package com.cnlaunch.downloadbin;

import java.io.File;
import java.io.IOException;

import android.content.Context;
import android.content.SharedPreferences;
import android.os.Environment;
import android.os.Handler;
import android.util.Log;



public class DownLoadThread implements Runnable {
	private String logInfo = "升级Download模块_DownLoadBinThread_";
	public final static String DOWNLOADBIN_PATH = Environment.getExternalStorageDirectory() + "/cnlaunch/newestDownload/iDiag/";
	private static Context mContext;
	private String sn;
	private static String version;
	private Handler mHandler;
	
	public DownLoadThread(Context context, Handler handler,String sn){
		mContext = context;
		this.sn = sn;
		mHandler = handler;
		SharedPreferences downloadInfoPreferences = context.getSharedPreferences("downloadInfo", Context.MODE_PRIVATE);
		version = downloadInfoPreferences.getString(sn, "V0.01");
		Log.e("golo", logInfo+"DownLoadThread: "+"version = " + version);
	}

	@Override
	public void run() {
		try{
			if (version != null && LibTools.isNetworkConnected(mContext)){
				String path1 = 	DownLoadThread.DOWNLOADBIN_PATH;			
				File file1 = new File(path1);
				if(!file1.exists()){
					file1.mkdirs();
				}
				
				int i = 0;
				File[] files = file1.listFiles();
				for (i = 0; i < files.length; i++){
					if (files[i].getName().equals("DOWNLOAD.BIN")){
						path1 = files[i].getAbsolutePath();
						break;
					}
				}
				//找到DOWNLOAD.BIN文件
				if ((i < files.length) && (path1 != null)){
					SharedPreferences downloadInfoPreferences = mContext.getSharedPreferences("downloadInfo", Context.MODE_PRIVATE);
					int totalLen = downloadInfoPreferences.getInt("totalLen", 0);
					file1 = new File(path1);
					if (!downloadInfoPreferences.getBoolean("downloadBINFlag", false) || totalLen != file1.length()) {			
						Log.e("golo", logInfo+"run: "+"下载好的DOWNLOAD.BIN文件有问题，删除，重新下载");
						file1.delete();
						DownloadApk.putdSharedPreferencesData(mContext, 0, null, null, false);
					}
					querySoftVersionInfo();
				} else { //没有找到DOWNLOAD.BIN文件
					Log.e("golo", logInfo+"run: "+"未找到DOWNLOAD.BIN文件");
					querySoftVersionInfo();
				}
			} else {
				Log.e("golo", logInfo+"run: "+"DownLoadBinThread 网络状态：false");
				mHandler.sendEmptyMessage(-1);
			}
		} catch (Exception e){
			Log.e("golo", logInfo+"run: "+"【下载 download.bin】异常:", e);
			mHandler.sendEmptyMessage(-2);
		}
	}
	
	private void querySoftVersionInfo() {
		try {
			Log.e("golo", logInfo+"downloadDownloadBin: "+"查询DownLoadBin版本");
			DownloadApk.querySoftVersionInfo("download",mContext,sn,mHandler);
		} catch (IOException e) {
			mHandler.sendEmptyMessage(-2);
		}
	}
	/**
	 * 判断DownloadBin是否需要升级
	 * @param responseInfo
	 * @param downloadBinName
	 * @return
	 */
	public static boolean isDownloadBinNeedUpdate(ResponseInfos responseInfo,String downloadBinName) {		
		int downloadBinVersion = (int)(Float.parseFloat(version.substring(1))*100);//当前版本
		int responseVersionCode = 0;
		if (downloadBinName.equals("DOWNLOAD.BIN")) {
			responseVersionCode = (int)(Float.parseFloat(responseInfo.downloadBinVersion)*100);
			if (!responseInfo.downloadBinName.equals(version.substring(1)) && downloadBinVersion < responseVersionCode) {
				SharedPreferences downloadInfoPreferences = mContext.getSharedPreferences("downloadInfo", Context.MODE_PRIVATE);
				downloadInfoPreferences.edit().putString("downloadVersion", "V" + responseInfo.downloadBinVersion).commit();
				return true;
			}
		} 	
		return false;
	}
}
