package com.cnlaunch.downloadbin;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.security.MessageDigest;
import java.util.ArrayList;
import java.util.List;

import android.content.Context;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.util.Log;

import com.cnlaunch.golo.logger.GoloLog;

public class LibTools {
	
	public static boolean execShell_SANMU(String command) {
		Process process = null;
		OutputStreamWriter out = null;
		Log.i("rcuguardservice", "command=" + command);
		try {
			process = Runtime.getRuntime().exec(command);
			out = new OutputStreamWriter(process.getOutputStream());
			if (out != null) {
				out.write(command);
				out.write("\n");
				out.write("exit\n");
				out.flush();
				out.close();
			}
			int i = process.waitFor();
			GoloLog.d("process.waitFor()返回值：" + i);
			if ( i== 0) {
				return true;
			} else {
				return false;
			}
		} catch (Exception e) {
			GoloLog.e("安装异常", e);
			e.printStackTrace();
			return false;
		}
	}

	public static boolean isNetworkConnected(Context context) {
		if (context != null) {
			ConnectivityManager mConnectivityManager = (ConnectivityManager) context.getSystemService(Context.CONNECTIVITY_SERVICE);
			NetworkInfo mNetworkInfo = mConnectivityManager.getActiveNetworkInfo();
			if (mNetworkInfo != null && mNetworkInfo.isConnectedOrConnecting()) {
				return mNetworkInfo.isAvailable();
			}
		}
		return false;
	}

	
	public static String getFileMD5String(String filePath) {
		String MD5 = null;
		File file = new File(filePath);
		FileInputStream fileInputStream = null;
		try {
			fileInputStream = new FileInputStream(file);
		} catch (FileNotFoundException e) {
			GoloLog.e("getFileMD5String异常", e);
			e.printStackTrace();
		}
		int readedLength = 0;
		int readedLengthTemp = 0;
		byte[] data = new byte[1024 * 4];
		List<byte[]> byteArrayList = new ArrayList<byte[]>();
		if (fileInputStream != null) {
			try {
				while ((readedLengthTemp = fileInputStream.read(data)) != -1) {
					byte[] temp = new byte[readedLengthTemp];
					System.arraycopy(data, 0, temp, 0, temp.length);
					byteArrayList.add(temp);
					readedLength += readedLengthTemp;
				}
				fileInputStream.close();
				MD5 = LibTools.getFileContentMD5Str(byteArrayList, readedLength);
			} catch (IOException e) {
				GoloLog.e("获取文件二进制流异常", e);
				MD5 = null;
			}		
		}	
		return MD5;
	}
	
	public static String getFileContentMD5Str(List<byte[]> byteArrayList, int len) {
		String str1 = "";
		byte[] tByteArray = new byte[len];
		int tmpLen = 0;

		if (byteArrayList != null && byteArrayList.size() > 0) {
			for (int i = 0; i < byteArrayList.size(); i++) {
				byte[] tempByte = byteArrayList.get(i);
				for (int j = 0; j < tempByte.length; j++) {
					System.arraycopy(tempByte, 0, tByteArray, tmpLen, tempByte.length);
				}
				tmpLen += tempByte.length;
			}
		}
		char hexDigits[] = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f' };
		try {
			MessageDigest mdTemp = MessageDigest.getInstance("MD5");
			mdTemp.update(tByteArray);
			byte[] md = mdTemp.digest();
			int j = md.length;
			char str[] = new char[j * 2];
			int k = 0;
			for (int i = 0; i < j; i++) {
				byte byte0 = md[i];
				str[k++] = hexDigits[byte0 >>> 4 & 0xf];
				str[k++] = hexDigits[byte0 & 0xf];
			}
			str1 = new String(str);
			return str1;
		} catch (Exception e) {
			GoloLog.e("异常", e);
			return null;
		}
	}

//	public static byte[] getFileContentMD5(List<byte[]> byteArrayList, int len)
//	{
//		String str1 = "";
//		byte[] tByteArray = new byte[len];
//		int tmpLen = 0;
//
//		if (byteArrayList != null && byteArrayList.size() > 0)
//		{
//			for (int i = 0; i < byteArrayList.size(); i++)
//			{
//				byte[] tempByte = byteArrayList.get(i);
//				for (int j = 0; j < tempByte.length; j++)
//				{
//					System.arraycopy(tempByte, 0, tByteArray, tmpLen, tempByte.length);
//				}
//				tmpLen += tempByte.length;
//			}
//		}
//		char hexDigits[] = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f' };
//		try
//		{
//			MessageDigest mdTemp = MessageDigest.getInstance("MD5");
//			mdTemp.update(tByteArray);
//			byte[] md = mdTemp.digest();
//			int j = md.length;
//			char str[] = new char[j * 2];
//			int k = 0;
//			for (int i = 0; i < j; i++)
//			{
//				byte byte0 = md[i];
//				str[k++] = hexDigits[byte0 >>> 4 & 0xf];
//				str[k++] = hexDigits[byte0 & 0xf];
//			}
//			str1 = new String(str);
//			int len2 = str1.length();
//			byte[] result = new byte[len2];
//			char[] hexChars = str1.toCharArray();
//			for (int i = 0; i < len2; i++)
//			{
//				result[i] = (byte) hexChars[i];
//			}
//			return result;
//		} catch (Exception e)
//		{
//			GoloLog.e("异常", e);
//			return null;
//		}
//	}

	
}
