package com.cnlaunch.downloadbin;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.cnlaunch.golo.logger.GoloLog;


/**
 * apk或download.bin版本信息的实体类
 * 
 */
public class ResponseInfos {
	
	private String logInfo = "Lib包升级模块_ResponseInfo_";
	
	//TODO 如果联创 这边需要 固件下载  下发 “下载地址” 可扩展
	int status = -1;
	public String message;
	//守护apk
	public String rcuApkName;
	public String rcuApkVersion;
	public String rcuApkUrl;    //根据实际情况 处理
	
	//主apk版本
	public String mainApkName;
	public String mainApkVersion;
	public String mainApkUrl;   //根据实际情况 处理
	
	//download.bin版本号
	public String downloadBinName;
	public String downloadBinVersion;
	public String downloadBinUrl;  //根据实际情况 处理


	
	public ResponseInfos(String jsonString) {
		JSONObject jsonObject = null;
		try {
			jsonObject = new JSONObject(jsonString);
		} catch (JSONException e) {
			GoloLog.e(logInfo+"ResponseInfo: "+"生成json对象失败", e);
			jsonObject = null;
		}
		if (jsonObject != null) {
			try {
				status = Integer.parseInt(jsonObject.getString("status"));
				message = jsonObject.getString("message");
				if (parseStatus(status, message)) {
					if (jsonObject.get("modulelist") != null) {
						JSONArray jsonArray = jsonObject.getJSONArray("modulelist");
						for (int i = 0; i < jsonArray.length(); i++) {
							JSONObject jsonObject2 = (JSONObject)jsonArray.get(i);
							String nameString = jsonObject2.getString("module_name");
							if (nameString.equals("DOWNLOAD.BIN")) {
								downloadBinName = nameString;
								downloadBinVersion = jsonObject2.getString("module_ver");
								downloadBinUrl = jsonObject2.getString("module_url");
							} else if (nameString.equals("golo_lc.apk")) {
								mainApkName = nameString;
								mainApkVersion = jsonObject2 .getString("module_ver");
								mainApkUrl= jsonObject2 .getString("module_url");
							} else if (nameString.equals("rcuGuardService.apk")) {
								rcuApkName = nameString;
								rcuApkVersion = jsonObject2.getString("module_ver");
								rcuApkUrl=jsonObject2.getString("module_url");
							}				
						}								
					}
				}
			} catch (JSONException e) {
				GoloLog.e(logInfo+"ResponseInfo: "+"解析json对象异常",e);
				jsonObject = null;
			}
		}
	}

	public String toString() {
		return ("ResponseInfo："+ 	"status："+status+"--message："+message
				+"--rcuApkName："+rcuApkVersion+"--rcuApkVersion："+rcuApkVersion
				+"--mainApkName："+mainApkName+"--mainApkName："+mainApkVersion
				+"--downloadBinName："+downloadBinName+"--downloadBinVersion："+downloadBinVersion);
	}
	
	public String getMainApkName() {
		return mainApkName;
	}

	public String getMainApkVersion() {
		return mainApkVersion;
	}

	public String getDownloadBinName() {
		return downloadBinName;
	}

	public String getDownloadBinVersion() {
		return downloadBinVersion;
	}

	public String getRcuApkName() {
		return rcuApkName;
	}

	public String getRcuApkVersion() {
		return rcuApkVersion;
	}
	
	public String getRcuApkUrl() {
		return rcuApkUrl;
	}

	public String getMainApkUrl() {
		return mainApkUrl;
	}

	public String getDownloadBinUrl() {
		return downloadBinUrl;
	}
	
	public boolean isResponseInfoValid() {
		if (status == 0 && message != null && rcuApkName != null && mainApkName != null && downloadBinName != null
				&& rcuApkVersion != null && mainApkVersion != null && downloadBinVersion != null 
				&& rcuApkUrl != null && mainApkUrl != null && downloadBinUrl != null){
			return true;
		}
		return false;
	}
	
	private boolean parseStatus(int status, String message) {
		if (status == 0) {
			return true;
		} else if (status == 900) {
			GoloLog.e(logInfo+"parseStatus: "+"服务器内部错误, message = " +message);
			return false;
		} else if (status == 102) {
			GoloLog.e(logInfo+"parseStatus: "+"参数有误, message = " +message);
			return false;
		} else if (status == 100) {
			GoloLog.e(logInfo+"parseStatus: "+"SN 校验失败, message = " +message);
			return false;
		}
		return false;
	}

}
