/*
 * FileName: BaseActivity.java
 * @Description: TODO(通用的标题栏处理) 
 * All rights Reserved, Designed By Golo  
 * Copyright:    Copyright(C) 2014-2020  
 * Company       Golo.  
 * @author:    jihu 
 * @version    V1.0    
 * Createdate: 2014年10月23日 上午10:38:33  
 *   
 * Modification  History:   
 * Date         Author        Version        Discription  
 *    
 * 2014年10月23日       wu.zh          1.0             1.0  
 * Why & What is modified: <修改原因描述>
 */

package com.cnlaunch.golo.inspection;

import android.app.Activity;
import android.content.Intent;
import android.content.res.ColorStateList;
import android.content.res.Configuration;
import android.content.res.Resources;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.text.TextUtils;
import android.util.TypedValue;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.ViewStub;
import android.view.Window;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.LinearLayout.LayoutParams;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.cnlaunch.golo.wifisettings2.R;
import com.cnlaunch.golo.tools.GoloActivityManager;

/**
 * @ClassName: BaseActivity
 * @Description:TODO(这里用一句话描述这个类的作用)
 * @author: jihu
 * @date: 2014年10月25日 下午12:25:25
 */

public class BaseActivity extends FragmentActivity implements OnClickListener {

	/** 标题 */
	protected TextView titleName;

	/** 车标题显示 */
	protected TextView carTitleName;

	/** 标题栏左边的布局 ,显示正在加载的布局,身驱的布局*/
	protected View title_left_layout, loadLayout, noDataLayout, bodyView;
	
	/** 标题栏的布局*/
	protected RelativeLayout title_layout;
	
	/** 底部菜单的布局*/
	private LinearLayout bottom_layout;
	
	/** 标题栏右边的布局, 身躯 */
	protected LinearLayout title_right_layout, title_middle_layout, layout_car;
	
	/** Framelayout,加载布局上一层的布局,即id = android.R.id.content */
	protected FrameLayout frameLayout;
	
	/** 加载布局的对象 */
	protected LayoutInflater inflater;

	/** 资源对象 */
	protected Resources resources;
	
	/** 上下文环境 */
	protected Activity context;
	/** 中间两个按钮 */
	private TextView centerleftbt, centerrightbt;
	private int resCenterLeftNor, resCenterLeftPres, resCenterRightNor, resCenterRightPres;
	private ColorStateList cs1;
	private ColorStateList cs2;

	public final int alert_id = 0x9999999;
//	private boolean isLeave = false;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		GoloActivityManager.create().addActivity(this);
		inflater = getLayoutInflater();
		resources = getResources();
		context = this;
//		isLeave = false;
		// 背景不设置任何元素
		getWindow().setBackgroundDrawable(null);
		// 没有标题
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		// 读取加载布局是的上一层布局控件,既是一个FrameLayout
		frameLayout = (FrameLayout) findViewById(android.R.id.content);
	}

	@Override
	protected void onSaveInstanceState(Bundle outState) {
		// TODO Auto-generated method stub
		// empty
	}

	/**
	 * 自定义处理标题头的初始化
	 * 
	 * @param titleViewId
	 *            标题栏布局
	 * @param bodyViewId
	 *            身驱布局
	 */
	protected void initAllView(int titleViewId, int bodyViewId) {
		initAllView(inflater.inflate(titleViewId, null), inflater.inflate(bodyViewId, null));
	}

	/**
	 * 自定义处理标题头的初始化
	 * 
	 * @param titleView
	 * @param bodyView
	 */
	protected void initAllView(View titleView, View bodyView) {
		FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams(LayoutParams.MATCH_PARENT,
				(int) resources.getDimension(R.dimen.dp_48));
		frameLayout.addView(titleView, layoutParams);
		this.bodyView = bodyView;
		FrameLayout.LayoutParams bodyLayoutParams = new FrameLayout.LayoutParams(
				android.widget.FrameLayout.LayoutParams.MATCH_PARENT, android.widget.FrameLayout.LayoutParams.MATCH_PARENT);
		bodyLayoutParams.setMargins(0, (int) resources.getDimension(R.dimen.dp_48), 0, 0);
		frameLayout.addView(bodyView, bodyLayoutParams);
	}

	protected void initView(int titleStringId, int bodyViewId, int... rightResId) {
		initView(getString(titleStringId), inflater.inflate(bodyViewId, null), rightResId);
	}

	protected void initView(int titleStringId, View bodyView, int... rightResId) {
		initView(getString(titleStringId), bodyView, rightResId);
	}

	protected void initView(String title, int bodyViewId, int... rightResId) {
		initView(title, inflater.inflate(bodyViewId, null), rightResId);
	}

	/**
	 * 
	 * @Title: initView
	 * @Description: TODO(初始化标题栏,并添加标题栏下面的布局)
	 * @param: title 标题文字
	 * @param: bodyView 加入标题栏下面的布局
	 * @param: rightResId 标题栏右边的操作集合,可以有多个或者一个,可以传文字也可以传图片
	 */
	protected void initView(String title, View bodyView, int... rightResId) {
		inflater.inflate(R.layout.activity_base, frameLayout, true);
		title_layout = (RelativeLayout) findViewById(R.id.title_layout);
		this.bodyView = bodyView;
		title_left_layout = findViewById(R.id.title_left_layout);
		layout_car=(LinearLayout) findViewById(R.id.layout_car);
		// 左边按钮的事件
		title_left_layout.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				leftClick();
			}
		});
		// 标题
		titleName = (TextView) findViewById(R.id.title_text);
		carTitleName = (TextView) findViewById(R.id.title_car);
		carTitleName.setOnClickListener(this);
		titleName.setText(TextUtils.isEmpty(title)?"":title);
		title_right_layout = (LinearLayout) findViewById(R.id.title_right_layout);
		// 中间布局
		title_middle_layout = (LinearLayout) findViewById(R.id.title_middle_layout);
		centerleftbt = (TextView) findViewById(R.id.left_center_title_btn);
		centerrightbt = (TextView) findViewById(R.id.right_cnter_title_btn);
		setCentertBtnVisible(false);
		// 右边的布局
		resetTitleRightMenu(rightResId);
		// 身躯布局
		if (bodyView != null) {
			// 添加身躯
			FrameLayout.LayoutParams bodyLayoutParams = new FrameLayout.LayoutParams(
					android.widget.FrameLayout.LayoutParams.MATCH_PARENT, android.widget.FrameLayout.LayoutParams.MATCH_PARENT);
//			bodyView.setBackgroundColor(resources.getColor(R.color.gray_bg_helper));
			bodyLayoutParams.setMargins(0, (int) resources.getDimension(R.dimen.dp_48), 0, 0);
			frameLayout.addView(bodyView, bodyLayoutParams);
		}
	}
	
	/**
	 * 
	 * @Title: setTitleBackgroundColor
	 * @Description: TODO(设置标题栏背景颜色)
	 * @param: @param colorResId
	 */
	public void setTitleBackgroundColor(int colorResId) {
		title_layout.setBackgroundColor(resources.getColor(colorResId));
	}

	/**
	 * 
	 * @Title: setTitleVisiable   
	 * @Description: TODO(设置标题栏是否可见)  
	 * @param: @param isVisiable      
	 */
	public void setTitleVisiable(boolean isVisiable) {
		if(isVisiable){
			title_layout.setVisibility(View.VISIBLE);
			FrameLayout.LayoutParams bodyLayoutParams = new FrameLayout.LayoutParams(
					android.widget.FrameLayout.LayoutParams.MATCH_PARENT, android.widget.FrameLayout.LayoutParams.MATCH_PARENT);
			bodyLayoutParams.setMargins(0, (int) resources.getDimension(R.dimen.dp_48), 0, 0);
			bodyView.setLayoutParams(bodyLayoutParams);
		}else{
			title_layout.setVisibility(View.GONE);
			FrameLayout.LayoutParams bodyLayoutParams = new FrameLayout.LayoutParams(
					android.widget.FrameLayout.LayoutParams.MATCH_PARENT, android.widget.FrameLayout.LayoutParams.MATCH_PARENT);
			bodyLayoutParams.setMargins(0, 0, 0, 0);
			bodyView.setLayoutParams(bodyLayoutParams);
		}
	}
	/**
	 * 
	 * @Title: setCentertBtnVisible
	 * @Description: TODO(设置中间按钮是否显示)
	 * @param: @param visible
	 */
	public void setCentertBtnVisible(boolean visible) {
		if (visible) {
			title_middle_layout.setVisibility(View.VISIBLE);
			centerBtnStyleChanged(true);
			centerleftbt.setOnClickListener(new OnClickListener() {

				@Override
				public void onClick(View v) {
					// TODO Auto-generated method stub
					middleBtnClick(0);
					centerBtnStyleChanged(true);
				}
			});
			centerrightbt.setOnClickListener(new OnClickListener() {

				@Override
				public void onClick(View v) {
					// TODO Auto-generated method stub
					middleBtnClick(1);
					centerBtnStyleChanged(false);
				}
			});
		} else {
			title_middle_layout.setVisibility(View.GONE);
		}
	}

	/**
	 * 初始化Title中间按钮样式
	 * 
	 * @param cleftnormal
	 *            传入左边按钮正常情况下的图片资源源id
	 * @param cleftpressed
	 *            传入左边按钮按下后的图片资源id
	 * @param crightnormal
	 *            传入右边按钮正常情况下的图片资源源id
	 * @param crightpressed
	 *            传入右边按钮按下后的图片资源id
	 * @param cleftstring
	 *            传入左边边按钮显示的字符串
	 * @param crightstring
	 *            传入右边边按钮显示的字符串
	 * @param csnor
	 *            传入正常字符串颜色
	 * @param cspres
	 *            传入按下btn后字符串颜色
	 */
	protected void initCenterBtnStyle(int cleftnormal, int cleftpressed, int crightnormal, int crightpressed, int cleftstring,
			int crightstring, int csnor, int cspres) {
		title_middle_layout.setGravity(Gravity.CENTER|Gravity.CENTER_VERTICAL);
		resCenterLeftNor = cleftnormal;
		resCenterLeftPres = cleftpressed;
		resCenterRightNor = crightnormal;
		resCenterRightPres = crightpressed;
		centerleftbt.setTextSize(16);
		centerleftbt.setText(cleftstring);
		centerrightbt.setTextSize(16);
		centerrightbt.setText(crightstring);
		cs1 = (ColorStateList) this.getResources().getColorStateList(csnor);
		cs2 = (ColorStateList) this.getResources().getColorStateList(cspres);
	}

	/**
	 * 中间按钮样式切换(初始化需要设置此项)
	 * @param isLeftSelect
	 * 判断初始化是左边按钮选中还是右边按钮选中
	 */
	protected void centerBtnStyleChanged(boolean isLeftSelect) {
		if (isLeftSelect) {
			centerleftbt.setBackgroundColor(resources.getColor(resCenterLeftPres));
			centerrightbt.setBackgroundColor(resources.getColor(resCenterRightNor));
			centerleftbt.setTextColor(cs2);
			centerrightbt.setTextColor(cs1);
		} else {
			centerleftbt.setBackgroundColor(resources.getColor(resCenterLeftNor));
			centerrightbt.setBackgroundColor(resources.getColor(resCenterRightPres));
			centerleftbt.setTextColor(cs1);
			centerrightbt.setTextColor(cs2);
		}
	}
	
	/**
	 * 
	 * @Title: resetTitleRightMenu
	 * @Description: TODO(重设标题栏右边的菜单,包含影藏操作)
	 * @param:
	 */
	public void resetTitleRightMenu(int... resID) {
		int size = resID==null?0:resID.length;
		boolean isAllStr = true;
		boolean isAllDra = true;
		for(int i=0; i<size; i++) {
			//判断它是不是图片资源
			if(resID[i]>=0x7f020000&&resID[i]<=0x7f02ffff){
				isAllStr = false;
			} else {
				isAllDra = false;
			}
		}
		if(isAllStr) {
			String[] res = new String[size];
			//全是文字
			for(int i=0; i<size; i++) {
				res[i] = getString(resID[i]);
			}
			resetTitleRightMenu(res);
		} else if(isAllDra) {
			//全是图片
			if (title_right_layout != null) {
				title_right_layout.removeAllViews();
			}
			title_right_layout.setVisibility(View.VISIBLE);
			int dp_10 = (int) resources.getDimension(R.dimen.dp_10);
			for (int i = 0; i < size; i++) {
				ImageView imageView = new ImageView(this);
				LinearLayout.LayoutParams layoutParams = new LinearLayout.LayoutParams(LayoutParams.WRAP_CONTENT,
						LayoutParams.MATCH_PARENT);
				imageView.setPadding(dp_10, 0, dp_10, 0);
				imageView.setImageResource(resID[i]);
				imageView.setBackgroundResource(R.drawable.title_color_select);
				title_right_layout.addView(imageView, layoutParams);
				imageView.setTag(i);
				imageView.setOnClickListener(new OnClickListener() {

					@Override
					public void onClick(View v) {
						rightClick((Integer) v.getTag());
					}
				});
			}
		} else {
			//又有文字又有图片
			if (title_right_layout != null) {
				title_right_layout.removeAllViews();
			}
			title_right_layout.setVisibility(View.VISIBLE);
			int dp_10 = (int) resources.getDimension(R.dimen.dp_10);
			for (int i = 0; i < size; i++) {
				LinearLayout.LayoutParams layoutParams = new LinearLayout.LayoutParams(LayoutParams.WRAP_CONTENT,
						LayoutParams.MATCH_PARENT);
				if(resID[i]>=0x7f020000&&resID[i]<=0x7f02ffff) {
					ImageView imageView = new ImageView(this);
					imageView.setPadding(dp_10, 0, dp_10, 0);
					imageView.setImageResource(resID[i]);
					imageView.setBackgroundResource(R.drawable.title_color_select);
					imageView.setTag(i);
					imageView.setOnClickListener(new OnClickListener() {

						@Override
						public void onClick(View v) {
							rightClick((Integer) v.getTag());
						}
					});
					title_right_layout.addView(imageView, layoutParams);
				} else {
					TextView textView = new TextView(this);
					textView.setGravity(Gravity.CENTER);
					textView.setPadding(dp_10, 0, dp_10, 0);
					textView.setTextSize(TypedValue.COMPLEX_UNIT_PX, resources.getDimensionPixelSize(R.dimen.sp_14));
					textView.setText(resID[i]);
					textView.setTextColor(resources.getColor(R.color.green_text_color));
					textView.setBackgroundResource(R.drawable.title_color_select);
					textView.setTag(i);
					textView.setOnClickListener(new OnClickListener() {

						@Override
						public void onClick(View v) {
							rightClick((Integer) v.getTag());
						}
					});
					title_right_layout.addView(textView, layoutParams);
				}
			}
		}
	}

	/**
	 * 设置菜单栏的消息提醒处理
	 * @param index 索引位置
	 * @param isShow 是否显示
	 */
	public void setRightMenuAlert(int index, boolean isShow){
		if(title_right_layout!=null&&title_right_layout.getChildCount()>0) {
			int dp_8 = (int)resources.getDimension(R.dimen.dp_8);
			View view = title_right_layout.findViewById(alert_id);
			if(view==null){
				LinearLayout.LayoutParams layoutParams = new LinearLayout.LayoutParams(dp_8, dp_8);
				layoutParams.gravity = Gravity.TOP;
				layoutParams.topMargin = (int)resources.getDimension(R.dimen.dp_10);
				layoutParams.leftMargin = (int)resources.getDimension(R.dimen._dp_10);
				view = new View(this);
				view.setId(alert_id);
				view.setBackgroundResource(R.drawable.unreadnumbtn1);
				title_right_layout.addView(view, index + 1, layoutParams);
			}
			view.setVisibility(isShow ? View.VISIBLE : View.GONE);
		}
	}
	
	public void resetTitleRightMenu(String[] res) {
		int size = res==null?0:res.length;
		if (title_right_layout != null) {
			title_right_layout.removeAllViews();
		}
		if (size > 0) {
			title_right_layout.setVisibility(View.VISIBLE);
			int dp_10 = (int) resources.getDimension(R.dimen.dp_10);
			for (int i = 0; i < size; i++) {
				TextView textView = new TextView(this);
				LinearLayout.LayoutParams layoutParams = new LinearLayout.LayoutParams(LayoutParams.WRAP_CONTENT,
						LayoutParams.MATCH_PARENT);
				textView.setGravity(Gravity.CENTER);
				textView.setTextSize(TypedValue.COMPLEX_UNIT_PX, resources.getDimensionPixelSize(R.dimen.sp_14));
				textView.setText(res[i]);
				textView.setTextColor(resources.getColor(R.color.green_text_color));
				textView.setBackgroundResource(R.drawable.title_color_select);
				textView.setPadding(dp_10, 0, dp_10, 0);
				title_right_layout.addView(textView, layoutParams);
				textView.setTag(i);
				textView.setOnClickListener(new OnClickListener() {

					@Override
					public void onClick(View v) {
						rightClick((Integer) v.getTag());
					}
				});
			}
		}
	}
	
	/**
	 * 
	 * @Title: resetTitleRightMenu
	 * @Description: TODO(重设标题栏右边的菜单,包含隐藏操作，设置按钮背景，设置按钮字体颜色)
	 * @param:
	 */
	public void resetTitleRightMenu(int backSrc, int textColor, String titleName) {
		if (title_right_layout != null) {
			title_right_layout.removeAllViews();
		}
		title_right_layout.setVisibility(View.VISIBLE);
		int dp_10 = (int) resources.getDimension(R.dimen.dp_10);
		TextView textView = new TextView(this);
		LinearLayout.LayoutParams layoutParams = new LinearLayout.LayoutParams(LayoutParams.WRAP_CONTENT,
				LayoutParams.WRAP_CONTENT);
		textView.setGravity(Gravity.CENTER|Gravity.CENTER_VERTICAL);
		textView.setTextSize(TypedValue.COMPLEX_UNIT_PX, resources.getDimensionPixelSize(R.dimen.sp_14));
		if(textColor!=-1){
			textView.setTextColor(resources.getColor(textColor));
		}
		if(backSrc==-1){
			textView.setBackgroundResource(R.drawable.title_color_select);
		}else{
			textView.setBackgroundResource(backSrc);
		}
		textView.setPadding(dp_10, 0, dp_10, 0);
		if(titleName!=null){
			textView.setText(titleName);
		}
		title_right_layout.setGravity(Gravity.CENTER_VERTICAL);
		title_right_layout.addView(textView, layoutParams);
		textView.setTag(0);
		textView.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				rightClick((Integer) v.getTag());
			}
		});
	}
	
	/**
	 * 添间整个布局
	 * @param viewId
	 */
	protected void initView(int viewId) {
		initView(inflater.inflate(viewId, null));
	}

	/**
	 * 
	 * @Title: initView
	 * @Description: TODO(不需要标题栏的布局,像登录这种界面,可别乱调用)
	 * @param: bodyView
	 */
	protected void initView(View bodyView) {
		// 添加身躯
		FrameLayout.LayoutParams bodyLayoutParams = new FrameLayout.LayoutParams(
				android.widget.FrameLayout.LayoutParams.MATCH_PARENT, android.widget.FrameLayout.LayoutParams.MATCH_PARENT);
		frameLayout.addView(bodyView, bodyLayoutParams);
		frameLayout.setBackgroundColor(resources.getColor(android.R.color.white));
	}

	/**
	 * 
	 * @Title: initView
	 * @Description: TODO(不需要标题栏的布局)
	 * @param: bodyView 布局的最外层的标检是merge
	 */
	protected void initMergetView(int layoutId) {
		inflater.inflate(layoutId, frameLayout, true);
		frameLayout.setBackgroundColor(resources.getColor(android.R.color.white));
	}

	/**
	 * 
	 * @Title: setLoadView
	 * @Description: TODO(显示和隐藏加载中的view)
	 * @param: @param isVisible
	 */
	public void setLoadViewVisibleOrGone(boolean isVisible,int... resID ) {
		if (loadLayout == null) {
			loadLayout = findViewById(R.id.progressbar_layout);
		} 
		if (isVisible&&resID.length>0) {
			TextView textView = (TextView)loadLayout.findViewById(R.id.load_tishi_text);
			textView.setText(resID[0]);
		}
		loadLayout.setVisibility(isVisible ? View.VISIBLE : View.GONE);
		bodyView.setVisibility(isVisible ? View.GONE : View.VISIBLE);
	}
	
	/**
	 * 显示没有数据的view
	 * noClickListener 没有数据提示操作的事件处理
	 * noDataTishiResId 没有数据的显示内容
	 * nodataClickResId 需要操作的字符
	 */
	public void showNodataView(View.OnClickListener noClickListener, int noDataTishiResId, int ...noDataClickResId) {
		if(noDataLayout==null) {
			ViewStub noDataViewStub = (ViewStub) findViewById(R.id.viewstub_nodata);
			noDataLayout = noDataViewStub.inflate();
		} else {
			noDataLayout.setVisibility(View.VISIBLE);
		}
		TextView noDataTishiTextView = (TextView)findViewById(R.id.no_data_tishi_text);
		if (null == noDataTishiTextView)
			return;
		noDataTishiTextView.setText(getString(noDataTishiResId));
		if(noDataClickResId!=null&&noDataClickResId.length>0) {
			TextView nodataClickText = (TextView)findViewById(R.id.no_data_click);
			nodataClickText.setText(getString(noDataClickResId[0]));
			nodataClickText.setOnClickListener(noClickListener);
		}else{
			TextView nodataClickText = (TextView)findViewById(R.id.no_data_click);
			nodataClickText.setText("");
		}
		if(bodyView!=null) {
			bodyView.setVisibility(View.GONE);
		}
	}
	
	/**
	 * 隐藏没有数据提示的界面
	 */
	protected void goneNoDataView() {
		if(noDataLayout!=null) {
			noDataLayout.setVisibility(View.GONE);
		}
		if(bodyView!=null) {
			bodyView.setVisibility(View.VISIBLE);
		}
	}

	/**
	 * @Title: addBottomMenuWithStr
	 * @Description: TODO(只带文字的底部菜单)
	 * @param: @param strArrayId
	 */
	protected void addBottomMenuWithStr(int strArrayId) {
		String[] array = resources.getStringArray(strArrayId);
		addBottomMenuWithStr(array);
	}
	
	protected void addBottomMenuWithStr(String[] strs) {
		if (strs == null || strs.length == 0)
			return;
		// 先创建一个底部菜单的部体布局
		if (bottom_layout == null) {
			bottom_layout = new LinearLayout(this);
			bottom_layout.setOrientation(LinearLayout.HORIZONTAL);
			bottom_layout.setBackgroundColor(resources.getColor(android.R.color.white));
			FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams(
					android.widget.FrameLayout.LayoutParams.MATCH_PARENT, (int) resources.getDimension(R.dimen.dp_40));
			layoutParams.gravity = Gravity.LEFT|Gravity.BOTTOM;
			frameLayout.addView(bottom_layout, layoutParams);
			//重新设置中间布局的大小
			FrameLayout.LayoutParams bodyViewLayoutParams = new FrameLayout.LayoutParams(android.widget.FrameLayout.LayoutParams.MATCH_PARENT, android.widget.FrameLayout.LayoutParams.MATCH_PARENT);
			bodyViewLayoutParams.gravity = Gravity.LEFT;
			bodyViewLayoutParams.setMargins(0, (int)resources.getDimension(R.dimen.dp_48), 0, (int)resources.getDimension(R.dimen.dp_40));
			bodyView.setLayoutParams(bodyViewLayoutParams);
		}
		int length = strs.length;
		for (int i = 0; i < length; i++) {
			TextView textView = new TextView(this);
			LinearLayout.LayoutParams textLayoutParams = new LinearLayout.LayoutParams(LayoutParams.MATCH_PARENT,
					LayoutParams.MATCH_PARENT);
			textLayoutParams.weight = 1.0f;
			textView.setText(strs[i]);
			textView.setBackgroundResource(R.drawable.title_color_select);
			textView.setGravity(Gravity.CENTER);
			textView.setTextSize(TypedValue.COMPLEX_UNIT_PX, resources.getDimensionPixelSize(R.dimen.sp_14));
			textView.setTextColor(resources.getColor(R.color.green_text_color));
			textView.setTag(i);
			textView.setOnClickListener(new View.OnClickListener() {

				@Override
				public void onClick(View v) {
					bottomClick((Integer) v.getTag());
				}
			});
			bottom_layout.addView(textView, textLayoutParams);
		}
	}
	
	/**
	 * 标题栏左边点击事件,默认是关闭当前的Activity
	 */
	protected void leftClick() {
		((InputMethodManager) getSystemService(INPUT_METHOD_SERVICE)).hideSoftInputFromWindow(getCurrentFocus().
				getWindowToken(),InputMethodManager.HIDE_NOT_ALWAYS);
		GoloActivityManager.create().finishActivity(this);
	}
	
	/**
	 * 
	 * @Title: rightClick
	 * @Description: TODO(标题栏右边菜单的点击事件)
	 * @param: index(索引,因为右边的菜单可能是一个或则多个所以传一个索引过来)
	 */
	protected void rightClick(int index) {}
	
	/**
	 * 
	 * @Title: middleBtnClick
	 * @Description: TODO(中间按钮点击事件)
	 * @param: @param index
	 */
	protected void middleBtnClick(int index) {}
	
	/**
	 * 底部菜单点击事件
	 * @param index
	 */
	protected void bottomClick(int index) {}
	
	@Override
	public void onClick(View v) {}
	
	/**
	 * @Title: showBottonMenuClick
	 * @Description: TODO(显示或者隐藏底部菜单)
	 * @param: visible
	 */
	protected void showBottonMenuClick(boolean visible) {
		if (bottom_layout != null) {
			bottom_layout.setVisibility(visible ? View.VISIBLE : View.GONE);
		}
	}

	/**
	 * 获取底部菜单index对应的TextView控件
	 * @param index
	 * @return
	 */
	protected TextView getIndexBottomMenu(int index) {
		if (bottom_layout != null) {
			int childCount = bottom_layout.getChildCount();
			if (index > 0 && index < childCount) {
				return (TextView) bottom_layout.getChildAt(index);
			}
			return null;
		}
		return null;
	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if (keyCode == KeyEvent.KEYCODE_BACK) {
			GoloActivityManager.create().finishActivity(this);
		}
		return super.onKeyDown(keyCode, event);
	}

	/**
	 * skip to @param(cls)，and call @param(aty's) finish() method
	 */
	public void skipActivity(Activity aty, Class<?> cls) {
		showActivity(aty, cls);
		GoloActivityManager.create().finishActivity(aty);
	}

	/**
	 * skip to @param(cls)，and call @param(aty's) finish() method
	 */
	public void skipActivity(Activity aty, Intent it) {
		showActivity(aty, it);
		GoloActivityManager.create().finishActivity(aty);
	}

	/**
	 * skip to @param(cls)，and call @param(aty's) finish() method
	 */
	public void skipActivity(Activity aty, Class<?> cls, Bundle extras) {
		showActivity(aty, cls, extras);
		GoloActivityManager.create().finishActivity(aty);
	}

	/**
	 * show to @param(cls)，but can't finish activity
	 */
	public void showActivity(Activity aty, Class<?> cls) {
		Intent intent = new Intent();
		intent.setClass(aty, cls);
		aty.startActivity(intent);
	}

	/**
	 * show to @param(cls)，but can't finish activity
	 */
	public void showActivity(Activity aty, Intent it) {
		aty.startActivity(it);
	}

	/**
	 * show to @param(cls)，but can't finish activity
	 */
	public void showActivity(Activity aty, Class<?> cls, Bundle extras) {
		Intent intent = new Intent();
		intent.putExtras(extras);
		intent.setClass(aty, cls);
		aty.startActivity(intent);
	}

	/**
	 * show to @param(cls) (startActivityForResult)，but can't finish activity
	 */
	public void showActivityForResult(Activity aty, Class<?> cls, Bundle extras, int requestCode) {
		Intent intent = new Intent();
		intent.putExtras(extras);
		intent.setClass(aty, cls);
		aty.startActivityForResult(intent, requestCode);
	}

	/**
	 * show to @param(cls) (startActivityForResult)，but can't finish activity
	 */
	public void showActivityForResult(Activity aty, Class<?> cls, int requestCode) {
		Intent intent = new Intent();
		intent.setClass(aty, cls);
		aty.startActivityForResult(intent, requestCode);
	}

	/**
	 * 清楚view图片的处理
	 * @param view
	 */
	final public void clearDrawables(View view) {
		if (view.getBackground() != null)
			view.getBackground().setCallback(null);

		if (view instanceof ImageView) {
			ImageView imageView = (ImageView) view;
			imageView.setImageBitmap(null);
		} else if (view instanceof ViewGroup) {
			ViewGroup viewGroup = (ViewGroup) view;
			for (int i = 0; i < viewGroup.getChildCount(); i++)
				clearDrawables(viewGroup.getChildAt(i));

			if (!(view instanceof AdapterView))
				viewGroup.removeAllViews();
		}
	}

	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
//		HttpMsgCenter.cancelRequests(context);
		clearDrawables(frameLayout);
	}

	@Override
	protected void onRestart() {
		super.onRestart();
//		Singlton.getInstance(MessageEventCodeManager.class).fireEvent(
//				MessageEventCodeManager.APP_REOPEN);
//		if (isLeave) {
//			//app 进入后台
//			Singlton.getInstance(MessageEventCodeManager.class).fireEvent(
//					MessageEventCodeManager.LOGIN_JUMP_TO_DRIVING_FRAGMENT);
//			//全局变量isActive = false 记录当前已经进入后台
//			isLeave = false;
//		}
	}

	@Override
	protected void onUserLeaveHint() {
		super.onUserLeaveHint();
//		if (!isLeave) {
//			isLeave = true;
//		}
	}

	@Override
	protected void onResume() {
		super.onResume();
//		if (isLeave) {
//			//app 进入后台
//			Singlton.getInstance(MessageEventCodeManager.class).fireEvent(
//					MessageEventCodeManager.LOGIN_JUMP_TO_DRIVING_FRAGMENT);
//			isLeave = false;
//			//全局变量isActive = false 记录当前已经进入后台
//		}
	}

	/**
	 * 
	 * <p>
	 * Title: setTitle
	 * </p>
	 * 设置title
	 * 
	 * @param title
	 * @see android.app.Activity#setTitle(int)
	 */
	public void setTitle(String title) {
		titleName.setText(title);
	}
	
	/*@Override
	public Resources getResources() {
		if(LcResources.instance == null) {
			Resources rs = super.getResources();
			LcResources.initResources(rs);
			LcResources.instance = new LcResources(this, rs.getAssets(), rs.getDisplayMetrics(), rs.getConfiguration());
		}
		return LcResources.instance;
	}*/

	/**
	 * APP字体大小，不随系统的字体大小变化而变化
	 * @return
	 */
	@Override
	public Resources getResources() {
		Resources res = super.getResources();
		Configuration config=new Configuration();
		config.setToDefaults();
		res.updateConfiguration(config,res.getDisplayMetrics() );
		return res;
	}

}