package com.cnlaunch.golo.inspection;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.EditText;
import android.widget.Toast;

import com.cnlaunch.golo.inspection.logic.RequestLogic;
import com.cnlaunch.golo.inspection.logic.RequestLogic.OnRequestFinishListener;
import com.cnlaunch.golo.inspection.model.CarCord;
import com.cnlaunch.golo.wifisettings2.R;
import com.lidroid.xutils.HttpUtils;

/**
 * @author: ljm
 * @类说明:	golo盒子激活界面
 * @version 1.0
 * @创建时间：2014-11-25 上午9:43:23
 *
 */
public class ConnectorActivateActivity extends BaseActivity implements OnRequestFinishListener {
	//接头序列号，密码
	private EditText snTxt,pwdTxt;
	private HttpUtils http;
	private Intent intent;
	private CarCord carcord;
	private RequestLogic logic;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		initView("激活接头", R.layout.activity_activate_connector);
		findViewById(R.id.activate_connector).setOnClickListener(onclick);
		snTxt=(EditText) findViewById(R.id.activate_sn);
		pwdTxt=(EditText) findViewById(R.id.activate_pwd);
		intent=getIntent();
		carcord=(CarCord) intent.getSerializableExtra("car");
		http=new HttpUtils();
		logic=RequestLogic.getInstance();
	}
	private OnClickListener onclick=new OnClickListener() {
		
		@Override
		public void onClick(View v) {
			if("".equals(snTxt.getText().toString().trim()) || "".equals(pwdTxt.getText().toString().trim())){
				Toast.makeText(ConnectorActivateActivity.this, "序列号和密码均不能为空！！", Toast.LENGTH_SHORT).show();
				return;
			}
			
			logic.activateConnector(snTxt.getText().toString().trim(), pwdTxt.getText().toString().trim(), carcord,ConnectorActivateActivity.this);
		}
	};
	
	

	@Override
	public void onFinish(int code, String tag, Object object) {
		if("activateConnector".equals(tag)){//返回激活结果
			switch (code) {
			case 0:
				Toast.makeText(ConnectorActivateActivity.this, "激活成功！！", Toast.LENGTH_SHORT).show();
				Intent i=new Intent(ConnectorActivateActivity.this,InspectionConfigActivity.class);
				i.putExtra("serial_no", snTxt.getText().toString().trim());
				startActivity(i);
				break;
			case 1:
				Toast.makeText(ConnectorActivateActivity.this, "激活失败！！", Toast.LENGTH_SHORT).show();
				break;
			case -2:
				Toast.makeText(ConnectorActivateActivity.this, "密码错误！！", Toast.LENGTH_SHORT).show();
				break;
			case -1:
				Toast.makeText(ConnectorActivateActivity.this, "接头已经存在！！", Toast.LENGTH_SHORT).show();
				break;
			default:
				break;
			}
		}
	}
	
}
