package com.cnlaunch.golo.inspection;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

import com.cnlaunch.golo.inspection.entrance.InspectionManager;
import com.cnlaunch.golo.inspection.interfaces.UnZipFileCallBack;
import com.cnlaunch.golo.inspection.logic.DownloadLogic;
import com.cnlaunch.golo.inspection.logic.RequestLogic;
import com.cnlaunch.golo.inspection.logic.RequestLogic.OnRequestFinishListener;
import com.cnlaunch.golo.inspection.main.UnZipFileUtils;
import com.cnlaunch.golo.inspection.model.ConfigBean;
import com.cnlaunch.golo.inspection.view.GoloProgressDialog;
import com.cnlaunch.golo.message.CmdCode;
import com.cnlaunch.golo.settings.SettingsCallBack;
import com.cnlaunch.golo.settings.goloWiFiBean;
import com.cnlaunch.golo.settings.goloWifiSettings;
import com.cnlaunch.golo.utils.StateCode;
import com.cnlaunch.golo.wifisettings2.R;
import com.lidroid.xutils.HttpUtils;

public class InspectionConfigActivity extends BaseActivity implements OnRequestFinishListener,SettingsCallBack {
	//结果展示txt
	private TextView resultTxt,unzipfile_result,check_wifi_result;
	private HttpUtils http;
	private String sn;
	private DownloadLogic logic;
	private RequestLogic requestlogic;
	private ConfigBean bean;
	//解压后的配置文件路径
	private String filePath;
	private Handler mHandler;
	//用于区分下载的是那种文件，车辆配置文件：config；EODB配置文件：odb_config
	private String flag="";
	private String snshare = "snshare";
	private goloWifiSettings wifiSettings;//golo盒子wifi设置管理类
	ProgressDialog proDialog = null;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		initView();
		initHandler();
		sn=getIntent().getStringExtra("serial_no");
		http=new HttpUtils();
		logic=DownloadLogic.getInstance();
		requestlogic=RequestLogic.getInstance();
		//获取配置参数
		requestlogic.getConfigParams(sn,this);
		GoloProgressDialog.showProgressDialog(InspectionConfigActivity.this, getString(R.string.string_loading));
	}

	private void initHandler() {
		mHandler = new Handler() {

			@Override
			public void handleMessage(Message msg) {
				// TODO Auto-generated method stub
				super.handleMessage(msg);
				flag=(String) msg.obj;
				switch (msg.arg1) {
				case 0://返回下载成功
					Toast.makeText(InspectionConfigActivity.this, "下载成功！！", Toast.LENGTH_LONG).show();
					break;
				case 1://返回下载失败
					Toast.makeText(InspectionConfigActivity.this, "下载失败！！", Toast.LENGTH_LONG).show();
					break;
				case 2://返回下载进程
					resultTxt.setText("下载进程："+msg.what+"%\n下载时请不要点击其他按钮");
					break;
				case 3://返回开始下载
					resultTxt.setText("正准备下载，下载时请不要点击其他按钮");
					break;
				case 4://返回解压配置文件成功
					unzipfile_result.setText("解压成功");
					boolean copy=UnZipFileUtils.copyFile(Environment.getExternalStorageDirectory() + 
							"/cnlaunch/golo3/"+sn+"/CN/CR_VII/VEHICLES/EUROFORD/V12.20/dpusys.ini", filePath+"/dpusys.ini");
					if(copy){
						Log.e("weige", "复制成功  ");
					}else{
						Log.e("weige", "复制失败  ");
					}
					break;
				case 5://返回解压配置文件失败
					unzipfile_result.setText("解压失败");
					break;
				default:
					break;
				}
			}

		};
	}

	private void initView() {
		initView("体检前配置", R.layout.activity_inspection_config);
		findViewById(R.id.getparameters).setOnClickListener(this);
		findViewById(R.id.download_configuration).setOnClickListener(this);
		findViewById(R.id.download_sys_ini).setOnClickListener(this);
		findViewById(R.id.unzipfile_btn).setOnClickListener(this);
		findViewById(R.id.check_wifi_btn).setOnClickListener(this);
		findViewById(R.id.inspection_btn).setOnClickListener(this);
		findViewById(R.id.getcar_button).setOnClickListener(this);
		findViewById(R.id.download_obd_sys_ini).setOnClickListener(this);
		//构造golo盒子wifi设置对象 参数为实现了处理wifi连接状态及连接成功后返回结果SettingsCallBack接口对象
		wifiSettings = new goloWifiSettings(this);

		resultTxt=(TextView) findViewById(R.id.request_result);
		unzipfile_result=(TextView) findViewById(R.id.unzipfile_result);
		check_wifi_result=(TextView) findViewById(R.id.check_wifi_result);

	}

	@Override
	public void onFinish(int code, String tag, Object object) {
		if("getConfigParams".equals(tag)){//返回配置文件下载所需要的参数
			GoloProgressDialog.dismissProgressDialog(InspectionConfigActivity.this);
			switch (code) {
			case 0:
				bean=(ConfigBean) object;
				Toast.makeText(InspectionConfigActivity.this, "初始化数据成功", Toast.LENGTH_SHORT).show();
				break;
			case 1:
				Toast.makeText(InspectionConfigActivity.this, "初始化数据失败", Toast.LENGTH_LONG).show();
				break;
			default:
				break;
			}
		}else if("downloadSysIni".equals(tag)){//返回DPUSYS.INI文件的内容
			switch (code) {
			case 0:
				Toast.makeText(InspectionConfigActivity.this, "获取sys.ini数据成功", Toast.LENGTH_SHORT).show();
				String result=(String) object;
				//保存内容到文件
				saveDpusysIni(result);
				break;
			case 1:
				Toast.makeText(InspectionConfigActivity.this, "获取sys.ini数据失败", Toast.LENGTH_SHORT).show();
				break;
			default:
				break;
			}
		}else if("getCarInfo".equals(tag)){//获取车数据
			switch (code) {
			case 0:
				String result=(String) object;
				AlertDialog show = new AlertDialog.Builder(this).setMessage(result).setNegativeButton("关闭",new DialogInterface.OnClickListener() {

					@Override
					public void onClick(DialogInterface dialog, int which) {
						// TODO Auto-generated method stub

					}
				}).show();
				break;
			case 1:

				break;
			default:
				break;
			}
		}
	}
	@Override
	public void onClick(View v) {
		super.onClick(v);
		//		if(bean==null){
		//			Toast.makeText(InspectionConfigActivity.this, "初始化数据失败", Toast.LENGTH_SHORT).show();
		//			return;
		//		}
		switch (v.getId()) {
		case R.id.getparameters://下载车辆配置文件
			if(bean==null){
				Toast.makeText(InspectionConfigActivity.this, "初始化数据失败", Toast.LENGTH_SHORT).show();
				return;
			}
			UnZipFileUtils.deleteFiles(Environment.getExternalStorageDirectory()+"/cnlaunch/golo3/"+sn+"/CN/ZIP/");
			logic.downloadConfigFile(bean.user_id, bean.configId, sn, bean.sign, mHandler);
			break;
		case R.id.download_configuration://下载EOBD配置
			if(bean==null){
				Toast.makeText(InspectionConfigActivity.this, "初始化数据失败", Toast.LENGTH_SHORT).show();
				return;
			}
			UnZipFileUtils.deleteFiles(Environment.getExternalStorageDirectory()+"/cnlaunch/golo3/"+sn+"/CN/ZIP/");
			logic.downloadEOBD(bean.user_id, bean.obd_config, sn, bean.obd_sign, mHandler);
			break;
		case R.id.download_sys_ini://下载sys.ini文件
			requestlogic.downloadSysIni(sn, "car_type",this);
			break;
		case R.id.unzipfile_btn://解压车辆配置文件并将sys.ini文件复制到相应文件夹
			unzipfile_result.setText("");
			UnZipFile();
			break;
		case R.id.check_wifi_btn://检查是否连接上正确的盒子WIFI
			showProDialog();
			check_wifi_result.setText("");
			wifiSettings.queryWiFiPassword(sn);
			break;

		case R.id.inspection_btn://开始体检
			File file = new File(Environment.getExternalStorageDirectory() + 
					"/cnlaunch/golo3/"+sn+"/CN/CR_VII/VEHICLES/EUROFORD/V12.20/"+"/dpusys.ini");
			if(!file.exists()){
				Toast.makeText(this, "请先下载体检所需的配置文件!", Toast.LENGTH_LONG).show();
				break;
			}
			if(filePath == null){
				SharedPreferences share = getSharedPreferences(snshare, MODE_PRIVATE);   
				filePath = share.getString(sn, null); 
			}

			if (InspectionManager.getInstance().isCanStartDiag() == true){//判断接头是否可以开始重新体检
				Intent intent=new Intent(this,InspectionStartActivity.class);
				intent.putExtra("serial_no", sn);
				intent.putExtra("filePath", filePath);
				startActivity(intent);
			}else{
				Toast.makeText(this, "正在结束上次体检，需要等待一段时间。。。。", Toast.LENGTH_LONG)  
				.show();
			}
			break;
		case R.id.getcar_button:
			requestlogic.getCarInfo(sn, this);
			break;
		case R.id.download_obd_sys_ini://下载obd的sys.ini文件
			requestlogic.downloadSysIni(sn,null, this);
			break;
		default:
			break;
		}
	}

	private void UnZipFile() {
		//删除之前解压的文件
		UnZipFileUtils.deleteFiles(Environment.getExternalStorageDirectory() + "/cnlaunch/golo3/"+sn+"CN/");
		UnZipFileUtils.unZipSingleFiles(Environment.getExternalStorageDirectory()+"/cnlaunch/golo3/"+sn+"/CN/ZIP/EUROFORD_V12_20_CN.ZIP",
				Environment.getExternalStorageDirectory() + "/cnlaunch/golo3/"+sn+"CN/", sn
				, new UnZipFileCallBack() {
			@Override
			public void onUnZipFileFinish(String zipFilePath, String targetPath) {
				filePath = targetPath;// /storage/sdcard0/cnlaunch/golo3/970190014344/CN/970190014344/CR_VII/VEHICLES/EUROFORD_/20.CN.ZIP
				Log.e("weige", "解压成功filePath：  " + filePath);
				Message msg=new Message();
				msg.arg1=4;
				mHandler.sendMessage(msg);
				SharedPreferences share = getSharedPreferences(snshare, MODE_PRIVATE);   
				SharedPreferences.Editor edit = share.edit(); 
				edit.putString(sn, filePath);        
				edit.commit();  
			}


			@Override
			public void onUnZipFileing() {
				// TODO Auto-generated method stub
				Log.e("weige", "正在解压。。。。  ");
			}


			@Override
			public void onUnZipFileFailed(Exception... e) {
				// TODO Auto-generated method stub
				Log.e("weige", "解压失败： 请检查是否已下载配置文件 ");
				Message msg1=new Message();
				msg1.arg1=5;
				mHandler.sendMessage(msg1);

				SharedPreferences share = getSharedPreferences(snshare, MODE_PRIVATE);
				share.edit().remove(sn).commit();
			}

		});
	}
	private  void saveDpusysIni(String iniFileContent) {
		File file = new File(Environment.getExternalStorageDirectory() + 
				"/cnlaunch/golo3/"+sn+"/CN/CR_VII/VEHICLES/EUROFORD/V12.20/");
		if (!file.exists()) {
			file.mkdirs();
		}

		FileWriter fwriter = null;
		try {
			String strFile = file.getAbsolutePath() + "/dpusys.ini";
			File file1 = new File(strFile);
			if (file1.exists()) {
				file1.delete();
			}
			file1.createNewFile();

			fwriter = new FileWriter(strFile);
			fwriter.write(iniFileContent);
		} catch (IOException ex) {
			ex.printStackTrace();
		} finally {
			try {
				fwriter.flush();
				fwriter.close();
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		}
	}

	@Override
	public void onSuccess(goloWiFiBean result) {
		// TODO Auto-generated method stub
		disProDialog();
		if (result != null ) {
			switch (result.getCmdCode()) {
			case CmdCode.CMD_QUERY_WIFI_PASSWORD://查询WiFI密码
				check_wifi_result.setText("盒子wifi连接正确");
				//disProDialog();
				break;
			case CmdCode.CMD_SERIALNUM_IS_WRONG://传入的序列号和接头序列号不一致
				Toast.makeText(this,"传入的序列号和接头序列号不一致", Toast.LENGTH_SHORT).show();
				check_wifi_result.setText("盒子wifi连接错误");
				break;
			default:
				break;
			}
		}
	}

	@Override
	public void onConnectStatus(int statusCode, String msg) {
		// TODO Auto-generated method stub
		
		if (statusCode == StateCode.SOCKET_CONNECT_FIAL ) {//连接golo盒子失败，请连接golo盒子wifi
			disProDialog();
			check_wifi_result.setText("盒子wifi连接错误");
			showConnectgoloDialog();
		}
		if( statusCode == StateCode.SOCKET_READ_DATA_FIAL){
			check_wifi_result.setText("盒子wifi连接错误，请确认连接了正确的盒子！！");
			disProDialog();
		}
		System.out.println(".............网络连接状态：statusCode="+statusCode+"...."+msg);
	}

	private void showConnectgoloDialog(){
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setTitle("golo盒子");
		builder.setMessage("请连接golo盒子的wifi");
		builder.setPositiveButton("确定", new OnClickListener() {

			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub
				Intent intent = new Intent(
						android.provider.Settings.ACTION_WIFI_SETTINGS);
				InspectionConfigActivity.this.startActivity(intent);

			}
		});
		builder.setNegativeButton("取消", new OnClickListener() {

			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub

			}
		});
		builder.create();
		builder.show();
	}
	
	private void showProDialog(){
		if (proDialog != null && proDialog.isShowing()) {
			proDialog.dismiss();
		}
		proDialog = new ProgressDialog(this);
		proDialog.setMessage("正在玩命连接...");
		proDialog.show();
	}
	
	private void disProDialog(){
		if (proDialog != null && proDialog.isShowing()) {
			proDialog.dismiss();
		}
	}

	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
		//关闭局域网通信及释放内存
		if (wifiSettings != null) {
			wifiSettings.destroy();
		}
	}

}
