package com.cnlaunch.golo.inspection;

import android.app.ProgressDialog;
import android.content.Context;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.cnlaunch.golo.inspection.entrance.InspectionManager;
import com.cnlaunch.golo.inspection.interfaces.DiagCallBack;
import com.cnlaunch.golo.logger.GoloLog;
import com.cnlaunch.golo.wifisettings2.R;

public class InspectionStartActivity extends BaseActivity implements OnClickListener {

	private ProgressDialog progressDialog = null;
	//解压后的配置文件路径
	private String filePath = "";
	private Context context;
	private String sn;
	private TextView inspection_result,inspection_over,inspection_progress;
	private EditText alltypEditText;
	private static boolean  isDiagOver = false;
	Handler mHandler = new Handler() {

		@Override
		public void handleMessage(Message msg) {
			// TODO Auto-generated method stub
			super.handleMessage(msg);
			switch (msg.what) {
			case 0:
				inspection_progress.setText("体检进度："+msg.obj.toString());
				break;
			case 1:
				break;
			case 2:

				isDiagOver = true;
				inspection_result.setText(msg.obj.toString());
				inspection_over.setText("接头正在结束体检中。。。\n结束体检需要较长时间来处理，如需开始第二次体检需要等待1分钟左右的时间");
				break;
			default:
				break;
			}
		}

	};

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		context = this;
		sn=getIntent().getStringExtra("serial_no");
		filePath=getIntent().getStringExtra("filePath");
		initViews();
//		registerReceiver();
	}


	private void initViews() {
		initView("体检界面", R.layout.activity_inspection_start);
		findViewById(R.id.inspection_start).setOnClickListener(this);
		findViewById(R.id.inspection_all_start).setOnClickListener(this);
		findViewById(R.id.inspection_interrup).setOnClickListener(this);
		findViewById(R.id.inspection_onekey_clear).setOnClickListener(this);
		inspection_result=(TextView) findViewById(R.id.inspection_result);
		inspection_over=(TextView) findViewById(R.id.inspection_over);
		inspection_progress=(TextView) findViewById(R.id.inspection_progress);
		alltypEditText=(EditText) findViewById(R.id.inspection_alltype);

	}
	
	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
		if (progressDialog != null) {
			progressDialog.dismiss();
		}
		InspectionManager.getInstance().diagCancel();
		InspectionManager.getInstance().unregister();
//		onDestroyActivity();
	}
	/** 
	 * @author lianyuhua 
	 * 功能描述：  释放资源，耗时
	 */ 
	private void onDestroyActivity(){
			new Thread(){
				@Override
				public void run() {
					//用户没有取消体检并且体检已经开始时需调用取消体检方法
//					if (DiagEnter.getInstance().getUserCancel() == false && DiagEnter.getInstance().getStopTag()==true ) {
						GoloLog.d("onDestroy  取消诊断");
//						DiagEnter.getInstance().diagCancel();
						try {
							sleep(2*1000);
						} catch (Exception e) {
							// TODO: handle exception
						}
						InspectionManager.getInstance().unregister();
						
//					}
				}	
			}.start();
		}
	private DiagCallBack callback = new DiagCallBack() {

		@Override
		public void diagSuccess(int mode, String json) {
			// TODO Auto-generated method stub
			Log.e("weige", "callBack====diagSuccess(): " + json);
			Message message = new Message();
			message.what = 2;
			message.obj = json;
			mHandler.sendMessage(message);
		}

		public void diagProgress(int progress, String title, String content, int index) {
			// TODO Auto-generated method stub
			Log.e("weige", "callBack====diagProgress(): " + progress + " ,title: " + title + " ,content: " + content + " index: " + index);
			Message message = new Message();
			message.what = 0;
			message.obj = progress;
			mHandler.sendMessage(message);
		}

		@Override
		public void diagDialogDismiss() {
			// TODO Auto-generated method stub n
			Log.e("weige", "callBack====diagDialogDismiss()");
			mHandler.sendEmptyMessage(1);
		}

		@Override
		public void diagFailed(String msg, int error) {
			// TODO Auto-generated method stub
			Log.e("weige", "callBack====diagFailed(): " + msg + " ,error: " + error);
			Message message = new Message();
			message.what = 2;
			message.obj = msg;
			mHandler.sendMessage(message);
		}

		@Override
		public void diagDialogShow(String msg, int flag) {
			// TODO Auto-generated method stub
			Log.e("weige", "callBack====diagDialogShow(): " + msg);
			Message message = new Message();
			message.what = 0;
			message.obj = msg;
			mHandler.sendMessage(message);
		}

		@Override
		public void diagBackPressed() {
			// TODO Auto-generated method stub
			Log.e("weige", "callBack====diagBackPressed(): " + "keyBack pressed");
		}

	};

	@Override
	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.inspection_interrup:
			GoloLog.e("中断体检");
//			//用户没有取消体检并且体检已经开始时需调用取消体检方法
//			if (DiagEnter.getInstance().getUserCancel() == false && DiagEnter.getInstance().getStopTag()==true ) {
//				DiagEnter.getInstance().diagCancel();
//			}
//			//注意！！！！！！！！！ 取消体检需要退出体检界面
//			InspectionStartActivity.this.finish();
			
			InspectionManager.getInstance().diagCancel();
			InspectionStartActivity.this.finish();
			break;
		case R.id.inspection_start://快速体检
			if (InspectionManager.getInstance().isCanStartDiag() == false){
				Toast.makeText(this, "当前还不能进行体检，请等待上一次的退出完成。。。。", Toast.LENGTH_SHORT).show();
				return;
			}
//			DiagEnter.getInstance().startDiag(sn, filePath, callback, getApplicationContext(),DiagEnter.DIAG_MODE_FAST);
			InspectionManager.getInstance().startDiag(sn, filePath, callback, this, InspectionManager.DIAG_MODE_FAST,0);
			inspection_over.setText(" "); 
			inspection_progress.setText("");
			inspection_result.setText("");
			break;
		case R.id.inspection_onekey_clear://一键清码
			if (InspectionManager.getInstance().isCanStartDiag() == false){
				Toast.makeText(this, "当前还不能进行一键清码，请等待上一次的退出完成。。。。", Toast.LENGTH_SHORT).show();
				return;
			}
//			DiagEnter.getInstance().startDiag(sn, filePath, callback, getApplicationContext(),DiagEnter.DIAG_MODE_ONEKEY_CLEAR);
			InspectionManager.getInstance().startDiag(sn, filePath, callback, this,InspectionManager.DIAG_MODE_ONEKEY_CLEAR,0 );
			inspection_over.setText(" ");
			inspection_progress.setText("");
			inspection_result.setText("");
			break;
		case R.id.inspection_all_start://全车体检
			if (InspectionManager.getInstance().isCanStartDiag() == false){
				Toast.makeText(this, "当前还不能进行体检，请等待上一次的退出完成。。。。", Toast.LENGTH_SHORT).show();
				return;
			}
//			DiagEnter.getInstance().startDiag(sn, filePath, callback, getApplicationContext(),DiagEnter.DIAG_MODE_FAST);
//			int alltype=Integer.parseInt(alltypEditText.getText().toString());
			InspectionManager.getInstance().startDiag(sn, filePath, callback, this, InspectionManager.DIAG_ALL_INSPECTION,7);
			inspection_over.setText(" "); 
			inspection_progress.setText("");
			inspection_result.setText("");
			break;
		default:
			break;
		}
		
	}
	

	

	

}
