package com.cnlaunch.golo.inspection;

import android.annotation.SuppressLint;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.StrictMode;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.cnlaunch.downloadbin.DownLoadThread;
import com.cnlaunch.downloadbin.UpgradeDownloadBINReceiver;
import com.cnlaunch.golo.inspection.entrance.InspectionManager;
import com.cnlaunch.golo.inspection.logic.RequestLogic;
import com.cnlaunch.golo.inspection.logic.RequestLogic.OnRequestFinishListener;
import com.cnlaunch.golo.inspection.tools.SharePreferenceUtils;
import com.cnlaunch.golo.inspection.tools.StringUtils;
import com.cnlaunch.golo.inspection.view.GoloProgressDialog;
import com.cnlaunch.golo.inspection.view.NormalDialog;
import com.cnlaunch.golo.wifisettings.CarMonitoringActivity;
import com.cnlaunch.golo.wifisettings.WiFiSettingsActivity;
import com.cnlaunch.golo.wifisettings2.R;
import com.lidroid.xutils.HttpUtils;

public class LoginActivity extends Activity implements OnClickListener,NormalDialog.OnClickItemListen,
		OnRequestFinishListener {

	private EditText account, token;
	private HttpUtils httpUtils;
	private SharePreferenceUtils prefer;
	private RequestLogic logic;
	private NormalDialog dialog;
	private static Context context;
	private static String sn;
	private static Button updatedownloadbin;

	@SuppressLint("NewApi")
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (android.os.Build.VERSION.SDK_INT > 9) {  
            StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();  
            StrictMode.setThreadPolicy(policy);  
        } 
		setContentView(R.layout.activity_login);
		httpUtils = new HttpUtils();
		prefer = new SharePreferenceUtils(this);
		context = LoginActivity.this;
		account = (EditText) findViewById(R.id.account);
		logic = RequestLogic.getInstance();
		findViewById(R.id.login_btn).setOnClickListener(this);
		findViewById(R.id.login_btn_non).setOnClickListener(this);
//		findViewById(R.id.login_btn_register).setOnClickListener(this);
		findViewById(R.id.login_btn_carmonitoring).setOnClickListener(this);
		findViewById(R.id.login_btn_release).setOnClickListener(this);
		findViewById(R.id.login_btn_wifisetting).setOnClickListener(this);
		updatedownloadbin = (Button)findViewById(R.id.updatedownloadbin);
		updatedownloadbin.setOnClickListener(this);
	}

	@Override
	public void onClick(View v) {
		int id=v.getId();
		Intent intent;
		switch (id) {
//			case R.id.login_btn_register://注册
//				logic.login(this);
//				break;
			case R.id.login_btn_non://无接头进入体检
				intent= new Intent(LoginActivity.this,
						VehicleAddNewCarsActivity.class);
				LoginActivity.this.startActivity(intent);
				logic.login(this);
				break;
			case R.id.login_btn://有接头进入体检
				if (StringUtils.isEmpty(account.getText().toString())) {
					Toast.makeText(LoginActivity.this, "接头序列号不能为空",
							Toast.LENGTH_SHORT).show();
					return;
				}
				if (account.getText().toString().trim().length()!=12) {
					Toast.makeText(LoginActivity.this, "接头序列号必须为12位",
							Toast.LENGTH_SHORT).show();
					return;
				}
				intent = new Intent(LoginActivity.this,
						InspectionConfigActivity.class);
				intent.putExtra("serial_no", account.getText().toString());
				LoginActivity.this.startActivity(intent);
				break;
			case R.id.login_btn_carmonitoring://进入车辆监控
				if (StringUtils.isEmpty(account.getText().toString())) {
					Toast.makeText(LoginActivity.this, "接头序列号不能为空",
							Toast.LENGTH_SHORT).show();
					return;
				}else if(account.getText().toString().trim().length()!=12) {
					Toast.makeText(LoginActivity.this, "接头序列号必须为12位",
							Toast.LENGTH_SHORT).show();
					return;
				}
				else{
					intent = new Intent(LoginActivity.this,
							CarMonitoringActivity.class);
					intent.putExtra("serial_no", account.getText().toString());
					LoginActivity.this.startActivity(intent);
				}
				
				break;
			case R.id.login_btn_wifisetting://进入wifi管理
				if (StringUtils.isEmpty(account.getText().toString())) {
					Toast.makeText(LoginActivity.this, "接头序列号不能为空",
							Toast.LENGTH_SHORT).show();
					return;
				}else if(account.getText().toString().trim().length()!=12) {
					Toast.makeText(LoginActivity.this, "接头序列号必须为12位",
							Toast.LENGTH_SHORT).show();
					return;
				}
				else{
					intent = new Intent(LoginActivity.this,
							WiFiSettingsActivity.class);
					intent.putExtra("serial_no", account.getText().toString());
					LoginActivity.this.startActivity(intent);
				}
				break;
			case R.id.login_btn_release://解绑接头
				if (StringUtils.isEmpty(account.getText().toString())) {
					Toast.makeText(LoginActivity.this, "接头序列号不能为空",
							Toast.LENGTH_SHORT).show();
					return;
				}
				if(account.getText().toString().trim().length()!=12) {
					Toast.makeText(LoginActivity.this, "接头序列号必须为12位",
							Toast.LENGTH_SHORT).show();
					return;
				}
				dialog=new NormalDialog(this, "提示", "是否确定解绑接头?", "取消","确定");
				dialog.setClickItemListen(this);
				dialog.show();
				break;
			case R.id.updatedownloadbin://升级downloadBin
				if (StringUtils.isEmpty(account.getText().toString())) {
					Toast.makeText(LoginActivity.this, "接头序列号不能为空",
							Toast.LENGTH_SHORT).show();
					return;
				}else if(account.getText().toString().trim().length()!=12) {
					Toast.makeText(LoginActivity.this, "接头序列号必须为12位",
							Toast.LENGTH_SHORT).show();
					return;
				}else{
					sn = account.getText().toString().trim();
					GoloProgressDialog.showProgressDialog(this, R.string.string_loading);
					readDPUVersionInfo(context,sn);
				}
				break;
			default:
				break;
		}
	}

	@Override
	public void onFinish(int code, String tag, Object object) {
		if ("login".equals(tag)) {//返回注册结果
			switch (code) {
			case 0:
				Toast.makeText(this, "注册access_id和access_token成功", Toast.LENGTH_SHORT).show();
				
				break;
			case 1:
				Toast.makeText(this, "注册access_id和access_token失败", Toast.LENGTH_SHORT).show();
				break;

			default:
				break;
			}
		} else if ("releaseConnector".equals(tag)) {//返回解除绑定结果
			switch (code) {
			case 0:
				Toast.makeText(LoginActivity.this, "已经解绑", Toast.LENGTH_SHORT)
						.show();
				break;
			case 1:
				Toast.makeText(LoginActivity.this, "解绑失败", Toast.LENGTH_SHORT)
						.show();
				break;

			default:
				break;
			}

		}

	}

	@Override
	public void leftClick() {
		dialog.cancel();
	}

	@Override
	public void rightClick() {
		logic.releaseConnector(account.getText().toString(),LoginActivity.this);
		dialog.dismiss();
	}
	
	
	/**
	* @param context
	* @param serialNo
	* @return void    返回类型
	* @throws
	* @Title: uploadDownloadBIN
	* @说明:golo1使用蓝牙功能，升级golo1的downloadBIN
	*/
	public static void readDPUVersionInfo(Context context, String serialNo) {
		// 获取升级downloadBIN的进度(使用广播)
		String path = DownLoadThread.DOWNLOADBIN_PATH + "DOWNLOAD.BIN";											
		IntentFilter filter = new IntentFilter();
		filter.addAction(UpgradeDownloadBINReceiver.DOWNLOADBIN_UPGRADE_ERROR);
		filter.addAction(UpgradeDownloadBINReceiver.DOWNLOADBIN_DPU_VERSION);	
		UpgradeDownloadBINReceiver.isRegister = true;
		context.registerReceiver(new UpgradeDownloadBINReceiver(serialNo), filter);
		Log.e("golo", "注册升级downloadBIN的进度广播");
		InspectionManager.getInstance().readDPUVersionInfo(context,serialNo,path,0);
	}

	public static void updateDownLoadBin(Context context, String serialNo) {
		// 获取升级downloadBIN的进度(使用广播)
		String path = DownLoadThread.DOWNLOADBIN_PATH + "DOWNLOAD.BIN";											
		IntentFilter filter = new IntentFilter();
		filter.addAction(UpgradeDownloadBINReceiver.DOWNLOADBIN_UPGRADE_COMPLETE);
		filter.addAction(UpgradeDownloadBINReceiver.DOWNLOADBIN_UPGRADE_ERROR);
		filter.addAction(UpgradeDownloadBINReceiver.DOWNLOADBIN_UPGRADE_PROGRESS);
		filter.addAction(UpgradeDownloadBINReceiver.DOWNLOADBIN_DPU_VERSION);//在蓝牙列表界面取消会调用回调
		UpgradeDownloadBINReceiver.isRegister = true;
		context.registerReceiver(new UpgradeDownloadBINReceiver(serialNo), filter);
		Log.e("golo", "注册升级downloadBIN的进度广播");
		InspectionManager.getInstance().updateDownLoadBin(context,serialNo,path,1);
	}
	
	//下载downloadbin过程中产生的结果 (-2：抛出异常，-1:无网络，0：初始值 ，1：查询版本信息失败，2：最新版本 3：下载异常,4:下载DOWNLOAD.BIN成功,5:下载DOWNLOAD.BIN失败)
	public static Handler mHandler = new Handler(){
		@Override
		public void handleMessage(Message msg) {
			switch(msg.what){
				case -2:
					GoloProgressDialog.dismissProgressDialog(context);
					Toast.makeText(context, "抛出异常",Toast.LENGTH_SHORT).show();	
					break;
				case -1:
					GoloProgressDialog.dismissProgressDialog(context);
					Toast.makeText(context, "无网络",Toast.LENGTH_SHORT).show();	
					break;
				case 1:
					GoloProgressDialog.dismissProgressDialog(context);
					Toast.makeText(context, "查询版本信息失败",Toast.LENGTH_SHORT).show();	
					break;
				case 2:
					GoloProgressDialog.dismissProgressDialog(context);
					Toast.makeText(context, "downloadbin为最新版本",Toast.LENGTH_SHORT).show();
					updatedownloadbin.setText("已是最新版本");
					updatedownloadbin.setClickable(false);
					break;
				case 3:
					GoloProgressDialog.dismissProgressDialog(context);
					Toast.makeText(context, "下载异常",Toast.LENGTH_SHORT).show();	
					break;
				case 4:
					Toast.makeText(context, "下载DOWNLOAD.BIN成功",Toast.LENGTH_SHORT).show();	
					updateDownLoadBin(context,sn);
					break;
				case 5:
					GoloProgressDialog.dismissProgressDialog(context);
					Toast.makeText(context, "下载DOWNLOAD.BIN失败",Toast.LENGTH_SHORT).show();	
					break;
				default:
					break;
			}
		}
	};
}
