package com.cnlaunch.golo.inspection;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.cnlaunch.golo.message.CmdCode;
import com.cnlaunch.golo.settings.SettingsCallBack;
import com.cnlaunch.golo.settings.goloWiFiBean;
import com.cnlaunch.golo.settings.goloWifiSettings;
import com.cnlaunch.golo.utils.StateCode;
import com.cnlaunch.golo.wifisettings2.R;

public class QueryAndModifyWifiActivity extends Activity implements View.OnClickListener, SettingsCallBack
{
	private EditText et_wifi_password,et_wifi_name;
	private String wifi_password,wifi_name,wifi_password_sure,wifi_name_sure,test_serial_no;
	private Button btn_sure,btn_return;
	private goloWifiSettings wifiSettings;//golo盒子wifi设置管理类
	ProgressDialog proDialog = null;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_query_modify_wifi);
		Intent intent=getIntent();
		test_serial_no=intent.getStringExtra("test_serial_no");
		initViews();
	}

	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		wifiSettings.queryWiFiSSID(test_serial_no);
	}

	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
		wifiSettings.destroy();
	}
	public void initViews() {
		//构造golo盒子wifi设置对象 参数为实现了处理wifi连接状态及连接成功后返回结果SettingsCallBack接口对象
		wifiSettings = new goloWifiSettings(this);
		et_wifi_password=(EditText)findViewById(R.id.et_wifi_password);
		et_wifi_name=(EditText)findViewById(R.id.et_wifi_name);
		btn_sure=(Button) findViewById(R.id.btn_sure);
		btn_sure.setOnClickListener(this);
		btn_return=(Button) findViewById(R.id.btn_return);
		btn_return.setOnClickListener(this);
	}

	@Override
	public void onClick(View v) {
		int id=v.getId();
		Intent intent;
		switch (id) {
		case R.id.btn_sure:
			wifi_name_sure=et_wifi_name.getText().toString().trim();
			if (TextUtils.isEmpty(wifi_name_sure)) {
				Toast.makeText(this,"WIFI名称不能为空", Toast.LENGTH_SHORT).show();
				return;
			}
			wifi_password_sure=et_wifi_password.getText().toString().trim();
			if(wifi_password_sure.length()<8){
				Toast.makeText(this,"WIFI密码必须至少为8位", Toast.LENGTH_SHORT).show();
				return;
			}
			if(wifi_name_sure.equals(wifi_name)&&wifi_password_sure.equals(wifi_password)){
				Toast.makeText(this,"修改的WIFI名称和密码与当前一致，不需要重新连接", Toast.LENGTH_LONG).show();
			}else{
				wifiSettings.setWiFiSSIDAndPassword(test_serial_no, wifi_name_sure, wifi_password_sure);
			}
			break;
		case R.id.btn_return://返回
			finish();
			break;
		default:
			break;
		}
	}

	private void disProDialog(){
		if (proDialog != null && proDialog.isShowing()) {
			proDialog.dismiss();
		}
	}

	private void showConnectgoloDialog(){
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setTitle("golo盒子");
		builder.setMessage("请连接golo盒子的wifi");
		builder.setPositiveButton("确定", new OnClickListener() {

			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub
				Intent intent = new Intent(
						android.provider.Settings.ACTION_WIFI_SETTINGS);
				QueryAndModifyWifiActivity.this.startActivity(intent);

			}
		});
		builder.setNegativeButton("取消", new OnClickListener() {

			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub

			}
		});
		builder.create();
		builder.show();
	}

	/**
	 * wifi连接成功后回调的结果
	 */
	@Override
	public void onSuccess(goloWiFiBean result) {
		// TODO Auto-generated method stub

		if (result != null ) {
			switch (result.getCmdCode()) {
			case CmdCode.CMD_QUERY_WIFI_PASSWORD://查询WiFI密码
				wifi_password=result.getValue();
				et_wifi_password.setText(wifi_password);
				disProDialog();
				break;
			case CmdCode.CMD_QUERY_WIFI_SSID://查询WiFI名称
				wifi_name=result.getValue();
				et_wifi_name.setText(wifi_name);
				if(!TextUtils.isEmpty(wifi_name)){
					wifiSettings.queryWiFiPassword(test_serial_no);
				}
				break;
			case CmdCode.CMD_SET_WIFI_PASSWORD_AND_SSID://设置WiFi名称和密码
				if(result.getErrorCode()==StateCode.GOLOWIFI_SETTING_SUCC){
					wifi_name=wifi_name_sure;
					wifi_password=wifi_password_sure;
					Toast.makeText(this,"WIFI修改成功，请重新连接", Toast.LENGTH_SHORT).show();
					((InputMethodManager)getSystemService(INPUT_METHOD_SERVICE)).hideSoftInputFromWindow(getCurrentFocus().getWindowToken(),InputMethodManager.HIDE_NOT_ALWAYS);
				}else{
					Toast.makeText(this,"WIFI修改失败", Toast.LENGTH_SHORT).show();
				}
				break;
			case CmdCode.CMD_SERIALNUM_IS_WRONG://传入的序列号和接头序列号不一致
				Toast.makeText(this,"传入的序列号和接头序列号不一致", Toast.LENGTH_SHORT).show();
				break;
			default:
				break;
			}
		}
	}

	@Override
	public void onConnectStatus(int statusCode, String msg) {
		// TODO Auto-generated method stub
		disProDialog();
		if (statusCode == StateCode.SOCKET_CONNECT_FIAL) {//连接golo盒子失败，请连接golo盒子wifi
			showConnectgoloDialog();
		}
		System.out.println(".............网络连接状态：statusCode="+statusCode+"...."+msg);
	}
}


