package com.cnlaunch.golo.inspection;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.content.Intent;
import android.os.Bundle;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.RadioGroup.OnCheckedChangeListener;
import android.widget.Toast;

import com.cnlaunch.golo.message.CmdCode;
import com.cnlaunch.golo.settings.SettingsCallBack;
import com.cnlaunch.golo.settings.goloWiFiBean;
import com.cnlaunch.golo.settings.goloWifiSettings;
import com.cnlaunch.golo.utils.StateCode;
import com.cnlaunch.golo.wifisettings2.R;

public class QueryAndModifyWifiSleepTimeActivity extends Activity implements  
SettingsCallBack,OnCheckedChangeListener
{
	private String test_serial_no,wifi_sleep_time;
	private goloWifiSettings wifiSettings;//golo盒子wifi设置管理类
	ProgressDialog proDialog = null;
	private RadioButton btn_5,btn_15,btn_30,btn_45,btn_60;
	private RadioGroup radioGroup;
	private Boolean flag_first=true;//标记是否是第一次显示查询休眠时间

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_query_modify_wifi_sleep_time);
		Intent intent=getIntent();
		test_serial_no=intent.getStringExtra("test_serial_no");
		initViews();
	}

	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		wifiSettings.queryWiFiSleepTime(test_serial_no);
	}

	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
		wifiSettings.destroy();
	}
	public void initViews() {
		//构造golo盒子wifi设置对象 参数为实现了处理wifi连接状态及连接成功后返回结果SettingsCallBack接口对象
		wifiSettings = new goloWifiSettings(this);
		btn_5=(RadioButton) findViewById(R.id.btn_5);
		btn_15=(RadioButton) findViewById(R.id.btn_15);
		btn_30=(RadioButton) findViewById(R.id.btn_30);
		btn_45=(RadioButton) findViewById(R.id.btn_45);
		btn_60=(RadioButton) findViewById(R.id.btn_60);

		radioGroup=(RadioGroup) findViewById(R.id.radioGroup);
		radioGroup.setOnCheckedChangeListener(this);
	}

	private void disProDialog(){
		if (proDialog != null && proDialog.isShowing()) {
			proDialog.dismiss();
		}
	}

	private void showConnectgoloDialog(){
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setTitle("golo盒子");
		builder.setMessage("请连接golo盒子的wifi");
		builder.setPositiveButton("确定", new OnClickListener() {

			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub
				Intent intent = new Intent(
						android.provider.Settings.ACTION_WIFI_SETTINGS);
				QueryAndModifyWifiSleepTimeActivity.this.startActivity(intent);

			}
		});
		builder.setNegativeButton("取消", new OnClickListener() {

			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub

			}
		});
		builder.create();
		builder.show();
	}

	/**
	 * wifi连接成功后回调的结果
	 */
	@Override
	public void onSuccess(goloWiFiBean result) {
		// TODO Auto-generated method stub

		if (result != null ) {
			switch (result.getCmdCode()) {
			case CmdCode.CMD_SET_WIFI_SlEEP_TIME://设置接头休眠时间	
				Toast.makeText(this,"设置成功", Toast.LENGTH_SHORT).show();
				break;
			case CmdCode.CMD_QUERY_WIFI_SLEEP_TIME://查询WiFi休眠时间
				wifi_sleep_time=result.getValue();
				switch (Integer.parseInt(wifi_sleep_time)) {
				case 5:
					Toast.makeText(this,"当前的休眠时间是：5分钟", Toast.LENGTH_SHORT).show();
					btn_5.setChecked(true);
					break;

				case 15:
					Toast.makeText(this,"当前的休眠时间是：15分钟", Toast.LENGTH_SHORT).show();
					btn_15.setChecked(true);
					break;

				case 30:
					Toast.makeText(this,"当前的休眠时间是：30分钟", Toast.LENGTH_SHORT).show();
					btn_30.setChecked(true);
					break;

				case 45:
					Toast.makeText(this,"当前的休眠时间是：45分钟", Toast.LENGTH_SHORT).show();
					btn_45.setChecked(true);
					break;

				case 60:
					Toast.makeText(this,"当前的休眠时间是：60分钟", Toast.LENGTH_SHORT).show();
					btn_60.setChecked(true);
					break;

				default:
					break;
				}
				flag_first=false;
				break;

			case CmdCode.CMD_SERIALNUM_IS_WRONG://传入的序列号和接头序列号不一致
				Toast.makeText(this,"传入的序列号和接头序列号不一致", Toast.LENGTH_SHORT).show();
				break;
			default:
				break;
			}
		}
	}

	@Override
	public void onConnectStatus(int statusCode, String msg) {
		// TODO Auto-generated method stub
		disProDialog();
		if (statusCode == StateCode.SOCKET_CONNECT_FIAL) {//连接golo盒子失败，请连接golo盒子wifi
			showConnectgoloDialog();
		}
		System.out.println(".............网络连接状态：statusCode="+statusCode+"...."+msg);
	}

	@Override
	public void onCheckedChanged(RadioGroup group, int checkedId) {
		// TODO Auto-generated method stub
		if(!flag_first){
			if (checkedId==btn_5.getId()) {
				wifiSettings.setWiFiSleepTime(test_serial_no, 5);
				Toast.makeText(this,"当前选择的休眠时间是：5分钟", Toast.LENGTH_SHORT).show();
			}else if(checkedId==btn_15.getId()){
				wifiSettings.setWiFiSleepTime(test_serial_no, 15);
				Toast.makeText(this,"当前选择的休眠时间是：15分钟", Toast.LENGTH_SHORT).show();
			}else if(checkedId==btn_30.getId()){
				wifiSettings.setWiFiSleepTime(test_serial_no, 30);
				Toast.makeText(this,"当前选择的休眠时间是：30分钟", Toast.LENGTH_SHORT).show();
			}else if(checkedId==btn_45.getId()){
				wifiSettings.setWiFiSleepTime(test_serial_no, 45);
				Toast.makeText(this,"当前选择的休眠时间是：45分钟", Toast.LENGTH_SHORT).show();
			}else if(checkedId==btn_60.getId()){
				wifiSettings.setWiFiSleepTime(test_serial_no, 60);
				Toast.makeText(this,"当前选择的休眠时间是：60分钟", Toast.LENGTH_SHORT).show();
			}
		}
	}
}

