/*
 * FileName: SlidingAroundableActivity.java
 * @Description: TODO(带菜单的可以继承它,目前是菜单栏为字符的标题,需要别的操作可以告诉，我会进行扩张.) 
 * All rights Reserved, Designed By Golo  
 * Copyright:    Copyright(C) 2014-2020  
 * Company       Golo.  
 * @author:    jihu 
 * @version    V1.0    
 * Createdate: 2014年10月24日 下午5:29:55  
 *   
 * Modification  History:   
 * Date         Author        Version        Discription  
 *    
 * 2014年09月20日      jihu          1.0             1.1  
 * Why & What is modified: <支持菜单带消息数量的提示 msgCountTextViews和handCurMenuMsgCountView方法>
 * 
 * 2014年10月24日      jihu          1.0             1.2  
 * Why & What is modified: <支持菜单重新设置及滑动view的设置resetSlidAroundView,有方法重载>
 */

package com.cnlaunch.golo.inspection;

import java.util.ArrayList;

import android.content.res.TypedArray;
import android.os.Bundle;
import android.support.v4.view.PagerAdapter;
import android.support.v4.view.ViewPager.OnPageChangeListener;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.LinearLayout.LayoutParams;

import com.cnlaunch.golo.inspection.listener.CustomOnPageChangeListener;
import com.cnlaunch.golo.inspection.view.PagerSlidingTabStrip;
import com.cnlaunch.golo.inspection.view.PagerSlidingTabStrip.MessageTagProvider;
import com.cnlaunch.golo.inspection.view.ViewPagerFixed;
import com.cnlaunch.golo.tools.GoloActivityManager;
import com.cnlaunch.golo.wifisettings2.R;

/**
 * 
 * @ClassName:  SlidingAroundableActivity
 * @Description:TODO extends FragmentActivity 适用于 ViewPager+View 和 ViewPager+Fragment
 * @author:    jihu
 * @date:   2014年10月25日 下午12:27:37
 */
public class SlidingAroundableActivity extends BaseActivity {
	
	/**滑动的viewpage*/
	protected ViewPagerFixed viewPager;
	/** 可滑动菜单的线性布局 */
	protected LinearLayout slidingLayout;
	private CustomOnPageChangeListener listener;
	protected PagerSlidingTabStrip pageTabs;
	private int currentIndex=0;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
	}
	public void setMessageCount(int position, int count) {
		if(pageTabs!=null)pageTabs.setMessageCount(position, count);
	}

	/**
	 * 自定义背景
	 * @param position
	 * @param count
	 * @param bgResId
	 */
	public void setMessageCount(int position,int count,int bgResId){
		if(pageTabs!=null)pageTabs.setMessageCount(position, count,bgResId);
	}
	
	/**
	 * 
	 * @Title: setMessageVisible   
	 * @Description: TODO  滑动TAB的提示点
	 * @param:  position 
	 * @param:  visible true显示，false隐藏     
	 */
	public void setMessageVisible(int position,boolean  visible){
		if(pageTabs!=null)pageTabs.setMessageVisible(position, visible);
	}
	
	
	/**
	 * 
	 * @Title: initSlidableView   
	 * @Description: TODO 定义一个 ViewPager+view (标题统一)
	 * @param:  titleId title资源
	 * @param:  arrayId 滑动菜单数组资源
	 * @param:  views  需要滑动的view
	 * @param:  rightRes 右侧菜单      
	 * @author liyao
	 */
	protected void initSlidableView(int titleId, int menusArrayId, ArrayList<View> views, int ...rightRes){
		if(views==null||views.size()<=0)com.cnlaunch.golo.tools.GoloActivityManager.create().finishActivity();
		initSlidableView(getString(titleId), resources.getStringArray(menusArrayId), views, rightRes);
	}
	
	/**
	 * 
	 * @Title: initSlidableView   
	 * @Description: TODO 定义一个 ViewPager+view (标题统一)
	 * @param:  titleId title
	 * @param:  arrayId 滑动菜单数组
	 * @param:  views  需要滑动的view
	 * @param:  rightRes 右侧菜单      
	 * @author liyao
	 */
	protected void initSlidableView(String titleStr, String[] menusArray, ArrayList<View> views, int ...rightRes){
		if(views==null||views.size()<=0||menusArray==null||menusArray.length<=0)GoloActivityManager.create().finishActivity();
		initSlidableMenu();
		initView(titleStr, slidingLayout, rightRes);
		PagerAdapter adapter = new MyPaperAdapter(views,menusArray);
		viewPager.setId(1);
		viewPager.setAdapter(adapter);
		pageTabs.setViewPager(viewPager);
		pageTabs.setOnPageChangeListener(new MyOnPageChangeListener());
	}
	
	
	/**
	 * @Title: initSlidableView   
	 * @Description: TODO 定义一个 ViewPager+view (自定义title)
	 * @param:  titleView
	 * @param:  menusArrayId
	 * @param:  views      
	 * @return: void     
	 */
	protected void initSlidableView(View titleView, int menusArrayId, ArrayList<View> views){
		TypedArray array = resources.obtainTypedArray(menusArrayId);
		if(array==null||array.length()<1||views==null||views.isEmpty()) GoloActivityManager.create().finishActivity();
		int menuSize = array.length();
		String[] menuStrText = new String[menuSize];
		for(int i=0;i<menuSize;i++) {
			menuStrText[i] = getString(array.getResourceId(i, 0));
		}
		initSlidableView(titleView, menuStrText, views);
	}
	
	
	/**
	 * @Title: initSlidableView   
	 * @Description: TODO 定义一个 ViewPager+view (自定义title)
	 * @param:  titleView 标题View
	 * @param:  menusArray  菜单数组
	 * @param:  views  View数组
	 */
	protected void initSlidableView(View titleView, String[] menusArray, ArrayList<View> views){
		if(menusArray==null||menusArray.length<=0||titleView==null) GoloActivityManager.create().finishActivity();
		initSlidableMenu();//创建滑动菜单
		LinearLayout linearLayout=new LinearLayout(context);
		linearLayout.setOrientation(LinearLayout.VERTICAL);
		LinearLayout.LayoutParams linearParm=new LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, (int) resources.getDimension(R.dimen.dp_48));
		linearLayout.addView(titleView,linearParm);//添加标题
		linearLayout.addView(slidingLayout);//添加内容
		initView(linearLayout);
		viewPager.setId(1);
		MyPaperAdapter adapter=new MyPaperAdapter(views, menusArray);
		viewPager.setId(1);
		viewPager.setAdapter(adapter);
		pageTabs.setViewPager(viewPager);
		pageTabs.setOnPageChangeListener(new MyOnPageChangeListener());
	}

	
	
	/**
	 * @Title: initSlidableFragment   
	 * @Description: TODO 定义一个 ViewPager+fragment(统一title)
	 * @param: titleId
	 * @param: menusArrayId
	 * @param: adapter 自定义的PagerAdapter
	 * @param: rightRes      
	 */
	protected void initSlidableFragment(int titleId, PagerAdapter adapter, int ...rightRes){
		if(adapter==null) GoloActivityManager.create().finishActivity();
		initSlidableFragment(getString(titleId),adapter, rightRes);
	}
	
	/**
	 * 
	 * @Title: initSlidableFragment   
	 * @Description: TODO 定义一个 ViewPager+fragment(统一title)
	 * @param:  title
	 * @param:  menusArray
	 * @param:  adapter 自定义的PagerAdapter
	 * @param:  rightRes      
	 */
	protected void initSlidableFragment(String title, PagerAdapter adapter, int ...rightRes){
		if(adapter==null) GoloActivityManager.create().finishActivity();
		initSlidableMenu();//创建滑动菜单
		initView(title, slidingLayout, rightRes);
		viewPager.setId(1);
		viewPager.setAdapter(adapter);
		pageTabs.setViewPager(viewPager);
		pageTabs.setOnPageChangeListener(new MyOnPageChangeListener());
	}
	
	
	/**
	 * 
	 * @Title: initSlidableFragment   
	 * @Description: TODO  定义一个 ViewPager+fragment(自定义title)
	 * @param:  titleView
	 * @param:  adapter      
	 */
	protected void initSlidableFragment(View titleView , PagerAdapter adapter){
		if(titleView==null) GoloActivityManager.create().finishActivity();
		initSlidableMenu(); 
		LinearLayout linearLayout=new LinearLayout(context);
		linearLayout.setBackgroundColor(resources.getColor(R.color.gray_bg_helper));
		linearLayout.setOrientation(LinearLayout.VERTICAL);
		LinearLayout.LayoutParams linearParm=new LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, (int)resources.getDimension(R.dimen.dp_48));
		linearLayout.addView(titleView,linearParm);
		linearLayout.addView(slidingLayout);
		initView(linearLayout);
		viewPager.setId(1);
		viewPager.setAdapter(adapter);
		pageTabs.setViewPager(viewPager);
		pageTabs.setOnPageChangeListener(new MyOnPageChangeListener());
	}
	
	/**
	 * 
	 * @Title: initSlidableMenu   
	 * @Description: TODO 创建 TAB菜单
	 * @param:       
	 */
	private void initSlidableMenu(){
		//菜单的横向线性布局
		pageTabs=new PagerSlidingTabStrip(context);
		LinearLayout.LayoutParams menuParams = new LinearLayout.LayoutParams(LayoutParams.MATCH_PARENT, (int) resources.getDimension(R.dimen.dp_40));
		pageTabs.setLayoutParams(menuParams);
		//创建ViewPage
		viewPager = new ViewPagerFixed(this);
		LinearLayout.LayoutParams viewPageParams = new LinearLayout.LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT);
		slidingLayout = new LinearLayout(this);
		slidingLayout.setOrientation(LinearLayout.VERTICAL);
		slidingLayout.addView(pageTabs, menuParams);
		slidingLayout.addView(viewPager, viewPageParams);
	} 
	
	
	/**
	 * 子类切换如果有需求的话就重写该方法，这里面已经做了切换和改变当前选中的颜色
	 * @param index 要切换的索引
	 * @return boolean 是否执行完成
	 */
	protected synchronized boolean setCurrentPoint(int index){
		if(pageTabs!=null){
			pageTabs.setCurrentPage(index);
			this.currentIndex=index;
			return true;
		}else{
			return false;
		}
	}
	
	/**
	 * @Title: getCurrentPoint   
	 * @Description: TODO 获取当前 tab的索引
	 * @return: int     
	 */
	public synchronized int getCurrentPoint(){
		return currentIndex;
	}
	
	
	/**
	 * @Title: getTabView   
	 * @Description: TODO 获取滑动菜单 对象
	 * @param: @return      
	 * @return: PagerSlidingTabStrip     
	 */
	protected PagerSlidingTabStrip getTabView(){
		return pageTabs;
	}
	

	/**
	 * @Title: getPagerView   
	 * @Description: TODO 获取ViewPager对象
	 * @param: @return      
	 * @return: PagerSlidingTabStrip     
	 */
	protected ViewPagerFixed getPagerView(){
		return viewPager;
	}
	
	
	/**
	 * @Title: notifyDataSetChanged   
	 * @Description: 更新Tabs
	 * @param:  adapter     
	 */
	protected void notifyDataSetChanged(PagerAdapter adapter){
		if(adapter==null)return;
		if(pageTabs!=null){
			viewPager.setAdapter(adapter);
			pageTabs.notifyDataSetChanged();
		}
	}
	
	
	/**
	 * 
	 * @Title: setTabVisible   
	 * @Description: TODO 是否隐藏 滑动TAB标签
	 * @param:  visible      
	 */
	protected void  setTabVisible(boolean visible){
		if(pageTabs!=null){
			pageTabs.setVisibility(visible?View.VISIBLE:View.GONE);
		}
	}
	
	
	
	/**
	 * @ClassName:     MyPaperAdapter
	 * @Description:TODO 通用的Viewpager+View 适配器. implements MessageTagProvider 提供 显示消息个数
	 * @author:    jihu
	 * @date:        2014年10月25日 下午12:32:44
	 */
	private class MyPaperAdapter extends PagerAdapter implements MessageTagProvider{
		
		private ArrayList<View> list;
		private String[] tiltes=null;
		public MyPaperAdapter(ArrayList<View> list,String[] titles) {
			this.list = list;
			this.tiltes=titles;
		}
		
		@Override
		public CharSequence getPageTitle(int position) {
			return tiltes[position];
		}
		
		@Override
		public int getCount() {
			return list==null?0:list.size();
		}
		
		@Override  
	    public void destroyItem(ViewGroup container, int position, Object object)   {
			if(position < list.size()) {
				container.removeView(list.get(position));//删除页卡  
			}
	    } 
		
		@Override
		public boolean isViewFromObject(View arg0, Object arg1) {
			return arg0==arg1;
		}
		
		@Override  
		public Object instantiateItem(ViewGroup container, int position) {  //这个方法用来实例化页卡
			if(list.get(position).getParent()==null){	
				container.addView(list.get(position), 0);	
			} 	
			return list.get(position);
		}
				
	}
	
	/**
	 * @ClassName:     MyOnPageChangeListener
	 * @Description:TODO(这里用一句话描述这个类的作用)
	 * @author:    jihu
	 * @date:        2014年10月25日 下午12:31:47
	 */
	private class MyOnPageChangeListener implements OnPageChangeListener {

		@Override
		public void onPageSelected(int index) {
			setCurrentPoint(index);
			if(listener!=null)listener.onPageSelected(index);
		}

		@Override
		public void onPageScrolled(int arg0, float arg1, int arg2) {
			if(listener!=null)listener.onPageScrolled(arg0, arg1, arg2);
				
		}

		@Override
		public void onPageScrollStateChanged(int arg0) {
			if(listener!=null)listener.onPageScrollStateChanged(arg0);
		}
		
	}
	
	/**
	 * 
	 * @Title: setOnPageChangeListener   
	 * @Description: TODO 设置滑动监听  
	 * @param: listener      
	 * @author: liyao
	 */
	protected void setOnPageChangeListener(CustomOnPageChangeListener listener){
		this.listener=listener;
	}

}