package com.cnlaunch.golo.inspection;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.regex.PatternSyntaxException;

import android.content.Context;
import android.content.Intent;
import android.content.res.TypedArray;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnKeyListener;
import android.view.WindowManager;
import android.view.WindowManager.LayoutParams;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.GridView;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.PopupWindow;
import android.widget.PopupWindow.OnDismissListener;
import android.widget.SimpleAdapter;
import android.widget.TextView;
import android.widget.Toast;

import com.cnlaunch.golo.inspection.adapter.AreaAdapter;
import com.cnlaunch.golo.inspection.adapter.VehicleModelAdapter;
import com.cnlaunch.golo.inspection.logic.RequestLogic;
import com.cnlaunch.golo.inspection.logic.RequestLogic.OnRequestFinishListener;
import com.cnlaunch.golo.inspection.model.CarCord;
import com.cnlaunch.golo.inspection.model.CarModel;
import com.cnlaunch.golo.inspection.model.CarPlatePrefix.PlatePrefix;
import com.cnlaunch.golo.inspection.tools.AllCapTransformationMethod;
import com.cnlaunch.golo.inspection.tools.ListViewUtils;
import com.cnlaunch.golo.inspection.view.ClearEditText;
import com.cnlaunch.golo.inspection.view.GoloProgressDialog;
import com.cnlaunch.golo.inspection.view.NormalDialog;
import com.cnlaunch.golo.tools.CommonUtils;
import com.cnlaunch.golo.wifisettings2.R;
import com.lidroid.xutils.HttpUtils;
/**   
 * FileName: VehicleAddNewCarsActivity.java   
 * @Description: (新增车辆) 
 * All rights Reserved, Designed By Golo  
 * Copyright:    Copyright(C) 2014-2020  
 * Company       Golo.  
 * @author:    liujiaqing 
 * @version    V1.0    
 * Createdate: 2014年11月24日 上午11:14:33  
 */
public class VehicleAddNewCarsActivity extends BaseActivity implements OnClickListener, OnItemClickListener, TextWatcher, OnRequestFinishListener {
	
	private Context mContext;
	//选择车牌前缀按钮、手动挡、自动挡
	private Button areaBtn;
	//车牌号输入框
	private ClearEditText plateEdtTxt;
	//选择车辆品牌、车型、年款
	private LinearLayout llVehicleBrand, llVehicleModel, llVehicleVinCode, llGearboxTypeSelector, llVehicleDisplacementUnit,layProducedYear;
	//车牌前缀集合
	private List<PlatePrefix> platePrefix = new ArrayList<PlatePrefix>();
	//车牌前缀适配器
	private AreaAdapter areaAdapter;
	//车辆品牌、车系编码id、车系编码、车辆子品牌id、车辆子品牌名称、车型、vin码、变速箱、排量、年款
	private String car_series_name,car_series_id,auto_code,car_sub_type_id,
			car_sub_type_name,platename = "",car_type_id,car_brand_vin,
			car_gearbox_type,car_displacement,car_producing_year;
	//车辆品牌、车型名字、VIN码
	private TextView txtVehicleBrand,txtVehicleModel,txtVehicleVINCode,txtGearboxHander,txtGearboxAuto, txtVehicleDisplacementUnit;
	//车辆数据
	private List<CarCord> carCordList = new ArrayList<CarCord>();
	//车辆品牌
	private static final int BRAND = 1;
	// Vin码请求code
	private static final int VIN_CODE = 2;
	//车辆档案业务逻辑类
//	private VehicleLogic vehicleLogic;
	// 新建的车
	private CarCord newCar;
	//车牌地区集合
	private String[] area;
//	private String[] area = { "京", "沪","浙", "苏", "粤", "鲁", "晋", "冀", "豫", "川",
//			"渝", "辽", "吉", "黑", "皖", "鄂", "湘", "赣", "闽", "陕", "甘", "宁", "蒙", 
//			"津", "贵", "云", "桂", "琼", "青", "新", "藏", "港", "奥", "台", "完成" };
	//车型适配器
//	private ModelAdapter modelAdapter;
	//排量、年款
	private EditText editVehicleDisplacement, editProducedYear,editSN,editActionCod;
	//车型数据集合
	private List<CarModel> carModels;
	private boolean brandHasNoModel;
	private VehicleModelAdapter adapter;
	private ListView lvVehicleModels;
	private ImageView imgVehicleModel, imgVehicleVinCode, imgVehicleDisplacementUnit;
	private PopupWindow pwVehicleDisplacementUnit;
//	private CarArchivesInterface archivesManager;
	
	private NormalDialog dialog;
	private int Flag = -1;//标志是否在创建车辆档案中
	private HttpUtils http;
	private RequestLogic logic;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		mContext = VehicleAddNewCarsActivity.this;    		
		initView(R.string.vehicle_info, R.layout.add_new_cars, R.drawable.titlebar_sure_icon);
		carCordList = new ArrayList<CarCord>();
		http=new HttpUtils();
		logic=RequestLogic.getInstance();
		init();
	}

	
	private void init(){
		TypedArray array = resources.obtainTypedArray(R.array.vehicle_prefix);
		int menuSize = array.length();
		area = new String[menuSize];
		for(int i=0;i<menuSize;i++) {
			area[i] = getString(array.getResourceId(i, 0));
		}
		
		areaBtn = (Button) findViewById(R.id.btn_area);
		areaBtn.setOnClickListener(this);
		areaBtn.setText(area[0]);
		plateEdtTxt = (ClearEditText) findViewById(R.id.car_plate_number);
		llVehicleBrand = (LinearLayout) findViewById(R.id.llVehicleBrand);
		llVehicleBrand.setOnClickListener(this);
		txtVehicleBrand = (TextView) findViewById(R.id.txtVehicleBrand);
		plateEdtTxt.setTransformationMethod(new AllCapTransformationMethod());
		plateEdtTxt.addTextChangedListener(this);
		llVehicleModel = (LinearLayout) findViewById(R.id.llVehicleModel);
		llVehicleModel.setOnClickListener(this);

		lvVehicleModels = (ListView) findViewById(R.id.lvVehicleModels);
		imgVehicleModel = (ImageView) findViewById(R.id.imgVehicleModel);
		carModels = new ArrayList<CarModel>();
		adapter = new VehicleModelAdapter(this, carModels);
		lvVehicleModels.setAdapter(adapter);
		lvVehicleModels.setOnItemClickListener(this);
		lvVehicleModels.setVisibility(View.GONE);
		
		txtVehicleModel = (TextView) findViewById(R.id.txtVehicleModel);
		llVehicleVinCode = (LinearLayout) findViewById(R.id.llVehicleVinCode);
		llVehicleVinCode.setOnClickListener(this);
		txtVehicleVINCode = (TextView) findViewById(R.id.txtVehicleVINCode);
		imgVehicleVinCode = (ImageView) findViewById(R.id.imgVehicleVinCode);
		llVehicleDisplacementUnit = (LinearLayout) findViewById(R.id.llVehicleDisplacementUnit);
		imgVehicleDisplacementUnit = (ImageView) findViewById(R.id.imgVehicleDisplacementUnit);
		txtGearboxHander = (TextView) findViewById(R.id.txtGearboxHander);
		txtGearboxHander.setOnClickListener(this);
		txtGearboxAuto = (TextView) findViewById(R.id.txtGearboxAuto);
		txtGearboxAuto.setOnClickListener(this);
		txtVehicleDisplacementUnit = (TextView) findViewById(R.id.txtVehicleDisplacementUnit);
		llVehicleDisplacementUnit.setOnClickListener(this);
		llGearboxTypeSelector = (LinearLayout) findViewById(R.id.llGearboxTypeSelector);
		editVehicleDisplacement = (EditText) findViewById(R.id.editVehicleDisplacement);
		editSN = (EditText) findViewById(R.id.editSN);
		editActionCod = (EditText) findViewById(R.id.editActionCod);
		layProducedYear = (LinearLayout) findViewById(R.id.layProducedYear);
		
		ListView lvDisplacementUnit = new ListView(this);
		String[] srcData = getResources().getStringArray(R.array.vehicle_displacement_units);
		List<Map<String, String>> data = new ArrayList<Map<String,String>>();
		for (String str : srcData) {
			Map<String, String> map = new HashMap<String, String>();
			map.put("srcData", str);
			data.add(map);
		}
		SimpleAdapter adapter = new SimpleAdapter(this, data, R.layout.list_simple_txt_white_bg, new String[]{"srcData"}, new int[]{R.id.txtContent});
		lvDisplacementUnit.setAdapter(adapter);
		lvDisplacementUnit.setOnItemClickListener(this);
		WindowManager wm = (WindowManager)this.getSystemService(Context.WINDOW_SERVICE);
		int width = wm.getDefaultDisplay().getWidth();
		lvDisplacementUnit.setFocusable(true);
		lvDisplacementUnit.setFocusableInTouchMode(true);
		pwVehicleDisplacementUnit = new PopupWindow(lvDisplacementUnit, width / 4, LayoutParams.WRAP_CONTENT);
		// 设置点击外边可消失
		pwVehicleDisplacementUnit.setBackgroundDrawable(new ColorDrawable(0x00000000));
		// 设置点击窗口外边窗口消失
		pwVehicleDisplacementUnit.setOutsideTouchable(true);
		// 设置此参数获得焦点，否则无法点击
		pwVehicleDisplacementUnit.setFocusable(true);
		pwVehicleDisplacementUnit.setOnDismissListener(new OnDismissListener() {
			@Override
			public void onDismiss() {
				imgVehicleDisplacementUnit.setImageResource(R.drawable.pull_down);
			}
		});
		lvDisplacementUnit.setOnKeyListener(new OnKeyListener() {
			@Override
			public boolean onKey(View v, int keyCode, KeyEvent event) {
				if (keyCode == KeyEvent.KEYCODE_BACK && pwVehicleDisplacementUnit.isShowing()) {
					imgVehicleDisplacementUnit.setImageResource(R.drawable.pull_down);
					pwVehicleDisplacementUnit.dismiss();
					return true;
				}
				return false;
			}
		});
		
		editProducedYear = (EditText) findViewById(R.id.editProducedYear);
		car_gearbox_type = "1";
		
		if(getCurrentFocus()!=null){
			((InputMethodManager) getSystemService(INPUT_METHOD_SERVICE)).hideSoftInputFromWindow(getCurrentFocus().
					getWindowToken(),InputMethodManager.HIDE_NOT_ALWAYS); 
		}
	}
	
	// 设置过滤字符函数(过滤掉我们不需要的字符)
	public static String stringFilter(String str) throws PatternSyntaxException{
	        String regEx = "[^a-zA-Z0-9]";//\u4E00-\u9FA5
	        Pattern p = Pattern.compile(regEx);
	        Matcher m = p.matcher(str);
	        return m.replaceAll("");
	}

	private int mMaxLenth = 7;
	private int cou = 0;
	private int selectionEnd = 0;
    private String androidVersion = android.os.Build.VERSION.RELEASE;
	
	
	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.btn_area://车牌前缀
			if(getCurrentFocus()!=null){
				((InputMethodManager) getSystemService(INPUT_METHOD_SERVICE)).hideSoftInputFromWindow(getCurrentFocus().
						getWindowToken(),InputMethodManager.HIDE_NOT_ALWAYS); 
			}
			showPopUp();
			break;
		case R.id.llVehicleBrand://品牌
			showActivityForResult(VehicleAddNewCarsActivity.this, VehicleCarBrandActivity.class, BRAND);
			lvVehicleModels.setVisibility(View.GONE);
			imgVehicleModel.setImageResource(R.drawable.open);
			break;
		case R.id.llVehicleModel://车型选择
			if (txtVehicleBrand.getText().toString().equals("")) {
				Toast.makeText(this, R.string.car_please_brand, Toast.LENGTH_LONG).show();
				return;
			}
			if (!brandHasNoModel) {
				if (carModels != null && !carModels.isEmpty()) {
						if (!lvVehicleModels.isShown()) {
							lvVehicleModels.setVisibility(View.VISIBLE);
							imgVehicleModel.setImageResource(R.drawable.close);
						} else {
							lvVehicleModels.setVisibility(View.GONE);
							imgVehicleModel.setImageResource(R.drawable.open);
						}
				} else {
					getVehicleModels();
					Toast.makeText(this, R.string.retry_soon, Toast.LENGTH_LONG).show();
				}
			}
			break;
		case R.id.llVehicleVinCode://VIN码
			Intent vinCode = new Intent(this, ModifyVehicleVinCodeActivity.class);
			vinCode.putExtra("vinCode", txtVehicleVINCode.getText().toString());
			startActivityForResult(vinCode, VIN_CODE);
			break;
		case R.id.txtGearboxHander://手动挡
			car_gearbox_type = "0";
			txtGearboxHander.setTextColor(getResources().getColor(R.color.white));
			txtGearboxAuto.setTextColor(getResources().getColor(R.color.gray_text_color));
			llGearboxTypeSelector.setBackgroundResource(R.drawable.bg_select_left);
			break;
		case R.id.txtGearboxAuto://自动挡
			car_gearbox_type = "1";
			txtGearboxAuto.setTextColor(getResources().getColor(R.color.white));
			txtGearboxHander.setTextColor(getResources().getColor(R.color.gray_text_color));
			llGearboxTypeSelector.setBackgroundResource(R.drawable.bg_select_right);
			break;
		case R.id.llVehicleDisplacementUnit:
			if(getCurrentFocus()!=null){
				((InputMethodManager) getSystemService(INPUT_METHOD_SERVICE)).hideSoftInputFromWindow(getCurrentFocus().
						getWindowToken(),InputMethodManager.HIDE_NOT_ALWAYS); 
			}
			if (!pwVehicleDisplacementUnit.isShowing()) {
				pwVehicleDisplacementUnit.showAsDropDown(editVehicleDisplacement);
				imgVehicleDisplacementUnit.setImageResource(R.drawable.pull_up);
			} else {
				pwVehicleDisplacementUnit.dismiss();
				imgVehicleDisplacementUnit.setImageResource(R.drawable.pull_down);
			}
			break;
		default:
			break;
		}
	}
	@Override
	public void onFinish(int code, String tag, Object object) {
		GoloProgressDialog.dismissProgressDialog(VehicleAddNewCarsActivity.this);
		if("getVehicleModels".equals(tag)){//返回获取车型结果
			switch (code) {
			case 0:
				List<CarModel> list=(List<CarModel>) object;
				if (list.isEmpty()) {
					brandHasNoModel = true;
				} else {
					for (CarModel carModel : list) {
						if (carModel.getCarType() != null && !carModel.getCarType().equals("")) {
							break;
						}
						brandHasNoModel = true;
					}
				}
				if (brandHasNoModel) {
					txtVehicleModel.setText(txtVehicleBrand.getText().toString());
					car_type_id = txtVehicleModel.getText().toString();
				} else {
					carModels.addAll(list);
					adapter.notifyDataSetChanged();
					ListViewUtils.setHeight(lvVehicleModels);
				}
				break;
			case 1:
				
				break;

			default:
				break;
			}
		}
		if("activateConnector".equals(tag)){//返回激活结果
			Flag = -1;
			switch (code) {
			case 0:
				Toast.makeText(VehicleAddNewCarsActivity.this, "激活成功！！", Toast.LENGTH_SHORT).show();
				Intent i=new Intent(VehicleAddNewCarsActivity.this,InspectionConfigActivity.class);
				i.putExtra("serial_no", newCar.getSerial_no());
				startActivity(i);
				break;
			case 1:
				Toast.makeText(VehicleAddNewCarsActivity.this, "激活失败！！", Toast.LENGTH_SHORT).show();
				break;
			case -2:
				Toast.makeText(VehicleAddNewCarsActivity.this, "密码错误！！", Toast.LENGTH_SHORT).show();
				break;
			case -1:
				Toast.makeText(VehicleAddNewCarsActivity.this, "接头已经存在！！", Toast.LENGTH_SHORT).show();
				break;
			case 1023:
				Toast.makeText(VehicleAddNewCarsActivity.this, "缺少参数！！", Toast.LENGTH_SHORT).show();
				break;
			default:
				break;
			}
		}
	}
	private void getVehicleModels() {
		GoloProgressDialog.showProgressDialog(this, R.string.string_loading);
		String detailId = null;
		if (!"".equals(car_sub_type_name.trim())) {
			detailId = car_sub_type_id;
		} else {
			detailId = car_series_id;
		}
		logic.getVehicleModels(detailId, this);
	}
	
	@Override
	protected void rightClick(int index) {
		super.rightClick(index);
		if(Flag==-1){
			if(getCurrentFocus()!=null){
				((InputMethodManager) getSystemService(INPUT_METHOD_SERVICE)).hideSoftInputFromWindow(getCurrentFocus().
						getWindowToken(),InputMethodManager.HIDE_NOT_ALWAYS); 
				}
				if(!CommonUtils.isEmpty(areaBtn.getText().toString())){
					platename = areaBtn.getText().toString();
					if(!CommonUtils.isEmpty(plateEdtTxt.getText().toString())){
						platename = platename + plateEdtTxt.getText().toString();
						platename = platename.toUpperCase();
						if(!CommonUtils.isEmpty(txtVehicleBrand.getText().toString())){
							if(isExist(platename.toString()) > 0){
								Toast.makeText(mContext, R.string.car_the_same, Toast.LENGTH_SHORT).show();
							}else{
								if(!CommonUtils.isEmpty(txtVehicleModel.getText().toString())){
									car_type_id = txtVehicleModel.getText().toString();
									car_brand_vin = txtVehicleVINCode.getText().toString();
//									if (imgVehicleVinCode.isShown() && car_brand_vin.equals("")) {
//										Toast.makeText(this, R.string.car_pl_vin, Toast.LENGTH_LONG).show();
//										return;
//									}
									car_producing_year = editProducedYear.getText().toString();
									if(CommonUtils.isEmpty(car_brand_vin) && CommonUtils.isEmpty(car_producing_year)){
										Toast.makeText(mContext, R.string.car_select_vin_years, Toast.LENGTH_SHORT).show();
									}else{
										if(!CommonUtils.isEmpty(editVehicleDisplacement.getText().toString())){

											car_displacement = editVehicleDisplacement.getText().toString();
											if(".".equals(car_displacement.subSequence(0, 1))){//如果排量第一个字符是“.”就提示。
												Toast.makeText(mContext, R.string.pl_specification, Toast.LENGTH_SHORT).show();
												return;
											}

											if (!car_displacement.contains(".")) {
												car_displacement = String.format("%s.0", car_displacement);
											} else if (car_displacement.endsWith(".")) {
												car_displacement = String.format("%s0", car_displacement);
											}
											car_displacement = String.format("%s%s", car_displacement, txtVehicleDisplacementUnit.getText());
											
											if((!CommonUtils.isEmpty(editSN.getText().toString()))&&(!CommonUtils.isEmpty(editActionCod.getText().toString()))){
												
												Flag = 0;
												newCar = new CarCord();
												newCar.setMine_car_plate_num(platename.toString());//车牌号
												newCar.setCar_series_id(car_series_id);//车辆品牌id
												newCar.setAuto_code(auto_code);//车系编码id
												newCar.setCar_series_name(car_series_name);//车辆品牌名称
												newCar.setCar_sub_type_id(car_sub_type_id);//子品牌
												newCar.setCar_sub_type_name(car_sub_type_name);//子品牌名称
												newCar.setCar_type_id(car_type_id);//车型名称
												newCar.setCar_brand_vin(car_brand_vin);//vin码
												newCar.setCar_gearbox_type(car_gearbox_type);//变速箱
												newCar.setCar_displacement(car_displacement);//排量
												newCar.setCar_producing_year(car_producing_year);//年款
												newCar.setSerial_no(editSN.getText().toString());
												newCar.setAction_code(editActionCod.getText().toString());
												GoloProgressDialog.showProgressDialog(mContext, getString(R.string.string_sending));
//												Intent intent=new Intent(this, ConnectorActivateActivity.class);
//												intent.putExtra("car", newCar);
//												startActivity(intent);
//												checkVinIsMust();
//												vehicleLogic.createCarArchive(newCar);
												
												logic.activateConnector(newCar.getSerial_no(), newCar.getAction_code(), newCar, this);
												
											}else{
												Toast.makeText(mContext, "请输入接头序列号和激活码!", Toast.LENGTH_SHORT).show();
											}
											
										}else{
											Toast.makeText(mContext, R.string.car_pl_disp, Toast.LENGTH_SHORT).show();
										}
									}
								
								}else{
									Toast.makeText(mContext, R.string.car_pl_model, Toast.LENGTH_SHORT).show();
								}
							}
						}else{
							Toast.makeText(mContext, R.string.car_pl_brand, Toast.LENGTH_SHORT).show();
						}
					}else{
						Toast.makeText(mContext, R.string.car_pl_plate, Toast.LENGTH_SHORT).show();
					}
				}else{
					Toast.makeText(mContext, R.string.car_pl_prefix, Toast.LENGTH_SHORT).show();
				}
		}else{
			Toast.makeText(mContext, R.string.string_sending, Toast.LENGTH_SHORT).show();
		}
	}


	/**
	 * @Title: isExist   
	 * @Description: (判断新建车牌号是否已存在)  
	 * @param: @param plateName
	 * @return: int     
	 */
	private int isExist(String plateName){
		int index = 0;
		if(carCordList != null && carCordList.size() > 0){
			for (int i = 0; i < carCordList.size(); i++) {
				if(carCordList.get(i).getMine_car_plate_num().equals(plateName)){
					index = index + 1;
				}
			}
			return index;
		}else{
			return 0;
		}
	}
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		if(resultCode == RESULT_OK){
			switch (requestCode) {
			case BRAND:
				if(data.hasExtra("brand"))
					car_series_name = data.getStringExtra("brand");
				if(data.hasExtra("auto_id"))
					car_series_id = data.getStringExtra("auto_id");
				if(data.hasExtra("auto_code"))
					auto_code = data.getStringExtra("auto_code");
				if(data.hasExtra("sub_id"))
					car_sub_type_id = data.getStringExtra("sub_id");
				if(data.hasExtra("sub_name"))
					car_sub_type_name = data.getStringExtra("sub_name");
				
				if(car_sub_type_name != null && !"".equals(car_sub_type_name) && !"null".equals(car_sub_type_name)){
					txtVehicleBrand.setText(car_sub_type_name);
				}else{
					txtVehicleBrand.setText(car_series_name);
				}
				car_type_id = "";
				txtVehicleModel.setText("");
				brandHasNoModel = false;
				carModels.clear();
				adapter.notifyDataSetChanged();
				ListViewUtils.setHeight(lvVehicleModels);
				getVehicleModels();
				imgVehicleVinCode.setVisibility(View.GONE);
//				checkImgMustVinShow();
				
//				Log.e("ljq", "brand="+car_series_name+",auto_id="+car_series_id+",auto_code="+auto_code+",car_sub_type_id="
//				+car_sub_type_id+",car_sub_type_name="+car_sub_type_name);
				break;
			case VIN_CODE:
				if (data.hasExtra("vinCode")) {
					car_brand_vin = data.getStringExtra("vinCode");
					txtVehicleVINCode.setText(car_brand_vin);
					if (car_brand_vin.length() >= 10) {
						recoginseProducedYear(car_brand_vin);
					}
				}
				break;
			default:
				break;
			}
		}
	}
	
	private void checkImgMustVinShow() {
//		if (configManager == null) {
//			configManager = new VehicleConfigInterface(mContext);
//		}
//		configManager.checkVinIsMust(auto_code, Utils.getRequestLanguage(), new HttpResponseEntityCallBack<CarVinIsMustData>() {
//			@Override
//			public void onResponse(int stateCode, int cmdCode, int code, String msg, CarVinIsMustData result) {
//				if (stateCode == StateCode.HTTP_REQUEST_SUCCESS) {
//					if (code == 0) {
//						if (result != null && result.getIsMustVin() == 1) {
//							imgVehicleVinCode.setVisibility(View.VISIBLE);
//						}
//					}
//				} else if (stateCode == StateCode.HTTP_REQUEST_FAIL) {
//
//				} else if (stateCode == StateCode.HTTP_SEARCH_ACTION_FAIL) {
//
//				}
//			}
//		});
	}
	
//	private void checkVinIsMust() {
//		configManager.getCarBrandList(null, newCar.getAuto_code(), Utils.getRequestLanguage(), new HttpResponseEntityCallBack<CarBrand>() {
//			@Override
//			public void onResponse(int stateCode, int cmdCode, int code, String msg, CarBrand result) {
//				if (stateCode == StateCode.HTTP_REQUEST_SUCCESS) {
//					if (result != null && result.getIsMustVin() == 1 && txtVehicleVINCode.getText().toString().equals("")) {
//						Toast.makeText(VehicleAddNewCarsActivity.this, R.string.car_pl_vin, Toast.LENGTH_LONG).show();
//					} else {
//						vehicleLogic.createCarArchive(newCar);
//					}
//				} else if (stateCode == StateCode.HTTP_REQUEST_FAIL) {
//					
//				} else if (stateCode == StateCode.HTTP_SEARCH_ACTION_FAIL) {
//					
//				}
//			}
//		});
//	}


	/**
	 * @Title: recoginseProducedYear 
	 * @说明:通过Vin码识别年款
	 * @参数: @param vinCode   
	 * @return void    返回类型 
	 * @throws
	 */
	private void recoginseProducedYear(String vinCode) {
		String year = null;
		switch (vinCode.charAt(9)) {
		case '1':
			year = "2001";
			break;
		case '2':
			year = "2002";
			break;
		case '3':
			year = "2003";
			break;
		case '4':
			year = "2004";
			break;
		case '5':
			year = "2005";
			break;
		case '6':
			year = "2006";
			break;
		case '7':
			year = "2007";
			break;
		case '8':
			year = "2008";
			break;
		case '9':
			year = "2009";
			break;
		case 'A':
			year = "2010";
			break;
		case 'B':
			year = "2011";
			break;
		case 'C':
			year = "2012";
			break;
		case 'D':
			year = "2013";
			break;
		case 'E':
			year = "2014";
			break;
		case 'F':
			year = "2015";
			break;
		case 'G':
			year = "2016";
			break;
		case 'H':
			year = "2017";
			break;
		case 'J':
			year = "2018";
			break;
		case 'K':
			year = "2019";
			break;
		case 'L':
			year = "2020";
			break;
		case 'M':
			year = "2021";
			break;
		case 'N':
			year = "2022";
			break;
		case 'P':
			year = "2023";
			break;
		case 'R':
			year = "2024";
			break;
		case 'S':
			year = "2025";
			break;
		case 'T':
			year = "2026";
			break;
		case 'V':
			year = "2027";
			break;
		case 'W':
			year = "2028";
			break;
		case 'X':
			year = "2029";
			break;
		case 'Y':
			year = "2030";
			break;
		default:
			break;
		}
		if (year != null) {
			editProducedYear.setText(year);
		}
	}

	private PopupWindow popupWindow;
	private View popupView;
	/**
	 * @Title: showPopUp   
	 * @Description: (弹出框)  
	 * @param: @param type 1、表示车牌地区2、表示车型选择  
	 * @throws
	 */
	private void showPopUp() {
		GridView girdView = null;
		ListView listview = null;
		if (popupView == null) {
			popupView = View.inflate(this, R.layout.select_plate_prefix, null);
		}
		girdView = (GridView) popupView.findViewById(R.id.gridview);
		listview = (ListView) popupView.findViewById(R.id.lsitview);
		
		girdView.setVisibility(View.VISIBLE);
		listview.setVisibility(View.GONE);
		areaAdapter = new AreaAdapter(mContext,area);
		girdView.setAdapter(areaAdapter);
		girdView.setOnItemClickListener(new OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
				if(arg2 == area.length - 1 || arg2 == area.length - 2){
					popupWindow.dismiss();
				}else{
					areaBtn.setText(area[arg2]);
					popupWindow.dismiss();
				}
			}
		});
		
		if (popupWindow == null) {
			popupWindow = new PopupWindow(VehicleAddNewCarsActivity.this);
			popupWindow.setBackgroundDrawable(new BitmapDrawable());
			popupWindow.setFocusable(true); // 设置PopupWindow可获得焦点
			popupWindow.setTouchable(true); // 设置PopupWindow可触摸
			popupWindow.setOutsideTouchable(true); // 设置非PopupWindow区域可触摸
			popupWindow.setContentView(popupView);
			popupWindow.setWidth(LayoutParams.MATCH_PARENT);
			popupWindow.setHeight(LayoutParams.WRAP_CONTENT);
//			popupWindow.setAnimationStyle(R.style.popuStyle); // 设置 popupWindow
		}
		popupWindow.showAtLocation(this.findViewById(R.id.main_layout),Gravity.BOTTOM, 0, 0);
		popupWindow.update();
	}
	
	
	
//	private VehicleConfigInterface configManager;
	
	
	@Override
	protected void onDestroy() {
		super.onDestroy();
//		Singlton.getInstance(VehicleLogic.class).deleteEventListener(vehicleLogicListener);
	}


	@Override
	public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
		if (parent.equals(lvVehicleModels)) {
			CarModel carModel = (CarModel) parent.getItemAtPosition(position);
			txtVehicleModel.setText(carModel.getCarType());
			lvVehicleModels.setVisibility(View.GONE);
			imgVehicleModel.setImageResource(R.drawable.open);
		} else {
			Map<String, String> map = (HashMap<String, String>) parent.getItemAtPosition(position);
			txtVehicleDisplacementUnit.setText(map.get("srcData"));
			pwVehicleDisplacementUnit.dismiss();
			imgVehicleDisplacementUnit.setImageResource(R.drawable.pull_down);
		}
	}
	
    private char[] DisplacementChar = new char[] { '0', '1', '2', '3',
		'4', '5', '6', '7', '8', '9', '.'};

	@Override
	public void beforeTextChanged(CharSequence s, int start, int count, int after) {
	}


	@Override
	public void onTextChanged(CharSequence s, int start, int before, int count) {
        cou = before + count;
        String editable = plateEdtTxt.getText().toString();
        String str = stringFilter(editable);
        if (!editable.equals(str)) {
            plateEdtTxt.setText(str);
        }
//      plateEdtTxt.setSelection(plateEdtTxt.length());
        cou = plateEdtTxt.length();
	}


	@Override
	public void afterTextChanged(Editable s) {
        if (cou > mMaxLenth) {
            selectionEnd = plateEdtTxt.getSelectionEnd();
            s.delete(mMaxLenth, selectionEnd);
            if(androidVersion.charAt(0)>='4') {
            	plateEdtTxt.setText(s.toString());
            }
        }
	}

}
