package com.cnlaunch.golo.inspection;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.ExpandableListView;
import android.widget.ExpandableListView.OnChildClickListener;
import android.widget.ExpandableListView.OnGroupClickListener;
import android.widget.TextView;
import android.widget.Toast;

import com.cnlaunch.golo.inspection.adapter.VehicleCarBrandAdapter;
import com.cnlaunch.golo.inspection.logic.RequestLogic;
import com.cnlaunch.golo.inspection.logic.RequestLogic.OnRequestFinishListener;
import com.cnlaunch.golo.inspection.model.CarSeries;
import com.cnlaunch.golo.inspection.tools.PinyinComparator;
import com.cnlaunch.golo.inspection.tools.StringUtils;
import com.cnlaunch.golo.inspection.view.GoloProgressDialog;
import com.cnlaunch.golo.inspection.view.SideBar;
import com.cnlaunch.golo.inspection.view.SideBar.OnTouchingLetterChangedListener;
import com.cnlaunch.golo.tools.GoloActivityManager;
import com.cnlaunch.golo.wifisettings2.R;
/**   
 * FileName: VehicleCarBrandActivity.java   
 * @Description: TODO(车辆品牌) 
 * All rights Reserved, Designed By Golo  
 * Copyright:    Copyright(C) 2014-2020  
 * Company       Golo.  
 * @author:    liujiaqing 
 * @version    V1.0    
 * Createdate: 2014年11月24日 下午5:16:30  
 */
public class VehicleCarBrandActivity extends SlidingAroundableActivity implements OnRequestFinishListener {
	
//	private Context mContext;
	//热门品牌、全部品牌
	private View hotBrandView, allBrandView;
	//页面view集合
	private ArrayList<View> viewList;
	//全部品牌集合
	private List<CarSeries> brandList;
	//热门品牌集合
	private List<CarSeries> brandHotList;
	//热门品牌
	private CarSeries carhot;
	//热门品牌子类
	private CarSeries carhotsub;
	private ExpandableListView listview,hostListView;
	private TextView dialogTxt,hotDialogText;
	private SideBar sidebar,hotSideBar;
	//适配器
//	private ExAdapter exAdapter,hotExAdapter;
	//根据拼音来排列ListView里面的数据类
	private PinyinComparator pinyinComparator;
//	private VehicleLogic vehicleLogic;
	private int select_num;
	private List<Boolean> selectgroup = new ArrayList<Boolean>();
//	private HashMap<Integer, List<Boolean>> selectchild = new HashMap<Integer, List<Boolean>>();
	private List<Boolean> selecthotgroup = new ArrayList<Boolean>();
//	private HashMap<Integer, List<Boolean>> selecthotchild = new HashMap<Integer, List<Boolean>>();
	private int Flage = 0;//标志当前页面是热门品牌还是全部品牌
	private int select_seller_car;//商家APP多选
	private VehicleCarBrandAdapter exAdapter,hotExAdapter;
	private RequestLogic logic;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		if(getIntent().hasExtra("select_num")){
			this.select_num = getIntent().getIntExtra("select_num", 0);
		}
		if(getIntent().hasExtra("select_seller_car")){
			select_seller_car = getIntent().getIntExtra("select_seller_car", 0);
		}
		init();
		GoloProgressDialog.showProgressDialog(VehicleCarBrandActivity.this, getString(R.string.string_loading));//等待加载dialog
		logic=RequestLogic.getInstance();
		logic.getVehicleBrand(this);
	}
	@Override
	public void onFinish(int code, String tag, Object object) {
		GoloProgressDialog.dismissProgressDialog(VehicleCarBrandActivity.this);
		if("getVehicleBrand".equals(tag)){//返回加载的车牌数据
			switch (code) {
			case 0:
				dealData((List<CarSeries>) object);
				break;
			case 1:
				Toast.makeText(getApplicationContext(), "加载品牌数据失败！！", Toast.LENGTH_SHORT).show();
				break;
			default:
				break;
			}
		}
	}
	//处理返回数据
	private void dealData(List<CarSeries> list) {
		GoloProgressDialog.dismissProgressDialog(VehicleCarBrandActivity.this);
		brandList =list ;
		if(brandList != null){
			sidebar.setVisibility(View.VISIBLE);
			brandHotList = new ArrayList<CarSeries>();
			for (int i = 0; i < brandList.size(); i++) {
				int ishot = brandList.get(i).getIsHot();
				if(ishot == 1){
					carhot = new CarSeries();
					carhot.setAutoCode(brandList.get(i).getAutoCode());
					carhot.setCarSeriesId(brandList.get(i).getCarSeriesId());
					carhot.setCarSeriesName(brandList.get(i).getCarSeriesName());
					List<CarSeries> mIsHotsublist = brandList.get(i).getSubList();
					List<CarSeries> mIsHotsublist2 = new ArrayList<CarSeries>();
					if(mIsHotsublist != null && mIsHotsublist.size() > 0){
						for (int j = 0; j < mIsHotsublist.size(); j++) {
							if( mIsHotsublist.get(j).getIsHot() == 1){
								carhotsub = new CarSeries();
								carhotsub.setAutoCode(mIsHotsublist.get(j).getAutoCode());
								carhotsub.setCarSeriesId(mIsHotsublist.get(j).getCarSeriesId());
								carhotsub.setCarSeriesName(mIsHotsublist.get(j).getCarSeriesName());
								carhotsub.setIsHot(mIsHotsublist.get(j).getIsHot());
								mIsHotsublist2.add(carhotsub);
							}
						}
					}
					if(mIsHotsublist2 != null && mIsHotsublist2.size()>0){
						carhot.setSubList(mIsHotsublist2);
					}
					brandHotList.add(carhot);
				}else if(ishot == 0){
					List<CarSeries> mIsHotsublist = brandList.get(i).getSubList();
					List<CarSeries> mIsHotsublist2 = new ArrayList<CarSeries>();
					if(mIsHotsublist != null && mIsHotsublist.size() > 0){
						for (int j = 0; j < mIsHotsublist.size(); j++) {
							if( mIsHotsublist.get(j).getIsHot() == 1){
								carhotsub = new CarSeries();
								carhotsub.setAutoCode(mIsHotsublist.get(j).getAutoCode());
								carhotsub.setCarSeriesId(mIsHotsublist.get(j).getCarSeriesId());
								carhotsub.setCarSeriesName(mIsHotsublist.get(j).getCarSeriesName());
								carhotsub.setIsHot(mIsHotsublist.get(j).getIsHot());
								mIsHotsublist2.add(carhotsub);
							}
						}
					}
					if(mIsHotsublist2 != null && mIsHotsublist2.size()>0){
						carhot = new CarSeries();
						carhot.setAutoCode(brandList.get(i).getAutoCode());
						carhot.setCarSeriesId(brandList.get(i).getCarSeriesId());
						carhot.setCarSeriesName(brandList.get(i).getCarSeriesName());
						carhot.setSubList(mIsHotsublist2);
						brandHotList.add(carhot);
					}
				}
			}
			
			if(brandList != null && brandList.size() > 0){
				brandList = filledData();
				Collections.sort(brandList, pinyinComparator);
				for (int j = 0; j < brandList.size(); j++) {
					selectgroup.add(false);
				}
				exAdapter = new VehicleCarBrandAdapter(VehicleCarBrandActivity.this, brandList, sidebar, 0, select_num,
						selectgroup, null);
				listview.setAdapter(exAdapter);
			}
			
			if(brandHotList != null && brandHotList.size() > 0){
				for (int j = 0; j < brandHotList.size(); j++) {
					selecthotgroup.add(false);
				}
				hotExAdapter = new VehicleCarBrandAdapter(VehicleCarBrandActivity.this, brandHotList, hotSideBar, 1
						, select_num, null, selecthotgroup);
				hostListView.setAdapter(hotExAdapter);
			}
		}
	}
	private void init(){
		viewList = new ArrayList<View>();
		hotBrandView = inflater.inflate(R.layout.car_brand_main, null);
		allBrandView = inflater.inflate(R.layout.car_brand_main, null);
		viewList.add(hotBrandView);
		viewList.add(allBrandView);
		
		if(select_num == 1){
			super.initSlidableView(R.string.car_vehicle_brand, R.array.car_brand, viewList, R.string.maintenance_record_ok);
		}else{
			super.initSlidableView(R.string.car_vehicle_brand, R.array.car_brand, viewList, null);
		}
		pageTabs.setVisibility(View.GONE);
		viewPager.setCurrentItem(1);
		// 实例化汉字转拼音类
		pinyinComparator = new PinyinComparator();
		listview = (ExpandableListView) allBrandView.findViewById(R.id.expandlistview);
		dialogTxt = (TextView) allBrandView.findViewById(R.id.dialog);
		sidebar = (SideBar) allBrandView.findViewById(R.id.sidrbar);
		sidebar.setTextView(dialogTxt);
		sidebar.setVisibility(View.GONE);
		sidebar.setOnTouchingLetterChangedListener(new OnTouchingLetterChangedListener() {
			
			@Override
			public void onTouchingLetterChanged(String s) {
				// TODO Auto-generated method stub
				int position = exAdapter.getPositionForSection(s.charAt(0));
				if (position != -1) {
					listview.setSelection(position);
				}
			}
		});
		
		hostListView = (ExpandableListView) hotBrandView.findViewById(R.id.expandlistview);
//		hotDialogText = (TextView) hotBrandView.findViewById(R.id.dialog);
		hotSideBar = (SideBar) hotBrandView.findViewById(R.id.sidrbar);
		hotSideBar.setVisibility(View.GONE);
		
		listview.setOnChildClickListener(onChildClickListener);
		listview.setOnGroupClickListener(onGroupClickListener);
		hostListView.setOnChildClickListener(onChildClickListener);
		hostListView.setOnGroupClickListener(onGroupClickListener);
		
	}
	
	@Override
	protected void rightClick(int index) {
		// TODO Auto-generated method stub
		super.rightClick(index);
		Flage = getCurrentPoint();
		List<CarSeries> list;
		if(select_seller_car == 1){
			list = new ArrayList<CarSeries>();
			if(brandHotList != null){
				list.addAll(brandHotList);
			}
			if(brandList != null){
				list.addAll(brandList);
			}
		}else if(Flage == 0){
			list = brandHotList;
		}else{
			list = brandList;
		}
		if(list == null || list.size() <= 0){
			return;
		}
		
		//选择的车辆品牌数据(注：此集合里面的SubList是为空的没有用的)
		List<CarSeries> selelist = new ArrayList<CarSeries>();
		if(selelist != null && selelist.size() > 0){
			selelist.clear();
		}
		selectgroup = exAdapter.getselectgroup();
		selecthotgroup = hotExAdapter.getselecthotgroup();
		for (int i = 0; i < list.size(); i++) {
			if(select_seller_car == 1){
				if(i<brandHotList.size()){
					if(selecthotgroup.get(i)){
						selelist.add(list.get(i));
					}
				}else {
					if(selectgroup.get(i-brandHotList.size())){
						selelist.add(list.get(i));
					}
				}
			}else if(Flage == 0){
				if(selecthotgroup.get(i)){
					selelist.add(list.get(i));
				}
//				List<CarSeries> listitem = list.get(i).getSubList();
//				if(listitem != null && listitem.size() > 0){
//					for (int j = 0; j < listitem.size(); j++) {
//						if(selecthotchild.get(i).get(j)){
//							selelist.add(listitem.get(j));
//						}
//					}
//				}
			}else{
				if(selectgroup.get(i)){
					selelist.add(list.get(i));
				}
//				List<CarSeries> listitem = list.get(i).getSubList();
//				if(listitem != null && listitem.size() > 0){
//					for (int j = 0; j < listitem.size(); j++) {
//						if(selectchild.get(i).get(j)){
//							selelist.add(listitem.get(j));
//						}
//					}
//				}
			}
		}
		if(selelist!=null&&selelist.size()>0){
			Intent result = new Intent();
			result.putExtra("select_list", (Serializable)selelist);
			setResult(Activity.RESULT_OK, result);
			GoloActivityManager.create().finishActivity();
		}else{
			Toast.makeText(context, R.string.car_pl_brand, 1000).show();
		}
	}
	
	
	private OnChildClickListener onChildClickListener = new OnChildClickListener() {

		@Override
		public boolean onChildClick(ExpandableListView parent, View v,
				int groupPosition, int childPosition, long id) {
			// TODO Auto-generated method stub
			if(select_num == 1){//选择多个需要自己添加
				
			}else{//默认是车辆品牌选择
				String carbrans = null;
				String auto_id = null;
				String auto_code = null;
				String sub_id = null;
				String sub_name = null;
				String sub_auto_code = null;
				if(getCurrentPoint() == 0){//getCurrentPoint（）==0 为热门品牌否则为全部
					carbrans = brandHotList.get(groupPosition).getCarSeriesName();
					auto_id = brandHotList.get(groupPosition).getCarSeriesId();
//				auto_code = brandHotList.get(groupPosition).getAutoCode();
					sub_id = brandHotList.get(groupPosition).getSubList().get(childPosition).getCarSeriesId();
					sub_name = brandHotList.get(groupPosition).getSubList().get(childPosition).getCarSeriesName();
					sub_auto_code = brandHotList.get(groupPosition).getSubList().get(childPosition).getAutoCode();
				}else{
					carbrans = brandList.get(groupPosition).getCarSeriesName();
					auto_id = brandList.get(groupPosition).getCarSeriesId();
//				auto_code = brandList.get(groupPosition).getAutoCode();
					sub_id = brandList.get(groupPosition).getSubList().get(childPosition).getCarSeriesId();
					sub_name = brandList.get(groupPosition).getSubList().get(childPosition).getCarSeriesName();
					sub_auto_code = brandList.get(groupPosition).getSubList().get(childPosition).getAutoCode();
				}
				Intent result = new Intent();
				result.putExtra("brand", carbrans);
				result.putExtra("auto_id", auto_id);
				result.putExtra("auto_code", sub_auto_code);
				result.putExtra("sub_name", sub_name);
				result.putExtra("sub_id", sub_id);
				setResult(Activity.RESULT_OK, result);
				GoloActivityManager.create().finishActivity();
			}
			return false;
		}
	};
	
	private OnGroupClickListener onGroupClickListener = new OnGroupClickListener() {
		
		@Override
		public boolean onGroupClick(ExpandableListView parent, View v,
				int groupPosition, long id) {
			// TODO Auto-generated method stub
			if(select_num == 1){//选择多个需要自己添加
				
			}else{//默认是车辆品牌选择
				if(getCurrentPoint() == 0){
					if(brandHotList.get(groupPosition).getSubList() != null && brandHotList.get(groupPosition).getSubList().size() > 0){
						
					}else{
						String carbrans = brandHotList.get(groupPosition).getCarSeriesName();
						String auto_id = brandHotList.get(groupPosition).getCarSeriesId();
						String auto_code = brandHotList.get(groupPosition).getAutoCode();
						
						Intent result = new Intent();
						result.putExtra("brand", carbrans);
						result.putExtra("auto_id", auto_id);
						result.putExtra("auto_code", auto_code);
						result.putExtra("sub_name", "");
						result.putExtra("sub_id", "");
						setResult(Activity.RESULT_OK, result);
						GoloActivityManager.create().finishActivity();
					}
				}else{
					if(brandList.get(groupPosition).getSubList() != null && brandList.get(groupPosition).getSubList().size() > 0){
						
					}else{
						String carbrans = brandList.get(groupPosition).getCarSeriesName();
						String auto_id = brandList.get(groupPosition).getCarSeriesId();
						String auto_code = brandList.get(groupPosition).getAutoCode();
						
						Intent result = new Intent();
						result.putExtra("brand", carbrans);
						result.putExtra("auto_id", auto_id);
						result.putExtra("auto_code", auto_code);
						result.putExtra("sub_name", "");
						result.putExtra("sub_id", "");
						setResult(Activity.RESULT_OK, result);
						GoloActivityManager.create().finishActivity();
					}
				}
			}
			return false;
		}
	};
	
	
	
	/**
	 * 为ListView填充数据
	 * 
	 * @param date
	 * @return
	 */
	private List<CarSeries> filledData() {
		List<CarSeries> mSortList = new ArrayList<CarSeries>();
		for (CarSeries c : brandList) {
			// 汉字转换成拼音
			String pinyin = StringUtils.getPingYin(c.getCarSeriesName());
			if(pinyin.equals("zhangan"))
				pinyin = "changan";
			if(pinyin.equals("zhangcheng"))
				pinyin = "changcheng";
			String sortString = pinyin.substring(0, 1).toUpperCase();
			
			// 正则表达式，判断首字母是否是英文字母
			if (sortString.matches("[A-Z]")) {
				c.setSortKey(sortString.toUpperCase());
			} else {
				c.setSortKey("#");
			}
			c.setPinying(pinyin.toUpperCase());
			mSortList.add(c);
		}
		return mSortList;
	}
	
	
	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
	}

}
