package com.cnlaunch.golo.inspection.adapter;

import android.content.Context;
import android.content.res.ColorStateList;
import android.content.res.Resources;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.LinearLayout.LayoutParams;
import android.widget.TextView;

import com.cnlaunch.golo.wifisettings2.R;

/**
 * FileName: AreaAdapter.java
 * 
 * @Description: TODO(车牌前缀适配器) All rights Reserved, Designed By Golo Copyright:
 *               Copyright(C) 2014-2020 Company Golo.
 * @author: liujiaqing
 * @version V1.0 Createdate: 2014年12月4日 下午4:24:21
 * 
 *          Modification History: Date Author Version Discription
 * 
 *          2014年12月4日 wu.zh 1.0 1.0 Why & What is modified: <修改原因描述>
 */
public class AreaAdapter extends BaseAdapter {
	private String[] area;
	private Context mcontext;
	public AreaAdapter(Context context,String[] area) {
		// TODO Auto-generated constructor stub
		this.area = area;
		this.mcontext = context;
	}

	@Override
	public int getCount() {
		if (area != null && area.length > 0) {
			return area.length;
		} else {
			return 0;
		}
	}

	@Override
	public Object getItem(int position) {
		return position;
	}

	@Override
	public long getItemId(int position) {
		return position;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		ViewHolder holder = null;
		if (null == convertView) {
			holder = new ViewHolder();
			convertView = LayoutInflater.from(mcontext).inflate(R.layout.select_plate_prefix_item, null);
			holder.textName = (TextView) convertView.findViewById(R.id.area_txt);
			convertView.setTag(holder);
		} else {
			holder = (ViewHolder) convertView.getTag();
		}

		holder.textName.setText(area[position]);
		if(position == area.length - 1){
			holder.textName.setBackgroundResource(R.color.darkgrey);
			LinearLayout.LayoutParams params = new LinearLayout.LayoutParams(LayoutParams.MATCH_PARENT,LayoutParams.MATCH_PARENT);
			params.gravity = Gravity.LEFT;
			params.setMargins(0, dip2px(3), dip2px(3), dip2px(3));
			holder.textName.setLayoutParams(params);
			holder.textName.setPadding(0, dip2px(3), dip2px(7), dip2px(3));
			holder.textName.setGravity(Gravity.LEFT);
			Resources resource = mcontext.getResources();  
			ColorStateList csl = (ColorStateList) resource.getColorStateList(R.color.white);
			holder.textName.setTextColor(csl);
		}
		if(position == area.length - 2){
			holder.textName.setBackgroundResource(R.color.darkgrey);
			LinearLayout.LayoutParams params = new LinearLayout.LayoutParams(LayoutParams.MATCH_PARENT,LayoutParams.MATCH_PARENT);
			params.gravity = Gravity.RIGHT;
			params.setMargins(dip2px(3), dip2px(3), 0, dip2px(3));
			holder.textName.setLayoutParams(params);
			holder.textName.setPadding(dip2px(7), dip2px(3), 0, dip2px(3));
			holder.textName.setGravity(Gravity.RIGHT);
			Resources resource = mcontext.getResources();  
			ColorStateList csl = (ColorStateList) resource.getColorStateList(R.color.white);
			holder.textName.setTextColor(csl);
		}
		return convertView;
	}

	class ViewHolder {
		TextView textName;
	}
	public  int dip2px(float dpValue) {
		return (int) (dpValue * (mcontext.getResources().getDisplayMetrics().density )+ 0.5f);
	}
}
