package com.cnlaunch.golo.inspection.adapter;

import java.util.ArrayList;
import java.util.List;

import android.content.Context;
import android.os.Handler;
import android.os.Message;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseExpandableListAdapter;
import android.widget.CheckBox;
import android.widget.ImageView;
import android.widget.TextView;

import com.cnlaunch.golo.inspection.model.CarSeries;
import com.cnlaunch.golo.inspection.view.SideBar;
import com.cnlaunch.golo.wifisettings2.R;

/**   
 * FileName: VehicleCarBrandAdapter.java   
 * @Description: TODO(车辆品牌适配器) 
 * All rights Reserved, Designed By Golo  
 * Copyright:    Copyright(C) 2014-2020  
 * Company       Golo.  
 * @author:    liujiaqing 
 * @version    V1.0    
 * Createdate: 2015年5月13日 下午5:55:53  
 *   
 * Modification  History:   
 * Date         Author        Version        Discription  
 *    
 * 2015年5月13日       wu.zh          1.0             1.0  
 * Why & What is modified: <修改原因描述>  
 */
public class VehicleCarBrandAdapter extends BaseExpandableListAdapter {
	
	private Context context;
	private List<CarSeries> date;
	private LayoutInflater inflater;
	private SideBar mBar;
	private List<CarSeries> subList;
	private int flag;//0代表全部、1代表热门
	private int select_num;
	private List<Boolean> selectgroup = new ArrayList<Boolean>();
	private List<Boolean> selecthotgroup = new ArrayList<Boolean>();
	
	public VehicleCarBrandAdapter(Context context,List<CarSeries> date, SideBar mBar, int flag,
			int select_num, List<Boolean> selectgroup, List<Boolean> selecthotgroup) {
		this.context = context;
		this.date = date;
		this.inflater = LayoutInflater.from(context);
		this.mBar = mBar;
		this.flag = flag;
		this.select_num = select_num;
		this.selectgroup = selectgroup;
		this.selecthotgroup = selecthotgroup;
	}
	
	public VehicleCarBrandAdapter(Context context,List<CarSeries> date, SideBar mBar, int flag,
			int select_num) {
		this.context = context;
		this.date = date;
		this.inflater = LayoutInflater.from(context);
		this.mBar = mBar;
		this.flag = flag;
		this.select_num = select_num;
	}
	
	public void update(List<CarSeries> list){
		date = list;
		notifyDataSetChanged();
	}
	
	public List<Boolean> getselectgroup(){
		return selectgroup;
	}
	
	public List<Boolean> getselecthotgroup(){
		return selecthotgroup;
	}

	@Override
	public Object getChild(int groupPosition, int childPosition) {
		// TODO Auto-generated method stub
		return date.get(groupPosition).getSubList().get(childPosition);
	}

	@Override
	public long getChildId(int groupPosition, int childPosition) {
		// TODO Auto-generated method stub
		return childPosition;
	}

	@Override
	public View getChildView(final int groupPosition, final int childPosition,
			boolean isLastChild, View convertView, ViewGroup parent) {
		// TODO Auto-generated method stub
		final ViewChildHolder childholder;
		if (convertView == null) {
			childholder = new ViewChildHolder();
			convertView = inflater.inflate(R.layout.vehicle_brand_item, null);
			childholder.childName = (TextView) convertView.findViewById(R.id.childName);
//			childholder.childCheck = (CheckBox) convertView.findViewById(R.id.brand_chlid_cbox);
			convertView.setTag(childholder);
		}else{
			childholder = (ViewChildHolder) convertView.getTag();
		}
		subList = date.get(groupPosition).getSubList();
		childholder.childName.setText(date.get(groupPosition).getSubList().get(childPosition).getCarSeriesName());
//		childholder.childCheck.setVisibility(View.GONE);
//		if(select_num == 1){
//			childholder.childCheck.setVisibility(View.VISIBLE);
//			if(flag == 0){
//				childholder.childCheck.setChecked(selectchild.get(groupPosition).get(childPosition));
//			}else{
//				childholder.childCheck.setChecked(selecthotchild.get(groupPosition).get(childPosition));
//			}
//			childholder.childCheck.setOnClickListener(new OnClickListener() {
//				
//				@Override
//				public void onClick(View v) {
//					// TODO Auto-generated method stub
//					childholder.childCheck.setChecked(false);
//					if(flag == 0){
//						selectchild.get(groupPosition).set(childPosition, !selectchild.get(groupPosition).get(childPosition));
//						childholder.childCheck.setChecked(selectchild.get(groupPosition).get(childPosition));
//					}else{
//						selecthotchild.get(groupPosition).set(childPosition, !selecthotchild.get(groupPosition).get(childPosition));
//						childholder.childCheck.setChecked(selecthotchild.get(groupPosition).get(childPosition));
//					}
//				}
//			});
//		}
		
		return convertView;
	}
	
	class ViewChildHolder{
		TextView childName;
//		CheckBox childCheck;
	}

	@Override
	public int getChildrenCount(int groupPosition) {
		// TODO Auto-generated method stub
		if(date.get(groupPosition).getSubList() != null 
				&& date.get(groupPosition).getSubList().size()>0)
			return date.get(groupPosition).getSubList().size();
		else
			return 0;
	}

	@Override
	public Object getGroup(int groupPosition) {
		// TODO Auto-generated method stub
		return date.get(groupPosition);
	}

	@Override
	public int getGroupCount() {
		// TODO Auto-generated method stub
		return date.size();
	}

	@Override
	public long getGroupId(int groupPosition) {
		// TODO Auto-generated method stub
		return groupPosition;
	}
	
	@Override
	public View getGroupView(final int groupPosition, boolean isExpanded,
			View convertView, ViewGroup parent) {
		// TODO Auto-generated method stub
		final ViewHolder viewHolder;
		CarSeries mContent = date.get(groupPosition);
		if(convertView == null){
			viewHolder = new ViewHolder();
			convertView = inflater.inflate(R.layout.vehicle_select_brand_new_item,null);
			viewHolder.sort_key = (TextView) convertView.findViewById(R.id.sort_key);
			viewHolder.groupName = (TextView) convertView.findViewById(R.id.groupName);
			viewHolder.groupview = (ImageView) convertView.findViewById(R.id.groupview);
			viewHolder.groupCbox = (CheckBox) convertView.findViewById(R.id.brand_group_cbox);
			convertView.setTag(viewHolder);
		}else{
			viewHolder = (ViewHolder) convertView.getTag();
		}
		
		if(date.get(groupPosition).getSortKey() != null){
			// 根据position获取分类的首字母的Char ascii值
			int section = getSectionForPosition(groupPosition);
			
			// 如果当前位置等于该分类首字母的Char的位置 ，则认为是第一次出现
			if (groupPosition == getPositionForSection(section)) {
				viewHolder.sort_key.setVisibility(View.VISIBLE);
				viewHolder.sort_key.setText(mContent.getSortKey());
			} else {
				viewHolder.sort_key.setVisibility(View.GONE);
			}
			viewHolder.groupName.setText(date.get(groupPosition).getCarSeriesName());
		}else{ 
			viewHolder.sort_key.setVisibility(View.GONE);
			viewHolder.groupName.setText(date.get(groupPosition).getCarSeriesName());
		}
		viewHolder.sort_key.setOnClickListener(null);
		
		viewHolder.groupCbox.setVisibility(View.GONE);
//		if(date.get(groupPosition).getSubList() != null && date.get(groupPosition).getSubList().size()>0){
			viewHolder.groupview.setVisibility(View.VISIBLE);
//			viewHolder.groupCbox.setVisibility(View.GONE);
//		}else{
//			viewHolder.groupview.setVisibility(View.GONE);
			if(select_num == 1){
				viewHolder.groupCbox.setVisibility(View.VISIBLE);
				viewHolder.groupview.setVisibility(View.GONE);
				if(flag == 0){
					if(selectgroup != null && selectgroup.size() > 0)
						viewHolder.groupCbox.setChecked(selectgroup.get(groupPosition));
				}else{
					if(selecthotgroup != null && selecthotgroup.size() > 0)
						viewHolder.groupCbox.setChecked(selecthotgroup.get(groupPosition));
				}
				viewHolder.groupCbox.setOnClickListener(new OnClickListener() {
					
					@Override
					public void onClick(View v) {
						// TODO Auto-generated method stub
						viewHolder.groupCbox.setChecked(false);
						if(flag == 0){
							if(selectgroup != null && selectgroup.size() > 0){
								selectgroup.set(groupPosition, !selectgroup.get(groupPosition));
								viewHolder.groupCbox.setChecked(selectgroup.get(groupPosition));
							}
								
						}else{
							if(selecthotgroup != null && selecthotgroup.size() > 0){
								selecthotgroup.set(groupPosition, !selecthotgroup.get(groupPosition));
								viewHolder.groupCbox.setChecked(selecthotgroup.get(groupPosition));
							}
						}
					}
				});
			}else{
				viewHolder.groupview.setVisibility(View.GONE);
				viewHolder.groupCbox.setVisibility(View.GONE);
				if(date.get(groupPosition).getSubList() != null && date.get(groupPosition).getSubList().size()>0){
					viewHolder.groupview.setVisibility(View.VISIBLE);
				}
			}
//		}
		viewHolder.groupview.setBackgroundResource(R.drawable.close);
		if (!isExpanded) {
			viewHolder.groupview.setBackgroundResource(R.drawable.open);
		}
		
		return convertView;
	}
	
	class ViewHolder{
		TextView sort_key;
		TextView groupName;
		ImageView groupview;
		CheckBox groupCbox;
	}
	@Override
	public boolean hasStableIds() {
		// TODO Auto-generated method stub
		return true;
	}

	@Override
	public boolean isChildSelectable(int groupPosition, int childPosition) {
		// TODO Auto-generated method stub
		return true;
	}
	
	/**
	 * 判断滑动距离
	 */
	private float DownX, UpX;

	private Handler mHanler = new Handler() {

		@Override
		public void handleMessage(Message msg) {
			super.handleMessage(msg);
			switch (msg.what) {
			case 0:

				break;
			case 1:

				break;
			}
			mBar.setVisibility(View.VISIBLE);
		}

	};

	/**
	 * 根据ListView的当前位置获取分类的首字母的Char ascii值
	 */
	public int getSectionForPosition(int groupPosition) {
		return date.get(groupPosition).getSortKey().charAt(0);
	}

	/**
	 * 根据分类的首字母的Char ascii值获取其第一次出现该首字母的位置
	 */
	public int getPositionForSection(int section) {
		for (int i = 0; i < getGroupCount(); i++) {
			String sortStr = date.get(i).getSortKey();
			char firstChar = sortStr.toUpperCase().charAt(0);
			if (firstChar == section) {
				return i;
			}
		}

		return -1;
	}

	/**
	 * 提取英文的首字母，非英文字母用#代替。
	 * 
	 * @param str
	 * @return
	 */
	private String getAlpha(String str) {
		String sortStr = str.trim().substring(0, 1).toUpperCase();
		// 正则表达式，判断首字母是否是英文字母
		if (sortStr.matches("[A-Z]")) {
			return sortStr;
		} else {
			return "#";
		}
	}

}
