package com.cnlaunch.golo.inspection.adapter;

import java.util.List;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.cnlaunch.golo.inspection.model.CarModel;
import com.cnlaunch.golo.wifisettings2.R;

/**
 * @author: ljm
 * @类说明:	
 * @version 1.0
 * @创建时间：2014-12-30 下午3:37:16
 * 
 */
public class VehicleModelAdapter extends BaseAdapter {
	
	private LayoutInflater inflater;
	private List<com.cnlaunch.golo.inspection.model.CarModel> carModels;
	private ViewHolder viewHolder;

	public VehicleModelAdapter(Context context, List<CarModel> carModels) {
		inflater = LayoutInflater.from(context);
		this.carModels = carModels;
	}

	@Override
	public int getCount() {
		return carModels != null && !carModels.isEmpty() ? carModels.size() : 0;
	}

	@Override
	public Object getItem(int position) {
		return carModels.get(position);
	}

	@Override
	public long getItemId(int position) {
		return position;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		if (convertView == null) {
			convertView = inflater.inflate(R.layout.list_simple_txt, parent, false);
			viewHolder = new ViewHolder();
			viewHolder.txtContent = (TextView) convertView.findViewById(R.id.txtContent);
			viewHolder.liner_one = (TextView) convertView.findViewById(R.id.liner_one);
			viewHolder.liner_two = (TextView) convertView.findViewById(R.id.liner_two);
			convertView.setTag(viewHolder);
		} else {
			viewHolder = (ViewHolder) convertView.getTag();
		}
		CarModel model = carModels.get(position);
		viewHolder.txtContent.setText(model.getCarType());
		viewHolder.liner_one.setVisibility(View.VISIBLE);
		viewHolder.liner_two.setVisibility(View.GONE);
		if(position == carModels.size() - 1){
			viewHolder.liner_two.setVisibility(View.VISIBLE);
		}
		return convertView;
	}
	
	private class ViewHolder {
		public TextView txtContent;
		public TextView liner_one;
		public TextView liner_two;
	}

}
