package com.cnlaunch.golo.inspection.logic;

import java.io.File;
import java.nio.charset.Charset;
import java.util.Map;
import java.util.TreeMap;

import android.os.Environment;
import android.os.Handler;
import android.os.Message;

import com.cnlaunch.golo.logger.GoloLog;
import com.lidroid.xutils.HttpUtils;
import com.lidroid.xutils.exception.HttpException;
import com.lidroid.xutils.http.RequestParams;
import com.lidroid.xutils.http.ResponseInfo;
import com.lidroid.xutils.http.callback.RequestCallBack;
import com.lidroid.xutils.http.client.HttpRequest.HttpMethod;
import com.lidroid.xutils.http.client.multipart.HttpMultipartMode;
import com.lidroid.xutils.http.client.multipart.MultipartEntity;

public class DownloadLogic {
	
	private HttpUtils http;
	private static DownloadLogic logic;
	private DownloadLogic(){
		http=new HttpUtils();
	}
	public synchronized static DownloadLogic getInstance(){
		if(logic==null){
			logic=new DownloadLogic();
		}
		return logic;
	}
	public void downloadConfigFile(String cc,String versionDetailId,String productSerialNo,String sign,final Handler handler) {
		RequestParams params=new RequestParams();
		params.addHeader("cc", cc);
//		params.addHeader("versionDetailId", versionDetailId);
//		params.addHeader("productSerialNo", productSerialNo);
		params.addHeader("sign", sign);
		
		
		params.addHeader("Content-Type", String.format("multipart/form-data;boundary=%s", "******"));
		String end = "\r\n";
		String twoHyphens = "--"; // 两个连字符
		String boundary = "******"; // 分界符的字符串
		TreeMap<String, String> map = new TreeMap<String, String>();
		map.put("cc", cc);// CC 号
		map.put("versionDetailId", versionDetailId);// 明细ID
		map.put("productSerialNo", productSerialNo);// 产品序列号
		StringBuilder strBuider = new StringBuilder();
		for (Map.Entry<String, String> entry : map.entrySet()) {
			strBuider.append(twoHyphens + boundary + end);
			strBuider.append("Content-Disposition: form-data;");
			strBuider.append(" name=").append(entry.getKey()).append(end);
			strBuider.append("Content-Type: text/plain; charset=UTF-8").append(end);
			strBuider.append("Content-Transfer-Encoding: 8bit").append(end);
			strBuider.append(end);
			strBuider.append(entry.getValue());
			strBuider.append(end);
		}
		strBuider.append(twoHyphens).append(boundary).append(twoHyphens).append(end);
		params.setBodyEntity(new MultipartEntity(HttpMultipartMode.STRICT, strBuider.toString(), Charset.forName("utf-8")));
		
		
		http.download(HttpMethod.POST,"http://dlcenter.x431.com/diag/downloadEncryptDiagSoft.action", 
				Environment.getExternalStorageDirectory()+"/cnlaunch/golo3/"+productSerialNo+"/CN/ZIP/EUROFORD_V12_20_CN.ZIP",
				params, new RequestCallBack<File>() {
			
			@Override
			public void onLoading(long total, long current, boolean isUploading) {
				Message msg=new Message();
				msg.arg1=2;
				msg.obj="config";
				if(total==456){//xutils每次下载时第一次返回的total和current都是456，为避免进度一开始解释100%，需特殊处理
					msg.what=0;
					
				}else if(total>0){
					float x = (float) current / total;
					float percent = (int) (x * 10000) / (float) 100;
					msg.what=(int) percent;
				}else{
					msg.arg1=1;
				}
				GoloLog.e("...........current........="+current);
				GoloLog.e("...........total........="+total);
				handler.sendMessage(msg);
			}
			@Override
			public void onSuccess(ResponseInfo<File> responseInfo) {
				Message msg1=new Message();
				msg1.arg1=0;
				msg1.obj="config";
				handler.sendMessage(msg1);
			}
			
			@Override
			public void onFailure(HttpException error, String msg) {
				Message msg2=new Message();
				msg2.arg1=1;
				msg2.obj="config";
				handler.sendMessage(msg2);
			}
			
			@Override
			public void onStart() {
				Message msg3=new Message();
				msg3.arg1=3;
				msg3.obj="config";
				handler.sendMessage(msg3);
			}
		});
	}
	public void downloadEOBD(String cc,String versionDetailId,String productSerialNo,String sign,final Handler handler) {
		RequestParams params=new RequestParams();
		params.addHeader("cc", cc);
//		params.addHeader("versionDetailId", versionDetailId);
//		params.addHeader("productSerialNo", productSerialNo);
		params.addHeader("sign", sign);
		
		params.addHeader("Content-Type", String.format("multipart/form-data;boundary=%s", "******"));
		String end = "\r\n";
		String twoHyphens = "--"; // 两个连字符
		String boundary = "******"; // 分界符的字符串
		TreeMap<String, String> map = new TreeMap<String, String>();
		map.put("cc", cc);// CC 号
		map.put("versionDetailId", versionDetailId);// 明细ID
		map.put("productSerialNo", productSerialNo);// 产品序列号
		StringBuilder strBuider = new StringBuilder();
		for (Map.Entry<String, String> entry : map.entrySet()) {
			strBuider.append(twoHyphens + boundary + end);
			strBuider.append("Content-Disposition: form-data;");
			strBuider.append(" name=").append(entry.getKey()).append(end);
			strBuider.append("Content-Type: text/plain; charset=UTF-8").append(end);
			strBuider.append("Content-Transfer-Encoding: 8bit").append(end);
			strBuider.append(end);
			strBuider.append(entry.getValue());
			strBuider.append(end);
		}
		strBuider.append(twoHyphens).append(boundary).append(twoHyphens).append(end);
		params.setBodyEntity(new MultipartEntity(HttpMultipartMode.STRICT, strBuider.toString(), Charset.forName("utf-8")));
		
		//Environment.getExternalStorageDirectory() + "/cnlaunch/golo3/970190023394/CN/CR_VII/VEHICLES/TJTOYOTA/V10.04"
		http.download(HttpMethod.POST,"http://dlcenter.x431.com/diag/downloadEncryptDiagSoft.action", 
				Environment.getExternalStorageDirectory() +"/cnlaunch/golo3/"+productSerialNo+"/CN/ZIP/EUROFORD_V12_20_CN.ZIP", params, new RequestCallBack<File>() {
			
			@Override
			public void onLoading(long total, long current, boolean isUploading) {
				super.onLoading(total, current, isUploading);
				GoloLog.e("...........current........="+current);
				GoloLog.e("...........total........="+total);
				Message msg=new Message();
				msg.arg1=2;
				msg.obj="odb_config";
				if(total==456){//xutils每次下载时第一次返回的total和current都是456，为避免进度一开始解释100%，需特殊处理
					msg.what=0;
					
				}else if(total>0){
					float x = (float) current / total;
					float percent = (int) (x * 10000) / (float) 100;
					msg.what=(int) percent;
				}else{
					msg.arg1=1;
				}
				handler.sendMessage(msg);
			}
			@Override
			public void onSuccess(ResponseInfo<File> responseInfo) {
				Message msg1=new Message();
				msg1.arg1=0;
				msg1.obj="odb_config";
				handler.sendMessage(msg1);
			}
			
			@Override
			public void onFailure(HttpException error, String msg) {
				Message msg2=new Message();
				msg2.arg1=1;
				msg2.obj="odb_config";
				handler.sendMessage(msg2);
			}
			
			@Override
			public void onStart() {
				Message msg3=new Message();
				msg3.arg1=3;
				msg3.obj="odb_config";
				handler.sendMessage(msg3);
			}
		});
	}

}
