/**
 * 项目名称：
 * 包名：  com.cnlaunch.golo3 
 * 文件名：  JSONMsg.java  
 * 功能：  
 * 2014深圳市元征科技股份有限公司-版权所有
 * NO.    Date                      Author     Summary 
 * 001   2014年10月24日-下午3:43:19   韦子龙 
 *
 */
package com.cnlaunch.golo.inspection.model;


import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.cnlaunch.golo.logger.GoloLog;

/**
 * 
 * 类名称:JSONMsg 
 * 类描述: 负责解析JSON数据生成实体对象  已解析code、msg 键值对   (解析具体的消息可继承该类 Override decode方法)	
 * 创建人: 韦子龙 
 * 修改人:
 * 修改人:  
 * 2014年10月24日 下午3:43:19
 * 修改备注:
 * @version 1.0.0
 * 
 */
public class JSONMsg{
	
	public final static String RESPONSE_CODE = "code";
	public final static String RESPONSE_MSG = "msg";
	public final static String RESPONSE_DATA = "data";
	
	public final static int ERROR_CODE_SUCC = 0;
	
	private int code = -1; //结果码

	private String msg; //结果描述
		
	private String data;
	
	private JSONObject jsonObject;
	
	private JSONArray jsonArray;
	private int stateCode;
	
//	private Object entity;
	
	public int getCode() {
		return code;
	}

	public void setCode(int code) {
		this.code = code;
	}

	public String getMsg() {
		return msg;
	}

	public void setMsg(String msg) {
		this.msg = msg;
	}

	public String getData() {
		return data;
	}

	public void setData(String data) {
		this.data = data;
	}

	public JSONObject getJsonObject() {
		return jsonObject;
	}

	public void setJsonObject(JSONObject jsonObject) {
		this.jsonObject = jsonObject;
	}

	public JSONArray getJsonArray() {
		return jsonArray;
	}

	public void setJsonArray(JSONArray jsonArray) {
		this.jsonArray = jsonArray;
	}
	
	public int getStateCode() {
		return stateCode;
	}

	public void setStateCode(int stateCode) {
		this.stateCode = stateCode;
	}

	//	/**
//	 * 设置实体对象
//	 * @param entity 
//	 *void
//	 * @exception 
//	 * @since  1.0.0
//	 */
//	public void setEntity(Object entity) {
//		this.entity = entity;
//	}
//	
//	public Object getEntity() {
//		return entity;
//	}
	public int decode(JSONObject jsonObject) throws JSONException {
		// TODO Auto-generated method stub
		if(jsonObject == null){
			return -1;
		}
		final JSONObject jObject = jsonObject;
		GoloLog.d( "response data:"+ jObject.toString());
		code = jObject.getInt(RESPONSE_CODE);
		if (jObject.has(RESPONSE_MSG)) {
			msg = jObject.getString(RESPONSE_MSG);
		}
		if (jObject.has(RESPONSE_DATA)) {
			if (!jObject.get(RESPONSE_DATA).equals("null") 
					&& !jObject.get(RESPONSE_DATA).equals("")
					&& !jObject.get(RESPONSE_DATA).equals("[]")) {
				if(jObject.get(RESPONSE_DATA) instanceof JSONObject) {
					this.jsonObject = jObject.getJSONObject(RESPONSE_DATA);
				} else if(jObject.get(RESPONSE_DATA) instanceof JSONArray) {
					jsonArray = jObject.getJSONArray(RESPONSE_DATA);
				}else if(jObject.get(RESPONSE_DATA) instanceof String){
					data=jObject.getString(RESPONSE_DATA);
				}else if(jObject.get(RESPONSE_DATA) instanceof Integer){
					data=jObject.getString(RESPONSE_DATA);
				}else if(jObject.get(RESPONSE_DATA) instanceof Boolean){
					data=jObject.getString(RESPONSE_DATA);
				}
			} 
		}
		return 0;
	}
	
	public void decodeString(JSONObject jsonObject) throws JSONException {
		if(jsonObject == null){
			code = -1;
			return ;
		}
		GoloLog.d("response data:"+ jsonObject.toString());
		code = jsonObject.getInt(RESPONSE_CODE);
		if (jsonObject.has(RESPONSE_MSG)) {
			msg = jsonObject.getString(RESPONSE_MSG);
		}
		if (jsonObject.has(RESPONSE_DATA)) {
			data=jsonObject.getString(RESPONSE_DATA);
		}
	}
	
//	/**
//	 *  解码 将JSON数据解析到对象（支持JSONMsg解析多个接口的数据） 不建议将不同的接口数据混在一起
//	 * @param jsonObject JSONObject数据对象
//	 * @param key  接口的key 
//	 * @return
//	 * @throws JSONException 
//	 *int
//	 * @exception 
//	 * @since  1.0.0
//	 */
//	public int decode(JSONObject jsonObject,int key) throws JSONException {
//		// TODO Auto-generated method stub
//		final JSONObject jObject = jsonObject;
//		GoloLog.d(JSONMsg.class.getSimpleName(), "response data:"+ jObject.toString());
//		code = jObject.getString(RESPONSE_CODE);
//		if (jObject.has(RESPONSE_MSG)) {
//			msg = jObject.getString(RESPONSE_MSG);
//		}
//		return 0;
//	}
	
	/**
	 * 根据JSON数据中名称name获取对应的值
	 * @param jsonObject json对象
	 * @param name 名称
	 * @return  名称对应的值
	 * @throws JSONException 
	 *String
	 * @exception 
	 * @since  1.0.0
	 */
	public static Object getMappedValue(JSONObject jsonObject, String name) throws JSONException{
		if (jsonObject != null) {
			if(jsonObject.has(name)){
				return jsonObject.isNull(name)? null:jsonObject.get(name);
			}
		}
		return null;
	}

}
