package com.cnlaunch.golo.inspection.view;

import android.app.Activity;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnKeyListener;
import android.os.Handler;
import android.text.TextUtils;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.cnlaunch.golo.logger.GoloLog;
import com.cnlaunch.golo.wifisettings2.R;

public class GoloProgressDialog {

	
	public static Dialog dialog;
	public static final int cancelDialog = -1000;
	
	public static void showProgressDialog(Context context, int msgId) {
		if(context==null) return;
		showProgressDialog(context, context.getString(msgId));
	}
	
	/**
	 * 
	 * @Title: showProgressDialog   
	 * @Description: TODO(公共加载框)  
	 * @param: @param context
	 * @param: @param msg ("1"代表拼命提交中) （"2"代表玩命加载中）（"0"代表疯狂登录中）    
	 * @return: void     
	 * @throws
	 */
	public static void showProgressDialog(Context context, String msg) {
		if(context !=null && !((Activity)context).isFinishing()){
			//处理 由于上次创建对话框的Context已经结束 ，继续关闭对话引起的异常问题  zilongw 2015.03.07 begin
			if (dialog != null /*&& !dialog.getOwnerActivity().isFinishing()*/ && dialog.isShowing()) {				
				try {
					dialog.dismiss();
				} catch (Exception e) {
					// TODO: handle exception
				}
				dialog = null;
				
			}
			//处理 由于上次创建对话框的Context已经结束 ，继续关闭对话引起的异常问题  zilongw 2015.03.07 end
			dialog = new Dialog(context, R.style.dialog_normal_Dim);
			dialog.show();
			View view = (LinearLayout) LayoutInflater.from(context).inflate(
					R.layout.loading_layout, null);
			dialog.setContentView(view);
			dialog.setCancelable(false);
			dialog.setCanceledOnTouchOutside(false);
			if (!TextUtils.isEmpty(msg)) {
				TextView textView = (TextView) view.findViewById(R.id.tv_progress);
				textView.setText(msg);
			}
		} 
	}

	public static void showProgressDialogCancel(Context context, String msg, final Handler handler) {
		//add: 如果对话框所属的Activity已经finished或者对话框正在显示则直接返回   zilongw 2014.10.09 begin 
		if (context instanceof Activity) {
			if (((Activity)context).isFinishing() || (dialog != null && dialog.isShowing())) {
				return;
			}
		}
		//add: 如果对话框所属的Activity已经finished或者对话框正在显示则直接返回   zilongw 2014.10.09 end
		dialog = new Dialog(context);
		dialog.show();
		View view = LayoutInflater.from(context).inflate(
				R.layout.loading_layout, null);
		dialog.setContentView(view);
		dialog.setCanceledOnTouchOutside(false);
		if (null != msg) {
			TextView textView = (TextView) view.findViewById(R.id.tv_progress);
			textView.setText(msg);
		}
		dialog.setOnKeyListener(new OnKeyListener() {
			
			@Override
			public boolean onKey(DialogInterface dialog, int keyCode, KeyEvent event) {
				if(keyCode == KeyEvent.KEYCODE_BACK && event.getRepeatCount()==0)
                {
                    dialog.dismiss();
                    handler.sendEmptyMessage(cancelDialog);
                }
                return false;
			}
		});
	}
	
	public static boolean dismissProgressDialog(Context context) {
		if (dialog != null && dialog.isShowing()) {
			//modify: 添加异常处理  所属的窗口已经finished后继续关闭对话框会出现异常 zilongw  2014.08.13 begin
			try {
				dialog.dismiss();
				return true;
			} catch (Exception e) {
				// TODO: handle exception
				GoloLog.e( "dismiss this progressDialog Error." + e.getMessage());
			}
			//modify: 添加异常处理  所属的窗口已经finished后继续关闭对话框会出现异常 zilongw  2014.08.13 end
		}
		return false;
	}

}