package com.cnlaunch.golo.inspection.view;

import android.content.Context;
import android.util.AttributeSet;
import android.widget.EditText;

/**
 * @className: LcEditText (LaunchEditText缩写)
 * @discription: 自定义EditText，替换xml文件中传入hint
 * @author: zenghaigeng
 * @time: 2015年04月07日 下午13:40:13
 */
public class LcEditText extends EditText {

	public LcEditText(Context context) {
		super(context);
	}

	public LcEditText(Context context, AttributeSet attrs) {
		super(context, attrs);
		setDefaultHint(context, attrs);
	}
	
	public LcEditText(Context context, AttributeSet attrs, int defStyle) {
		super(context, attrs, defStyle);
		setDefaultHint(context, attrs);
	}
	
	/**
	 * @title: setDefaultHint
	 * @discription: 设置默认提示语
	 * @param: context 容器
	 * @param: attrs 属性集合
	 */
	private void setDefaultHint(Context context, AttributeSet attrs) {
		if(LcResources.rs == null || getHint() == null) return;
		for(int i = 0; i<attrs.getAttributeCount(); i++) {
			if(attrs.getAttributeName(i).equals("hint")) {
				try {
					setHint(LcResources.getResourceText(context, attrs, i));
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}
	}
}
