package com.cnlaunch.golo.inspection.view;

import android.app.Dialog;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout.LayoutParams;
import android.widget.TextView;

import com.cnlaunch.golo.wifisettings2.R;

/**
 * FileName: NormalDialog.java
 * 
 * @Description: TODO(普通确定和取消弹出框) All rights Reserved, Designed By Golo
 *               Copyright: Copyright(C) 2014-2020 Company Golo.
 * @author: liujiaqing
 * @version V1.0 Createdate: 2014年12月4日 下午5:11:03
 * 
 *          Modification History: Date Author Version Discription
 * 
 *          2014年12月4日 wu.zh 1.0 1.0 Why & What is modified: <修改原因描述>
 */
public class NormalDialog extends Dialog implements OnClickListener {

	private Button cancleBtn, okBtn;
	private TextView title, content;
	private ImageView closeImage;
	private OnClickItemListen clickItemListen;

	/**
	 * @Title: NormalDialog
	 * @Description: TODO(初始化)
	 * @param: @param context
	 * @param: @param titleTxt 标题字符串
	 * @param: @param contentTxt 内容字符串
	 * @param: @param leftbtnTxt 左边按钮字符串
	 * @param: @param rightTxt 右边按钮字符串
	 * @throws
	 */
	public NormalDialog(Context context, String titleTxt, String contentTxt,
			String leftbtnTxt, String rightTxt) {
		super(context);
		// TODO Auto-generated constructor stub
		View winView = LayoutInflater.from(context).inflate(
				R.layout.normal_dialog, null);
		cancleBtn = (Button) winView.findViewById(R.id.cancle);
		okBtn = (Button) winView.findViewById(R.id.ok);
		title = (TextView) winView.findViewById(R.id.title);
		content = (TextView) winView.findViewById(R.id.content);
		closeImage=(ImageView)winView.findViewById(R.id.suggested_dialog_img_close);
		if (titleTxt != null && titleTxt.length() > 0) {
			title.setText(titleTxt);
		} else {
			title.setVisibility(View.GONE);
		}
		if (contentTxt != null && contentTxt.length() > 0) {
			content.setText(contentTxt);
		}
		if (leftbtnTxt != null && leftbtnTxt.length() > 0) {
			cancleBtn.setText(leftbtnTxt);
		} else {
			cancleBtn.setVisibility(View.GONE);
		}
		if (rightTxt != null && rightTxt.length() > 0) {
			okBtn.setText(rightTxt);
		}
		okBtn.setOnClickListener(this);
		cancleBtn.setOnClickListener(this);
		closeImage.setOnClickListener(this);
		setCanceledOnTouchOutside(false);
		this.requestWindowFeature(Window.FEATURE_NO_TITLE);
		this.setContentView(winView);
		// this.setCanceledOnTouchOutside(false);
		// this.setCancelable(false);
		this.getWindow().setBackgroundDrawableResource(
				android.R.color.transparent);
		WindowManager wm = (WindowManager) context
                .getSystemService(Context.WINDOW_SERVICE);
		int width = wm.getDefaultDisplay().getWidth() * 9 / 10;
		WindowManager.LayoutParams params = this.getWindow().getAttributes();
		params.width = width;
		params.height = LayoutParams.WRAP_CONTENT;
		this.getWindow().setAttributes(params);
		this.show();
	}

	public interface OnClickItemListen {
		public void leftClick();

		public void rightClick();
	}

	public Button getOkButton() {
        return okBtn;
    }
	
	public Button getCancelButton() {
        return cancleBtn;
    }
	
	public TextView getContent() {
        return content;
    }
	
	public OnClickItemListen getClickItemListen() {
		return clickItemListen;
	}

	public void setClickItemListen(OnClickItemListen clickItemListen) {
		this.clickItemListen = clickItemListen;
	}

	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		int id = v.getId();
		if (id == R.id.cancle) {
			clickItemListen.leftClick();
		} else if(id==R.id.ok) {
			clickItemListen.rightClick();
		}else{
			cancel();
		}
	}

	public ImageView getCloseImage() {
		return closeImage;
	}

	public void setCloseImage(ImageView closeImage) {
		this.closeImage = closeImage;
	}
}
