package com.cnlaunch.golo.inspection.view;

import java.util.Arrays;
import java.util.List;
import java.util.Locale;

import android.annotation.SuppressLint;
import android.content.Context;
import android.content.res.TypedArray;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Paint.Style;
import android.graphics.Typeface;
import android.graphics.drawable.Drawable;
import android.os.Build;
import android.os.Parcel;
import android.os.Parcelable;
import android.support.v4.view.PagerAdapter;
import android.support.v4.view.ViewPager;
import android.support.v4.view.ViewPager.OnPageChangeListener;
import android.util.AttributeSet;
import android.util.DisplayMetrics;
import android.util.SparseArray;
import android.util.TypedValue;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewTreeObserver.OnGlobalLayoutListener;
import android.widget.HorizontalScrollView;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.cnlaunch.golo.wifisettings2.R;

public class PagerSlidingTabStrip extends HorizontalScrollView {

	/**
	 * 
	 * @ClassName: IconTabProvider
	 * @Description: TODO 实现该接口 创建 带有图片的 tabs
	 * @author: liyao
	 * @date: 2014-11-18 下午3:41:19
	 * 
	 */
	public interface IconTabProvider {
		public int getPageIconResId(int position);
	}
	public SparseArray<LinearLayout> getTabView(){
		return frameLayout;
	}
	private SparseArray<LinearLayout> frameLayout = new SparseArray<LinearLayout>();

	/**
	 * 
	 * @ClassName: MessageTagProvider
	 * @Description: TODO 实现该接口 创建 带消息个数和消息点提醒 tabs
	 * @author: liyao
	 * @date: 2014-11-18 下午3:42:19
	 * 
	 */
	public interface MessageTagProvider {
		 
	}

	public interface IcoTextTab {
		public View getView(int positon, ViewGroup parent);
	}

	/**
	 * 
	 * @ClassName: OnTabClickable
	 * @Description: TODO(监听tab的点击事件 有需要的实现这个接口)
	 * @author: xiangshilong
	 * @date: 2014年11月19日 上午9:18:37
	 * 
	 */
	public interface OnTabClickable {
		public void tabClick(int id);
	}

	private OnTabClickable tabClick;

	// @formatter:off
	private static final int[] ATTRS = new int[] { android.R.attr.textSize, android.R.attr.textColor };
	// @formatter:on

	private LinearLayout.LayoutParams defaultTabLayoutParams;
	private LinearLayout.LayoutParams expandedTabLayoutParams;

	private final PageListener pageListener = new PageListener();
	public OnPageChangeListener delegatePageListener;

	private LinearLayout tabsContainer;
	private ViewPager pager;
	
	//add xlc 判断是否手动控制选择ViewPager; 
	boolean  isScroll=true; 

	private int tabCount;

	private int currentPosition = 0;
	private int selectedPosition = 0;
	private float currentPositionOffset = 0f;

	private Paint rectPaint;
	private Paint dividerPaint;

	private int indicatorColor =0xFF1CB2A7;
	private int underlineColor = 0x1A000000;
	private int dividerColor = 0x1A000000;

	private boolean shouldExpand = true;
	private boolean textAllCaps = true;

	private int scrollOffset = 52;
	private int indicatorHeight = 4;
	private int underlineHeight = 1;
	private int dividerPadding = 12;
	private int tabPadding = 5;
	private int dividerWidth = 1;

	private int tabTextSize = 12;
	private int tabTextColor = 0xFF666666;
	private int selectedTabTextColor = 0xFF1CB2A7;
	private Typeface tabTypeface = null;
	private int tabTypefaceStyle = Typeface.BOLD;
	private int lastScrollX = 0;
	private int tabBackgroundResId = R.drawable.background_tab;
	private Locale locale;

	private boolean isDivider = false;

	/**
	 * 控制一页显示几个TAB。不设置自适应
	 */
	private int pageLen=4;
	
	
	public PagerSlidingTabStrip(Context context) {
		this(context, null);
	}

	public PagerSlidingTabStrip(Context context, AttributeSet attrs) {
		this(context, attrs, 0);
	}

	public PagerSlidingTabStrip(Context context, AttributeSet attrs, int defStyle) {
		super(context, attrs, defStyle);

		setFillViewport(true);
		setWillNotDraw(false);

		tabsContainer = new LinearLayout(context);
		tabsContainer.setOrientation(LinearLayout.HORIZONTAL);
		tabsContainer.setLayoutParams(new LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT));
		addView(tabsContainer);

		DisplayMetrics dm = getResources().getDisplayMetrics();

		scrollOffset = (int) TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, scrollOffset, dm);
		indicatorHeight = (int) TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, indicatorHeight, dm);
		underlineHeight = (int) TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, underlineHeight, dm);
		dividerPadding = (int) TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, dividerPadding, dm);
		tabPadding = (int) TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, tabPadding, dm);
		dividerWidth = (int) TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, dividerWidth, dm);
		tabTextSize = (int) TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_SP, tabTextSize, dm);

		// get system attrs (android:textSize and android:textColor)

		TypedArray a = context.obtainStyledAttributes(attrs, ATTRS);

		tabTextSize = a.getDimensionPixelSize(0, tabTextSize);
		tabTextColor = a.getColor(1, tabTextColor);

		a.recycle();

		// get custom attrs

		a = context.obtainStyledAttributes(attrs, R.styleable.PagerSlidingTabStrip);

//		indicatorColor = a.getColor(R.styleable.PagerSlidingTabStrip_pstsIndicatorColor, indicatorColor);
		underlineColor = a.getColor(R.styleable.PagerSlidingTabStrip_pstsUnderlineColor, underlineColor);
//		indicatorColor=getResources().getColor(R.color.green_normal);
		int greenColor=getResources().getColor(R.color.green_text_color);
		indicatorColor=greenColor;
		selectedTabTextColor=greenColor;
		
		dividerColor = a.getColor(R.styleable.PagerSlidingTabStrip_pstsDividerColor, dividerColor);
		indicatorHeight = a.getDimensionPixelSize(R.styleable.PagerSlidingTabStrip_pstsIndicatorHeight, indicatorHeight);
		underlineHeight = a.getDimensionPixelSize(R.styleable.PagerSlidingTabStrip_pstsUnderlineHeight, underlineHeight);
		dividerPadding = a.getDimensionPixelSize(R.styleable.PagerSlidingTabStrip_pstsDividerPadding, dividerPadding);
		tabPadding = a.getDimensionPixelSize(R.styleable.PagerSlidingTabStrip_pstsTabPaddingLeftRight, tabPadding);
		tabBackgroundResId = a.getResourceId(R.styleable.PagerSlidingTabStrip_pstsTabBackground, tabBackgroundResId);
		shouldExpand = a.getBoolean(R.styleable.PagerSlidingTabStrip_pstsShouldExpand, shouldExpand);
		scrollOffset = a.getDimensionPixelSize(R.styleable.PagerSlidingTabStrip_pstsScrollOffset, scrollOffset);
		textAllCaps = a.getBoolean(R.styleable.PagerSlidingTabStrip_pstsTextAllCaps, textAllCaps);
		a.recycle();

		rectPaint = new Paint();
		rectPaint.setAntiAlias(true);
		rectPaint.setStyle(Style.FILL);

		dividerPaint = new Paint();
		dividerPaint.setAntiAlias(true);
		dividerPaint.setStrokeWidth(dividerWidth);

		defaultTabLayoutParams = new LinearLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.MATCH_PARENT);
		expandedTabLayoutParams = new LinearLayout.LayoutParams(0, LayoutParams.MATCH_PARENT, 1.0f);

		if (locale == null) {
			locale = getResources().getConfiguration().locale;
		}
	}

	public void setViewPager(ViewPager pager) {
		this.pager = pager;

		if (pager.getAdapter() == null) {
			throw new IllegalStateException("ViewPager does not have adapter instance.");
		}

		pager.setOnPageChangeListener(pageListener);

		notifyDataSetChanged();
	}

	/**
	 * 
	 * @Title: setViewTitle
	 * @Description: TODO(滑动tab中，地图应用时不需要滑动，只需要点击调用的方法)
	 *               使用PagerLidingTabStrip是需要注意
	 *               ：不能使用FrameLayout作为最外层节点，否则tab会不能适配
	 * @param: @param title
	 * @param: @param callBack
	 * @return: void
	 * @throws
	 */
	public void setViewTitle(List<String> title, OnTabClickable callBack) {
		if (null == title) {
			return;
		}
		tabsContainer.removeAllViews();
		tabCount = title.size();
		for (int i = 0; i < title.size(); i++) {
			addMessageTab(i, title.get(i));
//			addTextTab(i, title.get(i));
		}

		this.tabClick = callBack;

		updateTabStyles();
	}

	/**
	 * 
	 * @Title: setViewTitle
	 * @Description: TODO(滑动tab中，地图应用时不需要滑动，只需要点击调用的方法)
	 *               使用PagerLidingTabStrip是需要注意
	 *               ：不能使用FrameLayout作为最外层节点，否则tab会不能适配
	 * @param: @param title
	 * @param: @param callBack
	 * @return: void
	 * @throws
	 */
	public void setViewTitle(int tabArrayId, OnTabClickable callBack) {
		List<String> title = Arrays.asList(getResources().getStringArray(tabArrayId));
		if (null == title) {
			return;
		}
		tabsContainer.removeAllViews();
		tabCount = title.size();
		for (int i = 0; i < title.size(); i++) {
//			addTextTab(i, title.get(i));
			addMessageTab(i, title.get(i));
		}

		this.tabClick = callBack;

		updateTabStyles();
	}

	public void setOnPageChangeListener(OnPageChangeListener listener) {
		this.delegatePageListener = listener;
	}

	public void notifyDataSetChanged() {
		tabsContainer.removeAllViews();
		PagerAdapter mAdapter = pager.getAdapter();
		tabCount = mAdapter.getCount();
		for (int i = 0; i < tabCount; i++) {
			if (mAdapter instanceof IconTabProvider) {
				addIconTab(i, ((IconTabProvider) mAdapter).getPageIconResId(i));
			} else if (mAdapter instanceof MessageTagProvider) {
				addMessageTab(i, mAdapter.getPageTitle(i).toString());
			} else if (mAdapter instanceof IcoTextTab) {
				View myView = ((IcoTextTab) mAdapter).getView(i, tabsContainer);
				addTab(i, myView);
			} else {
				addTextTab(i, mAdapter.getPageTitle(i).toString());
			}
		}

		updateTabStyles();

		getViewTreeObserver().addOnGlobalLayoutListener(new OnGlobalLayoutListener() {

			@SuppressWarnings("deprecation")
			@SuppressLint("NewApi")
			@Override
			public void onGlobalLayout() {

				if (Build.VERSION.SDK_INT < Build.VERSION_CODES.JELLY_BEAN) {
					getViewTreeObserver().removeGlobalOnLayoutListener(this);
				} else {
					getViewTreeObserver().removeOnGlobalLayoutListener(this);
				}

				currentPosition = pager.getCurrentItem();
				scrollToChild(currentPosition, 0);
			}
		});

	}

	private void addTextTab(final int position, String title) {

		TextView tab = new TextView(getContext());
		tab.setText(title);
		tab.setGravity(Gravity.CENTER);
		tab.setSingleLine();
		tab.setTextSize(TypedValue.COMPLEX_UNIT_SP, 14);
		addTab(position, tab);
	}

	private void addIconTab(final int position, int resId) {

		ImageButton tab = new ImageButton(getContext());
		tab.setImageResource(resId);

		addTab(position, tab);

	}
	
	private void addMessageTab(final int position, String title) {
		LinearLayout linear = new LinearLayout(getContext());
		linear.setOrientation(LinearLayout.HORIZONTAL);
		linear.setGravity(Gravity.CENTER);
		LinearLayout.LayoutParams params = new LinearLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
		params.gravity=Gravity.CENTER;
		TextView tab = new TextView(getContext());
		tab.setText(title);
		tab.setTextSize(TypedValue.COMPLEX_UNIT_SP, 14);
		tab.setGravity(Gravity.CENTER);
		tab.setSingleLine();
		linear.addView(tab, params);
		
		params = new LinearLayout.LayoutParams(dip2px(20),dip2px(20));
		params.gravity=Gravity.CENTER;
		params.leftMargin=5;
		TextView tabMess = new TextView(getContext());
		tabMess.setSingleLine();
		tabMess.setTextSize(TypedValue.COMPLEX_UNIT_SP, 12);
		tabMess.setGravity(Gravity.CENTER);
		tabMess.setVisibility(View.GONE);
		linear.addView(tabMess, params);
		
		frameLayout.put(position, linear);
		addTab(position, linear);
	}
	public  int dip2px(float dpValue) {
		return (int) (dpValue * (getContext().getResources().getDisplayMetrics().density )+ 0.5f);
	}
	private void addTab(final int position, View tab) {
		tab.setFocusable(true);
		tab.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				if (null != tabClick) {
					tabClick.tabClick(position);
				}

				if (null != pager&&isScroll) {
					pager.setCurrentItem(position);
				} else {
					currentPosition = position;
					selectedPosition = position;
					scrollToChild(currentPosition, 0);
					updateTabStyles();
					invalidate();
				}
			}
		});

		tab.setPadding(tabPadding, 0, tabPadding, 0);
		tabsContainer.addView(tab, position, shouldExpand ? expandedTabLayoutParams : defaultTabLayoutParams);
	}

	private void updateTabStyles() {

		for (int i = 0; i < tabCount; i++) {

			View v = tabsContainer.getChildAt(i);

			v.setBackgroundResource(tabBackgroundResId);

			if (v instanceof TextView) {

				TextView tab = (TextView) v;
				// tab.setTextSize(TypedValue.COMPLEX_UNIT_PX, tabTextSize);
				// tab.setTypeface(tabTypeface, tabTypefaceStyle);
				tab.setTextColor(tabTextColor);

				// setAllCaps() is only available from API 14, so the upper case
				// is made manually if we are on a
				// pre-ICS-build
//				if (textAllCaps) {
//					if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.ICE_CREAM_SANDWICH) {
//						tab.setAllCaps(true);
//					} else {
//						tab.setText(tab.getText().toString().toUpperCase(locale));
//					}
//				}
				if (i == selectedPosition) {
					tab.setTextColor(selectedTabTextColor);
				}
			}

			/**
			 * add by xiangshilong 设置头部滑动标题选中颜色（头部标题为LinearLayout）
			 * 
			 */
			if (i == selectedPosition) {
				View selectView = tabsContainer.getChildAt(i);
				if (selectView instanceof LinearLayout) {
					View childView = ((LinearLayout) selectView).getChildAt(0);
					if (childView instanceof TextView) {
						TextView textView = (TextView) childView;
						textView.setTextColor(selectedTabTextColor);
					}
					/*
					 * LinearLayout ll = (LinearLayout)selectView; for (int j =
					 * 0; j < ll.getChildCount(); j++) { View childView =
					 * ((LinearLayout) selectView).getChildAt(j); if(childView
					 * instanceof TextView){ TextView textView =
					 * (TextView)childView;
					 * textView.setTextColor(selectedTabTextColor); } }
					 */
				}
			} else {
				View selectView = tabsContainer.getChildAt(i);
				if (selectView instanceof LinearLayout) {
					View childView = ((LinearLayout) selectView).getChildAt(0);
					if (childView instanceof TextView) {
						TextView textView = (TextView) childView;
						textView.setTextColor(tabTextColor);
					}
					// for (int j = 0; j < ll.getChildCount(); j++) {
					// View childView = ((LinearLayout)
					// selectView).getChildAt(j);
					// if(childView instanceof TextView){
					// TextView textView = (TextView)childView;
					// textView.setTextColor(tabTextColor);
					// }
					// }
				}
			}
		}

	}

	private void scrollToChild(int position, int offset) {

		if (tabCount == 0) {
			return;
		}

		//update ljm 2014-12-24 start 添加非空判断
		if (tabsContainer.getChildAt(position) != null) {
			int newScrollX = tabsContainer.getChildAt(position).getLeft() + offset;

			if (position > 0 || offset > 0) {
				newScrollX -= scrollOffset;
			}

			if (newScrollX != lastScrollX) {
				lastScrollX = newScrollX;
				scrollTo(newScrollX, 0);
			}
		}
		// update ljm 2014-12-24 start 添加非空判断

	}

	@Override
	protected void onDraw(Canvas canvas) {
		super.onDraw(canvas);

		if (isInEditMode() || tabCount == 0) {
			return;
		}

		final int height = getHeight();
		// draw underline

		rectPaint.setColor(underlineColor);
		canvas.drawRect(0, height - underlineHeight, tabsContainer.getWidth(), height, rectPaint);

		// draw indicator line

		rectPaint.setColor(indicatorColor);

		// default: line below current tab
		View currentTab = tabsContainer.getChildAt(currentPosition);
		if (currentTab==null) {
			return;
		}
		float lineLeft = currentTab.getLeft();
		float lineRight = currentTab.getRight();

		// if there is an offset, start interpolating left and right coordinates
		// between current and next tab
		if (currentPositionOffset > 0f && currentPosition < tabCount - 1) {

			View nextTab = tabsContainer.getChildAt(currentPosition + 1);
			final float nextTabLeft = nextTab.getLeft();
			final float nextTabRight = nextTab.getRight();

			lineLeft = (currentPositionOffset * nextTabLeft + (1f - currentPositionOffset) * lineLeft);
			lineRight = (currentPositionOffset * nextTabRight + (1f - currentPositionOffset) * lineRight);
		}

		canvas.drawRect(lineLeft, height - indicatorHeight, lineRight, height, rectPaint);

		// draw divider
		if (isDivider) {
			dividerPaint.setColor(dividerColor);
			for (int i = 0; i < tabCount - 1; i++) {
				View tab = tabsContainer.getChildAt(i);
				canvas.drawLine(tab.getRight(), dividerPadding, tab.getRight(), height - dividerPadding, dividerPaint);
			}
		}
	}

	private class PageListener implements OnPageChangeListener {

		@Override
		public void onPageScrolled(int position, float positionOffset, int positionOffsetPixels) {
			currentPosition = position;
			currentPositionOffset = positionOffset;

			// update ljm 2014-12-23 start 添加子项个数判断，防止NullPointerException问题
			if (tabsContainer != null && tabsContainer.getChildCount() > 0) {
				scrollToChild(position, (int) (positionOffset * tabsContainer.getChildAt(position).getWidth()));
				
				invalidate();
				
				if (delegatePageListener != null) {
					delegatePageListener.onPageScrolled(position, positionOffset, positionOffsetPixels);
				}
			}
			// update ljm 2014-12-23 end 添加子项个数判断，防止NullPointerException问题
		}

		@Override
		public void onPageScrollStateChanged(int state) {
			if (state == ViewPager.SCROLL_STATE_IDLE) {
				scrollToChild(pager.getCurrentItem(), 0);
			}

			if (delegatePageListener != null) {
				delegatePageListener.onPageScrollStateChanged(state);
			}
		}

		@Override
		public void onPageSelected(int position) {
			selectedPosition = position;
			updateTabStyles();
			if (delegatePageListener != null) {
				delegatePageListener.onPageSelected(position);
			}
		}

	}

	public void setTabClick(OnTabClickable tabClick) {
		this.tabClick = tabClick;
	}

	/**
	 * 
	 * @Title: setIndicatorColor
	 * @Description: TODO 滑动线的 颜色
	 * @param: indicatorColor 颜色值
	 * @return: void
	 */
	public void setIndicatorColor(int indicatorColor) {
		this.indicatorColor = indicatorColor;
		invalidate();
	}

	/**
	 * 
	 * @Title: setIndicatorColor
	 * @Description: TODO 滑动线的 颜色
	 * @param: resId 颜色值 资源ID
	 * @return: void
	 */
	public void setIndicatorColorResource(int resId) {
		this.indicatorColor = getResources().getColor(resId);
		invalidate();
	}

	public int getIndicatorColor() {
		return this.indicatorColor;
	}

	/**
	 * @Title: setIndicatorHeight
	 * @Description: TODO 设置滑动线 的高度
	 * @param: indicatorLineHeightPx 高度值
	 */
	public void setIndicatorHeight(int indicatorLineHeightPx) {
		this.indicatorHeight = indicatorLineHeightPx;
		invalidate();
	}

	public int getIndicatorHeight() {
		return indicatorHeight;
	}

	/**
	 * 
	 * @Title: setUnderlineColor
	 * @Description: TODO 设置tabs与内容的 分割线 颜色
	 * @param: underlineColor 分割线 颜色值
	 */
	public void setUnderlineColor(int underlineColor) {
		this.underlineColor = underlineColor;
		invalidate();
	}

	/**
	 * 
	 * @Title: setUnderlineColor
	 * @Description: TODO 设置tabs与内容的 分割线 颜色
	 * @param: resId 分割线 颜色值资源
	 */
	public void setUnderlineColorResource(int resId) {
		this.underlineColor = getResources().getColor(resId);
		invalidate();
	}

	public int getUnderlineColor() {
		return underlineColor;
	}

	/**
	 * @Title: setDivider
	 * @Description: TODO 设置tab之间是否有分割线
	 * @param: isDivider
	 * @throws
	 */
	public void setDivider(boolean isDivider) {
		this.isDivider = isDivider;
		invalidate();
	}

	/**
	 * 
	 * @Title: setDividerColor
	 * @Description: TODO 设置tab之间分割线颜色值.需要设置 {@link setDivider}
	 * @param: dividerColor tab之间分割线颜色值
	 */
	public void setDividerColor(int dividerColor) {
		this.dividerColor = dividerColor;
		invalidate();
	}

	/**
	 * 
	 * @Title: setDividerColor
	 * @Description: 设置tab之间分割线颜色值.需要设置 {@link setDivider}
	 * @param: resId tab之间分割线颜色值 资源
	 */
	public void setDividerColorResource(int resId) {
		this.dividerColor = getResources().getColor(resId);
		invalidate();
	}

	public int getDividerColor() {
		return dividerColor;
	}

	/**
	 * @Title: setUnderlineHeight
	 * @Description: TODO 设置tabs与内容的 分割线 高度
	 * @param: underlineHeightPx
	 */
	public void setUnderlineHeight(int underlineHeightPx) {
		this.underlineHeight = underlineHeightPx;
		invalidate();
	}

	public int getUnderlineHeight() {
		return underlineHeight;
	}

	/**
	 * @Title: setDividerPadding
	 * @Description: TODO tab之间分割线间距 {@link setDivider}
	 * @param: @param dividerPaddingPx
	 */
	public void setDividerPadding(int dividerPaddingPx) {
		this.dividerPadding = dividerPaddingPx;
		invalidate();
	}

	public int getDividerPadding() {
		return dividerPadding;
	}

	public void setScrollOffset(int scrollOffsetPx) {
		this.scrollOffset = scrollOffsetPx;
		invalidate();
	}

	public int getScrollOffset() {
		return scrollOffset;
	}

	/**
	 * 
	 * @Title: setShouldExpand
	 * @Description: TODO 设置是否 使用扩展的TAB,默认为true(适用于TAB内容过多)
	 * @param: shouldExpand
	 * @throws
	 */
	public void setShouldExpand(boolean shouldExpand) {
		this.shouldExpand = shouldExpand;
		if (null != pager) {
			notifyDataSetChanged();
		}
	}

	public boolean getShouldExpand() {
		return shouldExpand;
	}

	public boolean isTextAllCaps() {
		return textAllCaps;
	}

	public void setAllCaps(boolean textAllCaps) {
		this.textAllCaps = textAllCaps;
	}

	/**
	 * 
	 * @Title: setTextSize
	 * @Description: TODO设置TAB size的大小
	 * @param: textSizePx
	 */
	public void setTextSize(int textSizePx) {
		this.tabTextSize = textSizePx;
		updateTabStyles();
	}
	
	/**
	 * 设置指定界面为选择界面
	 * @param index
	 */
	public void setCurrentTabs(int index){
		currentPosition = index;
		selectedPosition = index;
		updateTabStyles();
	}

	public int getTextSize() {
		return tabTextSize;
	}

	public void setTextColor(int textColor) {
		this.tabTextColor = textColor;
		updateTabStyles();
	}

	public void setTextColorResource(int resId) {
		this.tabTextColor = getResources().getColor(resId);
		updateTabStyles();
	}

	public int getTextColor() {
		return tabTextColor;
	}

	public void setSelectedTextColor(int textColor) {
		this.selectedTabTextColor = textColor;
		updateTabStyles();
	}

	public void setSelectedTextColorResource(int resId) {
		this.selectedTabTextColor = getResources().getColor(resId);
		updateTabStyles();
	}

	public int getSelectedTextColor() {
		return selectedTabTextColor;
	}

	/**
	 * @Title: setTypeface
	 * @Description: TODO 定义tabs的样式
	 * @param: typeface
	 * @param: style
	 * @return: void
	 */
	public void setTypeface(Typeface typeface, int style) {
		this.tabTypeface = typeface;
		this.tabTypefaceStyle = style;
		updateTabStyles();
	}

	public void setTabBackground(int resId) {
		this.tabBackgroundResId = resId;
		updateTabStyles();
	}

	public int getTabBackground() {
		return tabBackgroundResId;
	}

	public void setTabPaddingLeftRight(int paddingPx) {
		this.tabPadding = paddingPx;
		updateTabStyles();
	}

	public int getTabPaddingLeftRight() {
		return tabPadding;
	}

	@Override
	public void onRestoreInstanceState(Parcelable state) {
		SavedState savedState = (SavedState) state;
		super.onRestoreInstanceState(savedState.getSuperState());
		currentPosition = savedState.currentPosition;
		requestLayout();
	}

	@Override
	public Parcelable onSaveInstanceState() {
		Parcelable superState = super.onSaveInstanceState();
		SavedState savedState = new SavedState(superState);
		savedState.currentPosition = currentPosition;
		return savedState;
	}

	static class SavedState extends BaseSavedState {
		int currentPosition;

		public SavedState(Parcelable superState) {
			super(superState);
		}

		private SavedState(Parcel in) {
			super(in);
			currentPosition = in.readInt();
		}

		@Override
		public void writeToParcel(Parcel dest, int flags) {
			super.writeToParcel(dest, flags);
			dest.writeInt(currentPosition);
		}

		public static final Parcelable.Creator<SavedState> CREATOR = new Parcelable.Creator<SavedState>() {
			@Override
			public SavedState createFromParcel(Parcel in) {
				return new SavedState(in);
			}

			@Override
			public SavedState[] newArray(int size) {
				return new SavedState[size];
			}
		};
	}

	/**
	 * @Title: setCurrentPage
	 * @Description: TODO(这里用一句话描述这个方法的作用)
	 * @param: @param position
	 */
	public void setCurrentPage(final int position) {
		if (pager == null || position < 0)
			return;
		pager.setCurrentItem(position);
		getViewTreeObserver().addOnGlobalLayoutListener(new OnGlobalLayoutListener() {
			@SuppressWarnings("deprecation")
			@SuppressLint("NewApi")
			@Override
			public void onGlobalLayout() {
				if (Build.VERSION.SDK_INT < Build.VERSION_CODES.JELLY_BEAN) {
					getViewTreeObserver().removeGlobalOnLayoutListener(this);
				} else {
					getViewTreeObserver().removeOnGlobalLayoutListener(this);
				}
				currentPosition = position;
				scrollToChild(currentPosition, 0);
			}
		});
	}
	
	/**
	 * add xlc
	 * 修改指定tab 的文字
	 * @param index
	 * @param text
	 */
	public void setTabText(int index, String text) {
		TextView v = (TextView) tabsContainer.getChildAt(index);
		v.setText(text);
	}
	
	public void  setScrllo(boolean is){
		isScroll=is;
	}
	
	
	/**
	 * add xlc
	 * 在指定Tab的右边加图标
	 * @param index
	 * @param text
	 */
	public void setTabTextIcon(int drawable,int index) {
		TextView v = (TextView) tabsContainer.getChildAt(index);
		 Drawable d= getResources().getDrawable(drawable);
		 d.setBounds(0, 0, 0, 0);
		v.setCompoundDrawablesWithIntrinsicBounds(null, null, getResources().getDrawable(drawable), null);
		
	}
	
	
	
	/**
	 * add by pjy
	 * 修改带图标的tab文字，每个tab必须是LinearLayout
	 * @param index	tab下表
	 * @param pos	对应tab中修改哪个位置上的文字
	 * @param text	修改的文字
	 */
	public void setTabLayoutText(int index, int pos, String text){
		LinearLayout tabLayout = (LinearLayout) tabsContainer.getChildAt(index);
		TextView v = (TextView) tabLayout.getChildAt(pos);
		v.setText(text);
	}
	
	/**
	 * add by zhujiang
	 * 获取tab文字，每个tab必须是LinearLayout
	 * @param index	tab下表
	 * @param pos	对应tab中哪个位置上的文字
	 */
	public String getTabLayoutText(int index, int pos){
		LinearLayout tabLayout = (LinearLayout) tabsContainer.getChildAt(index);
		TextView v = (TextView) tabLayout.getChildAt(pos);
		return "" + v.getText();
	}
	
	/**
	 * * add by txw
	 * 显示消息数，每个tab必须是LinearLayout
	 * @param index	tab下标
	 * @param pos	对应tab中修改哪个位置上的控件
	 * @param: count 消息数      
	 * @return: void     
	 * @throws
	 */
	public void setTabLayoutMsgCount(int index, int pos, int count){
		LinearLayout tabLayout = (LinearLayout) tabsContainer.getChildAt(index);
		if(tabLayout != null){
			TextView v = (TextView) tabLayout.getChildAt(pos);
			if (count > 0) {
				v.setVisibility(View.VISIBLE);
				if (count > 99) {
					v.setText("99+");
				} else {  
					v.setText(String.valueOf(count));
				}
			} else {
				v.setVisibility(View.GONE);
			}
		}
	}

	public void setMessageCount(int position, int count,int... bgResId) {
		SparseArray<LinearLayout> pagerLinearLayout = getTabView();
		LinearLayout linear = null;
		if ((linear = pagerLinearLayout.get(position)) != null) {
			String mess = "";
			if (count >= 99) {
				mess = "99+";
			} else {
				mess = count + "";
			}
			TextView tvw = (TextView) linear.getChildAt(1);
			if(tvw!=null){ 
				if(count!=0){
					LinearLayout.LayoutParams 	params =(LinearLayout.LayoutParams)tvw.getLayoutParams();
					params.width=dip2px(20);
					params.height=dip2px(20);
					params.gravity=Gravity.CENTER;
					params.leftMargin=0;
					tvw.setLayoutParams(params);
					if(bgResId==null||bgResId.length<=0) {
						tvw.setBackgroundResource(R.drawable.unreadnumbtn1);
					}else{
						int res=bgResId[0];
					    tvw.setBackgroundResource(res);
					}
					tvw.setVisibility(View.VISIBLE);
					tvw.setText(mess);
					
					tvw.setTextSize(TypedValue.COMPLEX_UNIT_SP, 12);
					tvw.setTextColor(Color.WHITE);
				} else{
					tvw.setBackgroundDrawable(null);
					tvw.setVisibility(View.GONE);
//					tvw.setText(mess);
				}
				invalidate();
			}
		}
	}
	
	/**
	 * 
	 * @Title: setMessageVisible   
	 * @Description: TODO  滑动TAB的提示点
	 * @param:  position 
	 * @param:  visible true显示，false隐藏     
	 */
	public void setMessageVisible(int position,boolean  visible){
		SparseArray<LinearLayout> pagerLinearLayout = getTabView();
		LinearLayout linear = null;
		if ((linear = pagerLinearLayout.get(position)) != null) {
			TextView tvw = (TextView) linear.getChildAt(1);
			if(tvw!=null){
			if(tvw.getVisibility()==View.GONE&&!visible)return;
				if(visible){
					LinearLayout.LayoutParams params=new LinearLayout.LayoutParams(dip2px(8), dip2px(8));
					params.leftMargin=5;
					params.gravity=Gravity.CENTER;
					tvw.setBackgroundResource(R.drawable.rec);
					tvw.setText("");
					tvw.setLayoutParams(params);
					tvw.setVisibility(View.VISIBLE);
				}else{
					tvw.setBackgroundDrawable(null);
					tvw.setVisibility(View.GONE);
				}
				invalidate();
			}
		}
	}
	
	/**
	 * 得到当前选中“项”的位置
	 * @return
	 */
	public int getCurrentPosition(){
		return currentPosition;
	}
	
	/**
	 * 
	 * @Title: getTabsContainer   
	 * @Description: TODO(返回Tab内的布局)  
	 * @param: @return      
	 * @return: LinearLayout     
	 */
	public LinearLayout getTabsContainer(){
		return tabsContainer;
	}
	
}
