/**
 * 项目名称：
 * 包名：  com.launch.mose.util 
 * 文件名：  CommonUtil.java  
 * 功能：  
 * 2014深圳市元征科技股份有限公司-版权所有
 * NO.    Date                      Author     Summary 
 * 001   2014年10月13日-上午10:42:18   韦子龙 
 *
 */
package com.cnlaunch.golo.tools;

import java.io.File;

import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager.NameNotFoundException;
import android.net.Uri;

/**
 * 
 * 类名称:CommonUtil 
 * 类描述:
 * 创建人: 韦子龙 
 * 修改人:
 * 修改人:  
 * 2014年10月13日 上午10:42:18
 * 修改备注:
 * @version 1.0.0
 * 
 */
public class CommonUtils {
	
	/**
	 * 如果str为null 或者length ==0 或 "null" 返回 ture
	 * @param str
	 * @return 
	 *boolean
	 * @exception 
	 * @since  1.0.0
	 */
	public static boolean isEmpty(String str){
		if (str == null || str.length() == 0 || str.trim().equals("") || str.trim().equalsIgnoreCase("null"))
			return true;
		else
			return false;
	}
	
	public static boolean isInstall(Context context, String packageName){
	     boolean isInstall = false;
	     try {
	    	PackageInfo pi = context.getPackageManager().getPackageInfo(packageName,0);
			if (pi != null) {
				isInstall = true;
			}
	     } catch (NameNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
	     }
	     return isInstall;
	}
	
	/**
	 * 安装apk
	 * 
	 * @param url
	 */
	public static void installApk(Context context, String filePath) {
		File apkfile = new File(filePath);
		if (!apkfile.exists()) {
			return;
		}
		Intent i = new Intent(Intent.ACTION_VIEW);
		i.setDataAndType(Uri.parse("file://" + apkfile.toString()),
				"application/vnd.android.package-archive");
		i.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		context.startActivity(i);
	}
	
	/**
	 * 安装apk 
	 * @param url
	 */
	public static void installApk(Context context, File apkFile) {
		
		if (!apkFile.exists()) {
			return;
		}
		Intent i = new Intent(Intent.ACTION_VIEW);
		i.setDataAndType(Uri.parse("file://" + apkFile.toString()),
				"application/vnd.android.package-archive");
		i.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		context.startActivity(i);
	}
	
	/**
	 * 安装apk 
	 * @param url
	 */
	public static void installApks(Context context, File apkFile) {
		
		if (!apkFile.exists()) {
			return;
		}
		Intent i = new Intent(Intent.ACTION_VIEW);
		i.setDataAndType(Uri.parse("file://" + apkFile.toString()),
				"application/vnd.android.package-archive");
		context.startActivity(i);
	}
	
	/**
	 * 
	 * @Title: compareVersion   
	 * @Description: TODO(判断诊断当前版本是否小于5.0.0)  
	 * @param: @param mContext          
	 * @param: @param packageName      //包名
	 * @param: @return       true:必须升级
	 * @return: boolean      false:不用升级
	 * @throws
	 */
	public static boolean compareVersion(Context mContext, String packageName) {
		try{
			String versionNo = mContext.getPackageManager().getPackageInfo(packageName, 0).versionName;
			String[] arrClientVersion = versionNo.split("\\.");
			if(arrClientVersion.length>0){
				if(Integer.valueOf(arrClientVersion[0])<=4){
					return true;
				}
			}
			return false;
		} catch(Exception e){
			e.printStackTrace();
			return false;
		}
	}

}
