/**
 * 项目名称：
 * 包名：  com.cnlaunch.golo.wifisettings 
 * 文件名：  CarMonitoringActivity.java  
 * 功能：  
 * 2015深圳市元征科技股份有限公司-版权所有
 * NO.    Date                      Author     Summary 
 * 001   2015年4月10日-上午10:40:06   韦子龙 
 *
 */
package com.cnlaunch.golo.wifisettings;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.cnlaunch.golo.adapter.CarMonitoringAdapter;
import com.cnlaunch.golo.carmonitor.CarMonitorBean;
import com.cnlaunch.golo.carmonitor.CarMonitorCallBack;
import com.cnlaunch.golo.carmonitor.CarMonitoringTask;
import com.cnlaunch.golo.message.CmdCode;
import com.cnlaunch.golo.utils.StateCode;
import com.cnlaunch.golo.wifisettings2.R;

/**
 * 
 * 类名称:CarMonitoringActivity 
 * 类描述:
 * 创建人: 韦子龙 
 * 修改人:
 * 修改人:  
 * 2015年4月10日 上午10:40:06
 * 修改备注:
 * @version 1.0.0
 * 
 */
public class CarMonitoringActivity extends Activity implements View.OnClickListener, CarMonitorCallBack{

	private static final String TAG = "MainActivity";
	private String test_serial_no ="967790031851"; //golo接头序列号测试用
	//private EditText sn_editview;//golo盒子序列号输入框
	private CarMonitoringTask carMonitoringTask;//golo盒子wifi设置管理类
	private TextView resultTextView;
	private ListView lvCarMOnitor;
	CarMonitoringAdapter adapter=null;
	CarMonitorBean myResult;
	ProgressDialog proDialog = null;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.carmonitoring);
		
		//获取传递过来的接头序列号
		Intent intent=getIntent();
		test_serial_no=intent.getStringExtra("serial_no");

		lvCarMOnitor=(ListView) findViewById(R.id.lv);
		Button btn0 = (Button) findViewById(R.id.btn_0);//车辆监控
		Button btn6 = (Button) findViewById(R.id.btn_6);//返回
		//设置button监听器
		btn0.setOnClickListener(this);

		btn6.setOnClickListener(this);
		//构造golo盒子wifi设置对象 参数为实现了处理wifi连接状态及连接成功后返回结果SettingsCallBack接口对象
		carMonitoringTask = new CarMonitoringTask(this);
		myResult=new CarMonitorBean();
		if(adapter==null)
		{
			Log.e("hui","进来");
			adapter=new CarMonitoringAdapter(this, myResult);
			lvCarMOnitor.setAdapter(adapter);
		}
		

	}

	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
	}

	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();

	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
		//关闭局域网通信及释放内存
		if (carMonitoringTask != null) {
			carMonitoringTask.destroy();
		}
	}
	/**
	 * 鏄剧ず杩炴帴鎺ュごwifi瀵硅?妗?
	 *void
	 * @exception
	 * @since  1.0.0
	 */
	private void showConnectgoloDialog(){
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setTitle("golo盒子");
		builder.setMessage("请连接golo盒子的wifi");
		builder.setPositiveButton("确定", new OnClickListener() {

			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub
				Intent intent = new Intent(
						android.provider.Settings.ACTION_WIFI_SETTINGS);
				CarMonitoringActivity.this.startActivity(intent);

			}
		});
		builder.setNegativeButton("取消", new OnClickListener() {

			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub

			}
		});
		builder.create();
		builder.show();
	}

	/**
	 * 显示连接golo盒子wifi对话框
	 *void
	 * @exception 
	 * @since  1.0.0
	 */
	private void showProDialog(){
		if (proDialog != null && proDialog.isShowing()) {
			proDialog.dismiss();
		}
		proDialog = new ProgressDialog(this);
		proDialog.setMessage("正在玩命连接...");
		proDialog.show();
	}

	private void disProDialog(){
		if (proDialog != null && proDialog.isShowing()) {
			proDialog.dismiss();
		}
	}
	@Override
	public void onClick(View v) {

		switch (v.getId()) {
		case R.id.btn_0://查询WiFI密码
//			显示正在连接对话框
			showProDialog();
			carMonitoringTask.queryWiFiPassword(test_serial_no);
			break;
		case R.id.btn_6://返回
			finish();
			break;
		default:
			break;
		}
		
//		finish();
		
	}


	@Override
	public void onConnectStatus(int statusCode, String msg) {
		// TODO Auto-generated method stub
		
		if (statusCode == StateCode.SOCKET_CONNECT_FIAL) {//连接golo盒子失败，请连接golo盒子wifi
			disProDialog();
			showConnectgoloDialog();
		}
		if( statusCode == StateCode.SOCKET_READ_DATA_FIAL){
			disProDialog();
			Toast.makeText(this, "盒子wifi连接错误，请确认连接了正确的盒子！！", Toast.LENGTH_LONG);
		}
	}

	/**
	 * wifi连接成功后回调的结果
	 */
	@Override
	public void onSuccess(CarMonitorBean result) {
		// TODO Auto-generated method stub
		disProDialog();
		setResult(result);

		adapter.notifyDataSetChanged();
		if (result != null ) {
			switch (result.getCmdCode()) {
			case CmdCode.CMD_QUERY_WIFI_PASSWORD:////查询WiFI密码
				if (result.getErrorCode() == StateCode.GOLOWIFI_QUERY_SUCC) {
					carMonitoringTask.startCarMonitoring();
				}else if (result.getErrorCode() == StateCode.GOLOWIFI_SERIAL_NO_ERROR) {
					//该接头不支持此功能
					Toast.makeText(this, "该接头不支持此功能", Toast.LENGTH_SHORT).show();
				}else if(result.getErrorCode() == StateCode.GOLOWIFI_SERIALNUM_IS_WRONG){
					Toast.makeText(this, "接头序列号与传入的序列号不一致", Toast.LENGTH_SHORT).show();
					showConnectgoloDialog();
				}
				break;
			case CmdCode.CMD_CAR_REAL_MONITORING:///实时监控

				break;
			default:
				break;
			}


		}
	}
	

	public void setResult(CarMonitorBean result){
		myResult.setAbs(result.getAbs());
		myResult.setAccelerator(result.getAccelerator());
		myResult.setAddmileage(result.getAddmileage());
		myResult.setAircondition(result.getAircondition());
		myResult.setAirflow(result.getAirflow());
		myResult.setAirinflowtemp(result.getAirinflowtemp());
		myResult.setBackdoor(result.getBackdoor());
		myResult.setBrakelamp(result.getBrakelamp());
		myResult.setCarlock(result.getCarlock());
		myResult.setCarspeed(result.getCarspeed());
		myResult.setCmdCode(result.getCmdCode());
		myResult.setConnectorVoltage(result.getConnectorVoltage());
		myResult.setDelaytime(result.getDelaytime());
		myResult.setDippedheadlamp(result.getDippedheadlamp());
		myResult.setEcm(result.getEcm());
		myResult.setEnginespeed(result.getEnginespeed());
		myResult.setErrorCode(result.getErrorCode());
		myResult.setFoglamp(result.getFoglamp());
		myResult.setGears(result.getGears());
		myResult.setHazardlamp(result.getHazardlamp());
		myResult.setHighbeamlamp(result.getHighbeamlamp());
		myResult.setLeftbackdoor(result.getLeftbackdoor());
		myResult.setLeftfrontdoor(result.getLeftfrontdoor());
		myResult.setMacceleratorfootboarddepth(result.getMacceleratorfootboarddepth());
		myResult.setMileageid(result.getMileageid());
		myResult.setMofflinecurtime(result.getMofflinecurtime());
		myResult.setOdometer(result.getOdometer());
		myResult.setOilaverage(result.getOilaverage());
		myResult.setOilinstantaneous(result.getOilinstantaneous());
		myResult.setOilpercent(result.getOilpercent());
		myResult.setParking(result.getParking());
		myResult.setRemaimileage(result.getRemaimileage());
		myResult.setRemainoil(result.getRemainoil());
		myResult.setRightbackdoor(result.getRightbackdoor());
		myResult.setRightfrontdoor(result.getRightfrontdoor());
		myResult.setSeatbelt(result.getSeatbelt());
		myResult.setSidelamp(result.getSidelamp());
		myResult.setSrs(result.getSrs());
		myResult.setTurnleftlamp(result.getTurnleftlamp());
		myResult.setTurnrightlamp(result.getTurnrightlamp());
		myResult.setVoltage(result.getVoltage());
		myResult.setWatertemp(result.getWatertemp());
		myResult.setWindscreenwiper(result.getWindscreenwiper());

	}
}
