/**
 * 项目名称：
 * 包名：  com.cnlaunch.golo.wifisettings 
 * 文件名：  WiFiSettingsActivity.java  
 * 功能：  
 * 2015深圳市元征科技股份有限公司-版权所有
 * NO.    Date                      Author     Summary 
 * 001   2015年2月10日-下午3:09:17   韦子龙 
 *
 */
package com.cnlaunch.golo.wifisettings;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import com.cnlaunch.golo.inspection.QueryAndModifyWifiActivity;
import com.cnlaunch.golo.inspection.QueryAndModifyWifiSleepTimeActivity;
import com.cnlaunch.golo.message.CmdCode;
import com.cnlaunch.golo.settings.SettingsCallBack;
import com.cnlaunch.golo.settings.goloWiFiBean;
import com.cnlaunch.golo.settings.goloWifiSettings;
import com.cnlaunch.golo.utils.StateCode;
import com.cnlaunch.golo.wifisettings2.R;

/**
 * 
 * 类名称:WiFiSettingsActivity 
 * 类描述:golo盒子wifi设置测试用例页面
 * 设置golo盒子wifi属于局域网通信，所以在设置前必须先连接golo盒子的wifi
 * 	使用方法：
 * 	1、构造goloWifiSettings对象 ，参数：设置回调接口（回调连接golo盒子wifi状态及读取数据异常情况、及连接成功回调结果），该类提供设置golo盒子wifi相关方法如查询wifi密码名称等  
 *  2、SettingsCallBack回调接口
 *  	a.在onConnectStatus方法中处理wifi连接状态及读取数据异常问题
 *  	b.在onSuccess方法处理设置的结果
 *  3、在Activity onDestroy 调用wifiSettings.destroy();关闭局域网通信，释放内存
 *  
 * 创建人: 韦子龙 
 * 修改人:
 * 修改人:
 * 2015年2月10日 下午3:09:17
 * 修改备注:
 * @version 1.0.0
 * 
 */
public class WiFiSettingsActivity extends Activity implements View.OnClickListener, SettingsCallBack{

	private String test_serial_no ="967790031851";//golo接头序列号测试用
	private goloWifiSettings wifiSettings;//golo盒子wifi设置管理类
	private TextView resultTextView;
	ProgressDialog proDialog = null;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.wifi_settings);

		//获取传递过来的接头序列号
		Intent intent=getIntent();
		test_serial_no=intent.getStringExtra("serial_no");
		//resultTextView = (TextView) findViewById(R.id.text);

		Button btn1 = (Button) findViewById(R.id.btn_1);//查询、修改WiFI密码和名称
		Button btn2= (Button) findViewById(R.id.btn_2);//设置WiFi为开放模式
		Button btn3 = (Button) findViewById(R.id.btn_3);//查询、修改WiFI睡眠时间
		Button btn4 = (Button) findViewById(R.id.btn_4);//返回
		//设置button监听器
		btn1.setOnClickListener(this);
		btn2.setOnClickListener(this);
		btn3.setOnClickListener(this);
		btn4.setOnClickListener(this);
		
	}

	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		//构造golo盒子wifi设置对象 参数为实现了处理wifi连接状态及连接成功后返回结果SettingsCallBack接口对象
		wifiSettings = new goloWifiSettings(this);

	}

	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();

	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
		//关闭局域网通信及释放内存
		if (wifiSettings != null) {
			wifiSettings.destroy();
		}
	}
	/**
	 * 鏄剧ず杩炴帴鎺ュごwifi瀵硅?妗?
	 *void
	 * @exception 
	 * @since  1.0.0
	 */
	private void showConnectgoloDialog(){
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setTitle("golo盒子");
		builder.setMessage("请连接golo盒子的wifi");
		builder.setPositiveButton("确定", new OnClickListener() {

			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub
				Intent intent = new Intent(
						android.provider.Settings.ACTION_WIFI_SETTINGS);
				WiFiSettingsActivity.this.startActivity(intent);

			}
		});
		builder.setNegativeButton("取消", new OnClickListener() {

			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub

			}
		});
		builder.create();
		builder.show();
	}

	/**
	 * 显示连接golo盒子wifi对话框
	 *void
	 * @exception 
	 * @since  1.0.0
	 */
	private void showProDialog(){
		if (proDialog != null && proDialog.isShowing()) {
			proDialog.dismiss();
		}
		proDialog = new ProgressDialog(this);
		proDialog.setMessage("正在玩命连接...");
		proDialog.show();
	}

	private void disProDialog(){
		if (proDialog != null && proDialog.isShowing()) {
			proDialog.dismiss();
		}
	}
	private long lasttime;
	private long curtime;
	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		lasttime=System.currentTimeMillis();
		Intent intent=null;
		switch (v.getId()) {

		case R.id.btn_1://查询和修改WiFi名称和密码
			//显示正在连接对话框
			showProDialog();
			intent = new Intent(this,QueryAndModifyWifiActivity.class);
			intent.putExtra("test_serial_no", test_serial_no);
			this.startActivity(intent);
			disProDialog();
			break;

		case R.id.btn_2:// 设置WiFi为开放模式
			wifiSettings.setWiFiOpenModel(test_serial_no);
			break;

		case R.id.btn_3://查询和修改WiFi休眠时间 
			//显示正在连接对话框
			showProDialog();
			intent = new Intent(this,QueryAndModifyWifiSleepTimeActivity.class);
			intent.putExtra("test_serial_no", test_serial_no);
			this.startActivity(intent);
			disProDialog();
			break;
		case R.id.btn_4://返回
			finish();
			break;
		default:
			break;
		}
	}

	/**
	 * wifi连接成功后回调的结果
	 */
	@Override
	public void onSuccess(goloWiFiBean result) {
		// TODO Auto-generated method stub
		disProDialog();
		if (result != null ) {
			String cmd = "";
			switch (result.getCmdCode()) {
			case CmdCode.CMD_OPEN_WIFI://设置WiFi为开放模式	
				cmd = "设置WiFi为开放模式";
				if(result.getErrorCode()==StateCode.GOLOWIFI_SETTING_SUCC){
					Toast.makeText(this,"设置WiFi为开放模式成功", Toast.LENGTH_SHORT).show();
				}else{
					Toast.makeText(this,"设置WiFi为开放模式失败", Toast.LENGTH_SHORT).show();
				}
				break;
			case CmdCode.CMD_SERIALNUM_IS_WRONG://传入的序列号和接头序列号不一致
				cmd = "传入的序列号和接头序列号不一致";
				Toast.makeText(this,"传入的序列号和接头序列号不一致", Toast.LENGTH_SHORT).show();
				break;
			default:
				break;
			}
			String errorState = (result.getErrorCode()==StateCode.GOLOWIFI_SETTING_SUCC || result.getErrorCode()==StateCode.GOLOWIFI_QUERY_SUCC) ? "成功":"失败";
		}
	}

	@Override
	public void onConnectStatus(int statusCode, String msg) {
		// TODO Auto-generated method stub
		disProDialog();
		if (statusCode == StateCode.SOCKET_CONNECT_FIAL) {//连接golo盒子失败，请连接golo盒子wifi
			showConnectgoloDialog();
		}
		System.out.println(".............网络连接状态：statusCode="+statusCode+"...."+msg);
	}

}
